'Ŀ
' DrawR v0.21                                                    1999/2000 
' Made by Bjorn Lindeijer                        (c) Moonlight Productions 
'

' ---------- The Advanced Font Routines -------------------------------------
DECLARE FUNCTION FLenght% (zin$)
DECLARE SUB FWindow (Xmin%, Ymin%, Xmax%, Ymax%)
DECLARE SUB FLocate (x%, y%)
DECLARE SUB FInit ()
DECLARE SUB FSize (Size%)
DECLARE SUB FColor (Clr%)
DECLARE SUB FRotate (Degrees%)
DECLARE SUB FPrint (zin$)
DECLARE SUB FWrite (zin$, x%, y%, Clr%)
DIM SHARED Letter(32 TO 122) AS STRING
DIM SHARED Lengte(32 TO 122) AS STRING * 1
DIM SHARED Lib.Xco AS INTEGER, Lib.Yco AS INTEGER
DIM SHARED FClr AS STRING, FSze AS STRING
DIM SHARED FAngle AS STRING
' ---------------------------------------------------------------------------
DECLARE SUB Cells.Copy (Nr%)        ' Subs die te maken hebben met de cellen
DECLARE SUB Cells.Paste (Nr%)
DECLARE SUB Cells.Save ()
DECLARE SUB BottomMessage (thing$, Nr%)
'ON ERROR GOTO UnforseenError

DECLARE FUNCTION MessageBox% (zin$, type$)
DECLARE SUB Prepair ()              ' Programma voorbereidingen
DECLARE SUB Set.Variables ()
DECLARE SUB Buildscreen ()          ' Eerste scherm opbouw
DECLARE SUB Check.Command ()
DECLARE SUB File.Open ()
DECLARE SUB Window.Open (type$, Filename$)
DECLARE SUB Window.Draw (Nr%)
DECLARE SUB Window.Close (Nr%)
DECLARE SUB Window.Drag (Nr%)
DECLARE SUB Update.ActFace (Nr%)
DECLARE SUB Magnify (Xc%, Yc%, Nr%) ' Vergroot een gedeelte van de tekening
DECLARE SUB Chance.Color (Col%)
DECLARE SUB Set.Mode ()
DECLARE SUB Info.Picture ()
DECLARE SUB Info.PW ()
DECLARE SUB Info.VG (Nr%)
DECLARE SUB Muis.Mengen ()
DECLARE SUB Muis.ColorChance ()     ' Subs die worden geactiveerd door de muis
DECLARE SUB Muis.ColorSelect ()
DECLARE SUB Muis.Paint (Nr%)
DECLARE SUB Muis.GetColor (Nr%)
DECLARE SUB CHR.Load (Nr%)
DECLARE SUB CHR.Save (Nr%)
DECLARE SUB PIC.Load (File$, PicX%, PicY%) ' Sub voor het laden van PIC bestanden
DECLARE SUB PIC.Save (File$)
DECLARE SUB PIC.New (Xl%, Yl%, PicX%, PicY%)
DECLARE SUB Palet.Load ()
DECLARE SUB Palet.Save ()
DECLARE SUB Palet.Update ()
DECLARE SUB HidePointer             ' Library subs voor de muis
DECLARE SUB ShowPointer
DECLARE SUB QuitProg ()             ' Sub voor een juiste afsluiting
DECLARE SUB ProgramError (D%)       ' Sub om fouten af te handelen

CONST Version = "0.21"
CONST WindowCount = 2
CONST LivObCount = 2

TYPE WindowType
  Active AS INTEGER: Height AS INTEGER
  Xmin AS INTEGER: Ymin AS INTEGER
  Xmax AS INTEGER: Ymax AS INTEGER
  Id AS INTEGER                     ' 0 = leeg  1 = LivOb
END TYPE
TYPE LivObWindow
  Filename AS STRING * 32
  LOXmin AS INTEGER: LOYmin AS INTEGER
  LOHSpace AS INTEGER: LOVSpace AS INTEGER
  VGXmin AS INTEGER: VGYmin AS INTEGER: VGSize AS INTEGER
  VGXmax AS INTEGER: VGYmax AS INTEGER
  VGX    AS INTEGER: VGY AS INTEGER
  ActFace AS INTEGER: Changed AS INTEGER
END TYPE
DIM SHARED LivOb(LivObCount) AS LivObWindow
DIM SHARED WindowNr(WindowCount) AS WindowType

DIM SHARED MP.Xmin AS INTEGER, MP.Xmax AS INTEGER, MP.Space AS INTEGER ' (MP)
DIM SHARED MP.Y1   AS INTEGER, MP.Y2   AS INTEGER, MP.Y3 AS INTEGER
DIM SHARED PW.Xmin AS INTEGER, PW.Ymin AS INTEGER                      ' (PW)
DIM SHARED PW.Xmax AS INTEGER, PW.Ymax AS INTEGER
DIM SHARED PW.From AS INTEGER, PW.To AS INTEGER
DIM SHARED OB.Xmin AS INTEGER, OB.Ymin AS INTEGER                      ' (OB)

DIM SHARED MemCell(65) AS INTEGER          ' Plak/Kopieer cell
DIM SHARED MClr(255, 2) AS STRING * 1      ' Kleur waarden in variabele
DIM SHARED Figuur(16, 3, 1, 1, LivObCount) ' Figuur dat je tekent
DIM SHARED MPunt(7, 15) AS INTEGER  ' Stukje vergrote tekening
DIM SHARED mx%, my%, but%
DIM SHARED Info$                    ' Welke info weergave bovenin
DIM SHARED Inf AS INTEGER           ' 1 als Info, 0 als geen Info
DIM SHARED IKleur AS INTEGER        ' Info-variabelen:
DIM SHARED Ipx AS INTEGER, Ipy AS INTEGER, Ipc AS INTEGER
DIM SHARED IMgx AS INTEGER, IMgy AS INTEGER
DIM SHARED Ix AS INTEGER, Iy AS INTEGER, Ic AS INTEGER
DIM SHARED x AS INTEGER, y AS INTEGER, z AS INTEGER, i AS INTEGER
DIM SHARED Sc AS INTEGER: Sc = 32   ' Geselecteerde kleur
DIM SHARED PICmem(24000) AS INTEGER ' Hierin wordt een plaatje geladen
DIM SHARED PicX AS INTEGER, PicY AS INTEGER

Prepair
ShowPointer
Check.Command

DO
  Inf = 0
  a$ = INKEY$
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2


  ' Uitrekenen welke window geslecteerd is...
  w% = -1: sw% = -1: WindowHeight% = 99
  FOR i = 0 TO WindowCount
    IF mx% >= WindowNr(i).Xmin AND my% >= WindowNr(i).Ymin AND mx% <= WindowNr(i).Xmax AND my% <= WindowNr(i).Ymax AND WindowNr(i).Height < WindowHeight% AND WindowNr(i).Active = 1 THEN w% = i: WindowHeight% = WindowNr(i).Height
    IF WindowNr(i).Active = 1 AND WindowNr(i).Height = 1 THEN sw% = i
  NEXT i
  'LOCATE 19, 1: PRINT w%; WindowHeight%
 
 
  ' Informatie weergave rechtsbovenin
  'IF mx% >= PicX AND mx% < PicX + PICmem(0) / 8 AND my% >= PicY AND my% < PicY + PICmem(1) THEN Info.Picture
  IF mx% >= PW.Xmin AND my% >= PW.Ymin AND mx% <= PW.Xmax AND my% <= PW.Ymax THEN Info.PW

 
  ' Muis afhandeling
  IF but% = 1 THEN
    IF Sc > 31 AND mx% > MP.Xmin - 2 AND mx% <= MP.Xmin + 64 AND my% >= MP.Y1 - 3 AND my% < MP.Y3 THEN Muis.Mengen
    IF mx% >= PW.Xmin AND my% >= PW.Ymin AND mx% <= PW.Xmax AND my% <= PW.Ymax THEN Muis.ColorSelect
    IF Sc > 0 AND mx% >= PW.Xmin - 5 AND my% >= PW.Ymin + 35 AND mx% <= PW.Xmin - 2 AND my% <= PW.Ymax THEN Sc = 0: Chance.Color (Sc)
  END IF
  IF but% = 2 THEN
    IF mx% >= PW.Xmin AND my% >= PW.Ymin AND mx% < PW.Xmax AND my% < PW.Ymax THEN Muis.ColorSelect
  END IF

 
  ' Toetsen afhandeling
  IF a$ <> "" THEN
    IF a$ = CHR$(27) THEN BottomMessage "Exit", sw%
    IF LCASE$(a$) = "l" THEN File.Open
    IF LCASE$(a$) = "s" THEN BottomMessage "Save", sw%
    IF LCASE$(a$) = "h" THEN BottomMessage "Help", sw%
  END IF


  ' Window afhankelijke toetsen
  IF sw% > -1 THEN
    SELECT CASE WindowNr(sw%).Id
      CASE 1
        IF mx% >= LivOb(sw%).VGXmin AND my% >= LivOb(sw%).VGYmin AND mx% <= LivOb(sw%).VGXmax AND my% <= LivOb(sw%).VGYmax THEN Info.VG sw%
        IF but% = 1 THEN
          IF mx% >= LivOb(sw%).VGXmin AND my% >= LivOb(sw%).VGYmin AND mx% <= LivOb(sw%).VGXmax AND my% <= LivOb(sw%).VGYmax THEN Muis.Paint sw%
          IF mx% > WindowNr(sw%).Xmax - 7 AND my% > WindowNr(sw%).Ymin + 1 AND mx% < WindowNr(sw%).Xmax - 1 AND my% < WindowNr(sw%).Ymin + 7 THEN Window.Close sw%
          IF mx% >= WindowNr(sw%).Xmin AND my% >= WindowNr(sw%).Ymin AND mx% <= WindowNr(sw%).Xmax - 7 AND my% <= WindowNr(sw%).Ymin + 7 THEN Window.Drag sw%
        END IF
        IF but% = 2 THEN
          IF mx% >= LivOb(sw%).VGXmin AND my% >= LivOb(sw%).VGYmin AND mx% <= LivOb(sw%).VGXmax AND my% <= LivOb(sw%).VGYmax THEN Muis.GetColor sw%
        END IF
        IF a$ <> "" THEN
            IF a$ = CHR$(0) + CHR$(75) AND LivOb(sw%).ActFace > 0 THEN LivOb(sw%).ActFace = LivOb(sw%).ActFace - 1: Update.ActFace sw% ' Links
            IF a$ = CHR$(0) + CHR$(77) AND LivOb(sw%).ActFace < 3 THEN LivOb(sw%).ActFace = LivOb(sw%).ActFace + 1: Update.ActFace sw% ' Rechts
            IF LCASE$(a$) = "c" THEN Cells.Copy sw%
            IF LCASE$(a$) = "p" THEN Cells.Paste sw%
        END IF
    END SELECT
  END IF
  IF w% > -1 THEN
    IF but% = 1 AND WindowNr(w%).Height > 1 THEN
      FOR i = 0 TO WindowCount
        IF WindowNr(i).Height < WindowNr(w%).Height THEN
          WindowNr(i).Height = WindowNr(i).Height + 1
          IF WindowNr(i).Height = 2 AND WindowNr(i).Active = 1 THEN
            Window.Draw i
          END IF
        END IF
      NEXT i
      WindowNr(w%).Height = 1
      Window.Draw w%
    END IF
  END IF

  IF Inf = 0 AND Info$ <> "Geen" THEN
    IF my% < 7 THEN HidePointer
    LINE (200, 1)-(319, 5), 2, BF: Info$ = "Geen"
    IF my% < 7 THEN ShowPointer
  END IF
     
LOOP

UnforseenError:
ProgramError 0

SUB BottomMessage (thing$, Nr%)

DIM Ondervak(3521)
HidePointer
GET (0, 156)-(319, 199), Ondervak   ' Dit vak wordt straks weer teruggezet
LINE (0, 157)-(319, 199), 2, BF

SELECT CASE thing$

  CASE "Exit"
    FColor 4
    FLocate 5, 166: FPrint "REALLY EXIT? PRESS..."
    FLocate 5, 174: FPrint "Y TO EXIT THIS PROGRAM, UNSAVED CHANGES WILL BE LOST"
    FLocate 5, 180: FPrint "N TO GO BACK AND ENJOY THIS PROGRAM EVEN MORE"
    FLocate 5, 188: FPrint "ESC TO CANCEL"
    ShowPointer
    DO
      a$ = INKEY$
      IF LCASE$(a$) = "y" THEN QuitProg
      IF LCASE$(a$) = "n" THEN EXIT DO
      IF a$ = CHR$(27) THEN EXIT DO
    LOOP

  CASE "Save"
    FColor 4
    FLocate 5, 166: FPrint "PRESS..."
    FLocate 5, 174
    SELECT CASE WindowNr(Nr%).Id
      CASE 1: FPrint "L TO SAVE THE LIVING OBJECT"
    END SELECT
    FLocate 5, 180: FPrint "P TO SAVE PALET"
    FLocate 5, 188: FPrint "ESC TO CANCEL"
    ShowPointer
    DO
      a$ = INKEY$
      SELECT CASE WindowNr(Nr%).Id
      CASE 1
          IF LCASE$(a$) = "l" THEN
          CHR.Save Nr%
          EXIT DO
        END IF
      END SELECT
      IF LCASE$(a$) = "p" THEN IF LCASE$(a$) = "p" THEN Palet.Save: EXIT DO
      IF a$ = CHR$(27) THEN EXIT DO
    LOOP

  CASE "Load"

  CASE "Help"
    FColor 1
    FLocate 3, 167: FPrint "HELP:"
    FColor 4
    FLocate 3, 166: FPrint "HELP:"
    FColor 3: FLocate 3, 174: FPrint "LIVING OBJECT WINDOW:": FColor 4
    FLocate 3, 180: FPrint "USE < AND > TO SELECT THE DIRECTION"
    FLocate 3, 186: FPrint "DRAW IN THE MAGNIFYCATION"
    FLocate 3, 192: FPrint "ESC - EXIT THIS PROGRAM"
    FColor 3: FLocate 150, 174: FPrint "PROGRAM KEYS:": FColor 4
    FLocate 150, 180: FPrint "L - LOAD A FILE"
    FLocate 150, 186: FPrint "S - SAVE THE ACTIVE FILE OR THE PALET"
    FLocate 150, 192: FPrint "H - THIS HELP WINDOW"
    ShowPointer
    DO: LOOP WHILE INKEY$ = ""

END SELECT

HidePointer
PUT (0, 156), Ondervak, PSET
ShowPointer
  
END SUB

SUB Buildscreen

Set.Variables

LINE (0, 7)-(319, 7), 3              ' Bovenbalk
LINE (0, 0)-(319, 6), 2, BF
FLocate 2, 5: FColor 0: FPrint "DRAWR  v" + Version
FLocate 1, 5: FColor 4: FPrint "DRAWR  v" + Version
LINE (0, 156)-(319, 156), 3          ' Onderbalk
LINE (0, 157)-(319, 199), 2, BF

' Palette Hokjes
LINE (PW.Xmin - 1, PW.Ymin - 1)-(PW.Xmax + 1, PW.Ymax + 1), 1, BF
FOR x = PW.From TO PW.To
  FOR y = 0 TO 7
    LINE (PW.Xmin + 5 * (x - PW.From), PW.Ymin + 5 * y)-(PW.Xmin + 3 + 5 * (x - PW.From), PW.Ymin + 3 + 5 * y), 8 * x + y, BF
    IF 8 * x + y < 16 THEN LINE (160 + 5 * x, 160 + 5 * y)-(163 + 5 * x, 163 + 5 * y), 0
  NEXT y
NEXT x
LINE (PW.Xmin - 6, PW.Ymin + 34)-(PW.Xmin - 1, PW.Ymax + 1), 1, B
LINE (PW.Xmin - 5, PW.Ymin + 35)-(PW.Xmin - 2, PW.Ymax), 0, BF
LINE (PW.Xmin - 5, PW.Ymin + 35)-(PW.Xmin - 2, PW.Ymax), 1
LINE (PW.Xmin - 5, PW.Ymax)-(PW.Xmin - 2, PW.Ymin + 35), 1

' Mengpaneeltje
LINE (MP.Xmin - 1, MP.Y1)-(MP.Xmin + 64, MP.Y1), 5
LINE (MP.Xmin - 1, MP.Y2)-(MP.Xmin + 64, MP.Y2), 6
LINE (MP.Xmin - 1, MP.Y3)-(MP.Xmin + 64, MP.Y3), 7
LINE (MP.Xmin - 1, MP.Y1 + 1)-(MP.Xmin + 64, MP.Y1 + 1), 1, BF
LINE (MP.Xmin - 1, MP.Y2 + 1)-(MP.Xmin + 64, MP.Y2 + 1), 1, BF
LINE (MP.Xmin - 1, MP.Y3 + 1)-(MP.Xmin + 64, MP.Y3 + 1), 1, BF
Chance.Color Sc

END SUB

SUB Cells.Copy (Nr%)
                              
HidePointer
GET (LivOb(Nr%).LOXmin + 1 + LivOb(Nr%).LOHSpace * LivOb(Nr%).ActFace, LivOb(Nr%).LOYmin + 1)-(LivOb(Nr%).LOXmin + 8 + LivOb(Nr%).LOHSpace * LivOb(Nr%).ActFace, LivOb(Nr%).LOYmin + 16), MemCell
ShowPointer
'                       Geselecteerde held gaat in variabele MemCell
END SUB

SUB Cells.Paste (Nr%)

HidePointer
PUT (LivOb(Nr%).LOXmin + 1 + LivOb(Nr%).LOHSpace * LivOb(Nr%).ActFace, LivOb(Nr%).LOYmin + 1), MemCell, PSET
Update.ActFace Nr%
IF WindowNr(Nr%).Id = 1 THEN
  FOR x = 0 TO 7
    FOR y = 0 TO 15
      Clr% = POINT(IMgx + x, IMgy + y)
      IF Clr% = 0 THEN
        PSET (IMgx + x, IMgy + y + LivOb(Nr%).LOVSpace), 255
        ELSE PSET (IMgx + x, IMgy + y + LivOb(Nr%).LOVSpace), 0
      END IF
    NEXT y
  NEXT x
END IF
ShowPointer
'                       Geselecteerde cell wordt cell in variabele MemCell
END SUB

SUB Cells.Save

'DEF SEG = VARSEG(Cell(0, 0))        ' Vanuit geheugen direct naar bestand
'BSAVE CellsFile$, VARPTR(Cell(0, 0)), 17408       ' 17 * 4 * 256 = 17408

END SUB

SUB Chance.Color (Col%)

' Nieuwe instellingen van de kleur doorvoeren
  OUT &H3C8, Col%
  OUT &H3C9, ASC(MClr(Col%, 0))
  OUT &H3C9, ASC(MClr(Col%, 1))
  OUT &H3C9, ASC(MClr(Col%, 2))
  OUT &H3C8, Col% + 128
  OUT &H3C9, ASC(MClr(Col%, 0)) / 2 + 2
  OUT &H3C9, ASC(MClr(Col%, 1)) / 2 + 5
  OUT &H3C9, ASC(MClr(Col%, 2)) / 2 + 7
   
' Mengpaneeltje updaten
  HidePointer
   LINE (MP.Xmin + 65, MP.Y1 - 4)-(MP.Xmin + 73, MP.Y1 + 1), 2, BF
   FColor 1: FLocate MP.Xmin + 63, MP.Y1 + 1: FPrint STR$(ASC(MClr(Sc, 0)))
  FColor 5: FLocate MP.Xmin + 63, MP.Y1: FPrint STR$(ASC(MClr(Sc, 0)))
  LINE (MP.Xmin - 1, MP.Y1 - 3)-(MP.Xmin + 64, MP.Y1 - 1), 2, BF
  FColor 4: FLocate MP.Xmin + ASC(MClr(Sc, 0)) - 1, MP.Y1 - 1: FPrint "^"

   LINE (MP.Xmin + 65, MP.Y2 - 4)-(MP.Xmin + 73, MP.Y2 + 1), 2, BF
   FColor 1: FLocate MP.Xmin + 63, MP.Y2 + 1: FPrint STR$(ASC(MClr(Sc, 1)))
  FColor 6: FLocate MP.Xmin + 63, MP.Y2: FPrint STR$(ASC(MClr(Sc, 1)))
  LINE (MP.Xmin - 1, MP.Y2 - 3)-(MP.Xmin + 64, MP.Y2 - 1), 2, BF
  FColor 4: FLocate MP.Xmin + ASC(MClr(Sc, 1)) - 1, MP.Y2 - 1: FPrint "^"

   LINE (MP.Xmin + 65, MP.Y3 - 4)-(MP.Xmin + 73, MP.Y3 + 1), 2, BF
   FColor 1: FLocate MP.Xmin + 63, MP.Y3 + 1: FPrint STR$(ASC(MClr(Sc, 2)))
  FColor 7: FLocate MP.Xmin + 63, MP.Y3: FPrint STR$(ASC(MClr(Sc, 2)))
  LINE (MP.Xmin - 1, MP.Y3 - 3)-(MP.Xmin + 64, MP.Y3 - 1), 2, BF
  FColor 4: FLocate MP.Xmin + ASC(MClr(Sc, 2)) - 1, MP.Y3 - 1: FPrint "^"
  ShowPointer

END SUB

SUB Check.Command

IF COMMAND$ > "" THEN
  ComFile$ = LCASE$(COMMAND$)

  SHELL "DIR DATA\*.* /B /L /ON >DIR.TMP"      ' Bestand-lijst maken
  OPEN "DIR.TMP" FOR INPUT AS #1
  Succes% = 0
  DO UNTIL EOF(1)                              ' Bestanden inlezen
    INPUT #1, File$
    IF ComFile$ = File$ THEN Succes% = 1: EXIT DO
  LOOP
  CLOSE #1
  KILL "DIR.TMP"

  IF Succes% = 1 THEN
    FileExt$ = MID$(ComFile$, INSTR(ComFile$, "."), 4)
    SELECT CASE FileExt$
      CASE ".chr": Window.Open "LivOb", "DATA\" + ComFile$
    END SELECT
  ELSE
    File.Open
  END IF
ELSE
  File.Open
END IF


END SUB

SUB CHR.Load (Nr%)

DEF SEG = VARSEG(Figuur(0, 0, 0, 0, Nr%))
BLOAD LivOb(Nr%).Filename, VARPTR(Figuur(0, 0, 0, 0, Nr%))

END SUB

SUB CHR.Save (Nr%)

HidePointer
FOR x = 0 TO 3
  FOR y = 0 TO 1
    FOR z = 0 TO 1
      GET (LivOb(Nr%).LOXmin + 1 + LivOb(Nr%).LOHSpace * x, LivOb(Nr%).LOYmin + 1 + y * 8 + z * 20)-(LivOb(Nr%).LOXmin + 8 + LivOb(Nr%).LOHSpace * x, LivOb(Nr%).LOYmin + 8 + y * 8 + z * LivOb(Nr%).LOVSpace), Figuur(0, x, y, z, Nr%)
    NEXT z
  NEXT y
NEXT x
ShowPointer

Lenght% = (8 * 8 + 4) * 16

DEF SEG = VARSEG(Figuur(0, 0, 0, 0, Nr%))
BSAVE LivOb(Nr%).Filename, VARPTR(Figuur(0, 0, 0, 0, Nr%)), Lenght%
LivOb(Nr%).Changed = 0

END SUB

SUB FColor (Clr%)

IF Clr% < 0 OR Clr% > 255 THEN ProgramError 2
FClr = "C" + MID$(STR$(Clr%), 2, 3)

END SUB

SUB File.Open

DIM Ondervak(3303)
DIM ListFiles AS INTEGER
DIM SelectedFile AS INTEGER
DIM PrevFile AS INTEGER
DIM FileNr AS INTEGER

' Raampje op scherm zetten
HidePointer
 GET (OB.Xmin, OB.Ymin)-(OB.Xmin + 104 - 1, OB.Ymin + 127 - 1), Ondervak
LINE (OB.Xmin, OB.Ymin)-(OB.Xmin + 104 - 1, OB.Ymin + 127 - 1), 1, B
LINE (OB.Xmin, OB.Ymin)-(OB.Xmin + 104 - 2, OB.Ymin + 127 - 2), 3, B
LINE (OB.Xmin + 1, OB.Ymin + 1)-(OB.Xmin + 104 - 2, OB.Ymin + 127 - 2), 2, BF
LINE (OB.Xmin + 3, OB.Ymin + 3)-(OB.Xmin + 49 + 3, OB.Ymin + 127 - 3), 3, B
LINE (OB.Xmin + 2, OB.Ymin + 2)-(OB.Xmin + 49 + 2, OB.Ymin + 127 - 4), 1, B
LINE (OB.Xmin + 3, OB.Ymin + 3)-(OB.Xmin + 49 + 2, OB.Ymin + 127 - 4), 1, BF
'FColor 3: FLocate OB.Xmin + 57, OB.Ymin + 127 - 4: FPrint "N: NEW FILE"
FColor 2: FLocate OB.Xmin + 4, OB.Ymin + 4 + 4: FPrint "LOADING FILES"
ShowPointer

SHELL "DIR DATA\*.* /B /L /ON >DIR.LST"      ' Bestanden-lijst maken
OPEN "DIR.LST" FOR INPUT AS #1
DO UNTIL EOF(1)                              ' Tellen hoeveel het er zijn
  INPUT #1, File$
  extension$ = MID$(File$, INSTR(File$, "."), 4)
  IF extension$ = ".chr" THEN ListFiles = ListFiles + 1
LOOP
CLOSE #1
DIM ListFile(ListFiles) AS STRING
DIM ListFileExt(ListFiles) AS STRING

OPEN "DIR.LST" FOR INPUT AS #1
FileNr = 0
DO UNTIL EOF(1)
  INPUT #1, ListFile(FileNr)                 ' Bestanden inlezen
  extension$ = MID$(ListFile(FileNr), INSTR(ListFile(FileNr), "."), 4)
  IF extension$ = ".chr" THEN
    ListFileExt(FileNr) = MID$(ListFile(FileNr), INSTR(ListFile(FileNr), "."), 4)
    ListFile(FileNr) = LEFT$(ListFile(FileNr), INSTR(ListFile(FileNr), ".") - 1)
    FileNr = FileNr + 1
  END IF
LOOP
CLOSE #1
KILL "DIR.LST"

' Vakje leeg maken en vullen met de net ingelezen bestanden.
SelectedFile = 0
HidePointer
LINE (OB.Xmin + 3, OB.Ymin + 3)-(OB.Xmin + 49 + 2, OB.Ymin + 127 - 4), 1, BF
FOR FileNr = 0 TO ListFiles - 1
  FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * FileNr
  IF FileNr = SelectedFile THEN
    LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * SelectedFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * SelectedFile + 4), 2, BF
    FLocate OB.Xmin + 4 + 1, OB.Ymin + 4 + 4 + 6 * SelectedFile
    FColor 1: FPrint UCASE$(ListFile(SelectedFile))
    FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * SelectedFile
    SELECT CASE ListFileExt(SelectedFile)
      CASE ".chr": FColor 5
    END SELECT
  ELSE
    SELECT CASE ListFileExt(SelectedFile)
      CASE ".chr": FColor 8
    END SELECT
  END IF
  FPrint UCASE$(ListFile(FileNr))
NEXT FileNr
ShowPointer

DO
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2

  ' Muis afhandelen
  IF but% = 1 THEN
    IF mx% >= OB.Xmin + 4 AND my% >= OB.Ymin + 4 AND mx% <= OB.Xmin + 49 + 1 AND my% <= OB.Ymin + 127 - 5 THEN
      PrevFile = SelectedFile
      SelectedFile = INT((my% - (OB.Ymin + 4)) / 6)
      IF SelectedFile > (ListFiles - 1) THEN SelectedFile = PrevFile
    END IF
  END IF
 
  ' Toetsen afhandelen
  a$ = INKEY$
  IF a$ <> "" THEN
    IF a$ = CHR$(13) THEN Fl = SelectedFile: EXIT DO
    IF a$ = CHR$(27) THEN
      HidePointer
        PUT (OB.Xmin, OB.Ymin), Ondervak, PSET
      ShowPointer
      EXIT SUB
    END IF
    IF a$ = CHR$(0) + CHR$(72) AND SelectedFile > 0 THEN SelectedFile = SelectedFile - 1               ' Omhoog
    IF a$ = CHR$(0) + CHR$(80) AND SelectedFile < ListFiles - 1 THEN SelectedFile = SelectedFile + 1    ' Omlaag
  END IF

  IF PrevFile <> SelectedFile THEN
    HidePointer
    LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * PrevFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * PrevFile + 4), 1, BF
    FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * PrevFile
    SELECT CASE ListFileExt(SelectedFile)
      CASE ".chr": FColor 8
    END SELECT
    FPrint UCASE$(ListFile(PrevFile))
    LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * SelectedFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * SelectedFile + 4), 2, BF
    FLocate OB.Xmin + 4 + 1, OB.Ymin + 4 + 4 + 6 * SelectedFile
    FColor 1: FPrint UCASE$(ListFile(SelectedFile))
    FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * SelectedFile
    SELECT CASE ListFileExt(SelectedFile)
      CASE ".chr": FColor 5
    END SELECT
    FPrint UCASE$(ListFile(SelectedFile))
    ShowPointer
    PrevFile = SelectedFile
  END IF
LOOP

HidePointer
PUT (OB.Xmin, OB.Ymin), Ondervak, PSET
ShowPointer

SELECT CASE ListFileExt(SelectedFile)
  CASE ".chr":
    Window.Open "LivOb", "DATA\" + ListFile(SelectedFile) + ListFileExt(SelectedFile)
END SELECT

DO
  CALL GetButtonM(but%, mx%, my%)
LOOP WHILE but% = 1

END SUB

SUB FInit

' Lettertype inladen...
OPEN "DATA\STANDARD.LTT" FOR INPUT AS #1    ' Lettertype inladen
DO UNTIL EOF(1)
  LINE INPUT #1, DrawRegel$
  IF LEN(DrawRegel$) > 2 THEN
    Char% = ASC(LEFT$(DrawRegel$, 1))
    Letter(Char%) = RIGHT$(DrawRegel$, LEN(DrawRegel$) - 4)
    Lengte(Char%) = CHR$(VAL(RIGHT$(LEFT$(DrawRegel$, 4), 2)))
  END IF
LOOP
CLOSE #1

FSize 1                             ' Beginwaarden instellen
FColor 7
FRotate 0
FWindow 0, 0, 319, 199
FLocate 1, 5

END SUB

FUNCTION FLenght% (zin$)
DIM LTeken AS STRING * 1

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)

FOR TekenNummer% = 1 TO LEN(zin$)
  LTeken = MID$(zin$, TekenNummer%, 1)
  Lenght% = Lenght% + ASC(Lengte(ASC(LTeken))) * TekenBg%
NEXT TekenNummer%

FLenght% = Lenght%

END FUNCTION

SUB FLocate (x%, y%)

Lib.Xco% = x%
Lib.Yco% = y%

END SUB

SUB FPrint (zin$)
DIM Teken AS STRING * 1

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)
Lib.Yc% = Lib.Yco% - 4 * TekenBg%
PSET (Lib.Xco%, Lib.Yc%), POINT(Lib.Xco%, Lib.Yc%)
DRAW FClr + FSze + FAngle                ' Juiste lettertype instellen

FOR TekenNummer% = 1 TO LEN(zin$)
  Teken = MID$(zin$, TekenNummer%, 1)    ' Teken uit de string halen
  DRAW Letter(ASC(Teken))                ' Teken op het scherm zetten

  Lib.Xco% = Lib.Xco% + ASC(Lengte(ASC(Teken))) * TekenBg%     ' Nieuwe positie op scherm berekenen
NEXT TekenNummer%

END SUB

SUB FRotate (Degrees%)

IF Degrees% < -360 OR Degrees% > 360 THEN ProgramError 3
FAngle = "TA" + MID$(STR$(Degrees%), 1, 3)
IF MID$(FAngle, 1, 1) = " " THEN FAngle = MID$(FAngle, 2, 3)
 
END SUB

SUB FSize (Size%)

IF Size% < 1 THEN ProgramError 1
FSze = "S" + MID$(STR$(Size% * 4), 2, 3)

END SUB

SUB FWindow (Xmin%, Ymin%, Xmax%, Ymax%)
' Deze sub doet nog niet veel
END SUB

SUB FWrite (zin$, x%, y%, Clr%)
DIM Teken AS STRING * 1

IF Clr% < 0 OR Clr% > 255 THEN ProgramError 2
FClr = "C" + MID$(STR$(Clr%), 2, 3)
Lib.Xco% = x%
Lib.Yco% = y%

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)
Lib.Yc% = Lib.Yco% - 4 * TekenBg%
PSET (Lib.Xco%, Lib.Yc%), POINT(Lib.Xco%, Lib.Yc%)
DRAW FClr + FSze + FAngle                ' Juiste lettertype instellen

FOR TekenNummer% = 1 TO LEN(zin$)
  Teken = MID$(zin$, TekenNummer%, 1)    ' Teken uit de string halen
  DRAW Letter(ASC(Teken))                ' Teken op het scherm zetten

  Lib.Xco% = Lib.Xco% + ASC(Lengte(ASC(Teken))) * TekenBg%     ' Nieuwe positie op scherm berekenen
NEXT TekenNummer%

END SUB

SUB Info.Picture
 Inf = 1

 Px% = mx% - PicX                ' Rekenen boven welke x en y de muis is
 Py% = my% - PicY
'Pc% = POINT(mx%, my%)

 c = 49
 IF Info$ <> "Picture" THEN
   LINE (200, 1)-(319, 5), 2, BF
   FColor 20
   FLocate 220 + c, 5: FPrint "X:"
   FLocate 250 + c, 5: FPrint "Y:"
  'FLocate 280, 5: FPrint "COLOR:"
   Info$ = "Picture"
   FColor 8
   FLocate 225 + c, 5: FPrint STR$(Px%)
   FLocate 255 + c, 5: FPrint STR$(Py%)
  'FLocate 304, 5: FPrint STR$(Pc%)
 END IF

 FColor 8
 IF Ipx <> Px% THEN LINE (225 + c, 1)-(239 + c, 5), 2, BF: FLocate 225 + c, 5: FPrint STR$(Px%): Ipx = Px%
 IF Ipy <> Py% THEN LINE (255 + c, 1)-(279 + c, 5), 2, BF: FLocate 255 + c, 5: FPrint STR$(Py%): Ipy = Py%
'IF Ipc <> Pc% THEN LINE (304, 1)-(318, 5), 2, BF: FLocate 304, 5: FPrint STR$(Pc%): Ipc = Pc%

END SUB

SUB Info.PW
Inf = 1

x = INT((mx% - PW.Xmin) / 5)            ' Rekenen boven welke kleur de muis zit
y = INT((my% - PW.Ymin) / 5)
VKleur = 8 * (x + PW.From) + y
Ch$ = STR$(VKleur)

IF Info$ <> "PW" THEN
  LINE (200, 1)-(319, 5), 2, BF
  FColor 3: FLocate 280, 5: FPrint "COLOR:"
  IKleur = -1
  Info$ = "PW"
END IF

IF IKleur <> VKleur THEN
  LINE (304, 1)-(318, 5), 2, BF         ' Vorig getal wissen
  FColor 4: FLocate 304, 5: FPrint Ch$  ' Nieuwe ervoor in de plaats
  IKleur = VKleur
END IF

END SUB

SUB Info.VG (Nr%)
Inf = 1

x = INT((mx% - LivOb(Nr%).VGXmin) / LivOb(Nr%).VGSize)              ' Rekenen boven welke x en y de muis is
y = INT((my% - LivOb(Nr%).VGYmin) / LivOb(Nr%).VGSize)
c = MPunt(x, y)

IF Info$ <> "VG" THEN
  LINE (200, 1)-(319, 5), 2, BF
  FColor 3
  FLocate 220, 5: FPrint "X:"
  FLocate 250, 5: FPrint "Y:"
  FLocate 280, 5: FPrint "COLOR:"
  Info$ = "VG"
  FColor 4
  FLocate 225, 5: FPrint STR$(x)
  FLocate 255, 5: FPrint STR$(y)
  FLocate 304, 5: FPrint STR$(c)
END IF

FColor 4
IF Ix <> x THEN LINE (225, 1)-(249, 5), 2, BF: FLocate 225, 5: FPrint STR$(x): Ix = x
IF Iy <> y THEN LINE (255, 1)-(279, 5), 2, BF: FLocate 255, 5: FPrint STR$(y): Iy = y
IF Ic <> c THEN LINE (304, 1)-(318, 5), 2, BF: FLocate 304, 5: FPrint STR$(c): Ic = c

END SUB

SUB Magnify (Xv%, Yv%, Nr%)

' Plek van vergroting corrigeren
'Xv% = Xv% - CINT(LivOb(Nr%).VGX / 2): Yv% = Yv% - CINT(LivOb(Nr%).VGY / 2)
'IF Xv% > PicX + PICmem(0) / 8 - LivOb(Nr%).VGX THEN Xv% = PicX + PICmem(0) / 8 - LivOb(Nr%).VGX
'IF Xv% < PicX THEN Xv% = PicX
'IF Yv% > PicY + PICmem(1) - LivOb(Nr%).VGY THEN Yv% = PicY + PICmem(1) - LivOb(Nr%).VGY
'IF Yv% < PicY THEN Yv% = PicY

' Vergroting tekenen
HidePointer
FOR x = 0 TO LivOb(Nr%).VGX - 1
  FOR y = 0 TO LivOb(Nr%).VGY - 1
    Pc% = POINT(Xv% + x, Yv% + y)
    MPunt(x, y) = Pc%
  NEXT y
NEXT x
FOR x = 0 TO LivOb(Nr%).VGX - 1
  FOR y = 0 TO LivOb(Nr%).VGY - 1
    LINE (LivOb(Nr%).VGXmin + LivOb(Nr%).VGSize * x, LivOb(Nr%).VGYmin + LivOb(Nr%).VGSize * y)-(LivOb(Nr%).VGXmin - 2 + LivOb(Nr%).VGSize * (x + 1), LivOb(Nr%).VGYmin - 2 + LivOb(Nr%).VGSize * (y + 1)), MPunt(x, y), BF
    IF MPunt(x, y) = 0 THEN
      LINE (LivOb(Nr%).VGXmin + LivOb(Nr%).VGSize * x, LivOb(Nr%).VGYmin + LivOb(Nr%).VGSize * y)-(LivOb(Nr%).VGXmin - 2 + LivOb(Nr%).VGSize * (x + 1), LivOb(Nr%).VGYmin - 2 + LivOb(Nr%).VGSize * (y + 1)), 1
      LINE (LivOb(Nr%).VGXmin + LivOb(Nr%).VGSize * x, LivOb(Nr%).VGYmin - 2 + LivOb(Nr%).VGSize * (y + 1))-(LivOb(Nr%).VGXmin - 2 + LivOb(Nr%).VGSize * (x + 1), LivOb(Nr%).VGYmin + LivOb(Nr%).VGSize * y), 1
    END IF
  NEXT y
NEXT x
IMgx = Xv%: IMgy = Yv%
ShowPointer

END SUB

FUNCTION MessageBox% (zin$, type$)

BoxWidth% = FLenght(zin$) + 6
BoxHeight% = 20

SELECT CASE type$
  CASE "YesNoCancel": IF BoxWidth% < 60 THEN BoxWidth% = 60
  CASE "AnyKey": IF BoxWidth% < 58 THEN BoxWidth% = 58
END SELECT
BoxX% = 160 - BoxWidth% / 2
BoxY% = 75 - BoxHeight% / 2

' Raampje op scherm zetten
VarLenght% = CINT((BoxWidth% * BoxHeight% + 4) / 4)
DIM Ondervak(VarLenght%)
HidePointer
 GET (BoxX%, BoxY%)-(BoxX% + BoxWidth% - 1, BoxY% + BoxHeight% - 1), Ondervak
 LINE (BoxX%, BoxY%)-(BoxX% + BoxWidth% - 1, BoxY% + BoxHeight% - 1), 1, B
 LINE (BoxX%, BoxY%)-(BoxX% + BoxWidth% - 2, BoxY% + BoxHeight% - 2), 5, B
 LINE (BoxX% + 1, BoxY% + 1)-(BoxX% + BoxWidth% - 2, BoxY% + BoxHeight% - 2), 8, BF
 FWrite zin$, BoxX% + (BoxWidth% - FLenght(zin$)) / 2 + 1, BoxY% + 7, 1
 FWrite zin$, BoxX% + (BoxWidth% - FLenght(zin$)) / 2, BoxY% + 6, 4
ShowPointer

SELECT CASE type$
  CASE "YesNoCancel"
    FLocate BoxX% + (BoxWidth% - FLenght("YES NO CANCEL")) / 2, BoxY% + 15
    FColor 5: FPrint "Y": FColor 0: FPrint "ES "
    FColor 5: FPrint "N": FColor 0: FPrint "O "
    FColor 5: FPrint "C": FColor 0: FPrint "ANCEL"
    DO
      a$ = INKEY$
      IF a$ = CHR$(27) THEN MessageBox = 0: EXIT DO
      SELECT CASE LCASE$(a$)
        CASE "c": MessageBox = 0: EXIT DO
        CASE "y": MessageBox = 1: EXIT DO
        CASE "n": MessageBox = 2: EXIT DO
      END SELECT
    LOOP
 
  CASE "AnyKey"
    FLocate BoxX% + (BoxWidth% - FLenght("PRESS ANY KEY")) / 2, BoxY% + 15
    FColor 0: FPrint "PRESS ANY KEY"
    DO: LOOP UNTIL INKEY$ = ""
    DO: LOOP WHILE INKEY$ = ""
    MessageBox = 0

END SELECT

HidePointer
 PUT (BoxX%, BoxY%), Ondervak, PSET
ShowPointer

END FUNCTION

SUB Muis.ColorChance

ISc = Sc
IF Sc > 31 AND Sc < 248 THEN
  Sc = Sc - 24 * Contrast - 72 * Intensiteit
  Contrast = INT((mx% - 131) / 9)
  Intensiteit = INT((my% - 161) / 9)
  Sc = Sc + 24 * Contrast + 72 * Intensiteit
END IF

IF ISc <> Sc THEN Chance.Color (Sc)

END SUB

SUB Muis.ColorSelect

ISc = Sc
x = INT((mx% - PW.Xmin) / 5)
y = INT((my% - PW.Ymin) / 5)
Sc = 8 * (x + PW.From) + y
IF ISc <> Sc THEN Chance.Color (Sc)

END SUB

SUB Muis.GetColor (Nr%)

x = INT((mx% - LivOb(Nr%).VGXmin) / LivOb(Nr%).VGSize)
y = INT((my% - LivOb(Nr%).VGYmin) / LivOb(Nr%).VGSize)

IF Sc <> MPunt(x, y) THEN
  Sc = MPunt(x, y)
  Chance.Color (Sc)
END IF

END SUB

SUB Muis.Mengen

x% = mx%: y% = my%

IF my% < MP.Y1 THEN
  DO
    Kl% = x% - MP.Xmin
    IF Kl% < 0 THEN Kl% = 0
    IF Kl% > 63 THEN Kl% = 63
    IF Kl% <> ASC(MClr(Sc, 0)) THEN
      MClr(Sc, 0) = CHR$(Kl%)
      Chance.Color (Sc)
    END IF
    CALL GetButtonM(but%, x%, y%): x% = x% / 2
  LOOP UNTIL but% = 0
END IF
IF my% > MP.Y2 - 4 AND my% < MP.Y2 THEN
  DO
    Kl% = x% - MP.Xmin
    IF Kl% < 0 THEN Kl% = 0
    IF Kl% > 63 THEN Kl% = 63
    IF Kl% <> ASC(MClr(Sc, 1)) THEN
      MClr(Sc, 1) = CHR$(Kl%)
      Chance.Color (Sc)
    END IF
    CALL GetButtonM(but%, x%, y%): x% = x% / 2
  LOOP UNTIL but% = 0
END IF
IF my% > MP.Y3 - 4 THEN
  DO
    Kl% = x% - MP.Xmin
    IF Kl% < 0 THEN Kl% = 0
    IF Kl% > 63 THEN Kl% = 63
    IF Kl% <> ASC(MClr(Sc, 2)) THEN
      MClr(Sc, 2) = CHR$(Kl%)
      Chance.Color (Sc)
    END IF
    CALL GetButtonM(but%, x%, y%): x% = x% / 2
  LOOP UNTIL but% = 0
END IF

END SUB

SUB Muis.Paint (Nr%)

x = INT((mx% - LivOb(Nr%).VGXmin) / LivOb(Nr%).VGSize)
y = INT((my% - LivOb(Nr%).VGYmin) / LivOb(Nr%).VGSize)
LivOb(Nr%).Changed = 1

IF Sc <> MPunt(x, y) THEN
  HidePointer
  LINE (LivOb(Nr%).VGXmin + LivOb(Nr%).VGSize * x, LivOb(Nr%).VGYmin + LivOb(Nr%).VGSize * y)-(LivOb(Nr%).VGXmin - 2 + LivOb(Nr%).VGSize * (x + 1), LivOb(Nr%).VGYmin - 2 + LivOb(Nr%).VGSize * (y + 1)), Sc, BF
  IF Sc = 0 THEN
    LINE (LivOb(Nr%).VGXmin + LivOb(Nr%).VGSize * x, LivOb(Nr%).VGYmin + LivOb(Nr%).VGSize * y)-(LivOb(Nr%).VGXmin - 2 + LivOb(Nr%).VGSize * (x + 1), LivOb(Nr%).VGYmin - 2 + LivOb(Nr%).VGSize * (y + 1)), 1
    LINE (LivOb(Nr%).VGXmin + LivOb(Nr%).VGSize * x, LivOb(Nr%).VGYmin - 2 + LivOb(Nr%).VGSize * (y + 1))-(LivOb(Nr%).VGXmin - 2 + LivOb(Nr%).VGSize * (x + 1), LivOb(Nr%).VGYmin + LivOb(Nr%).VGSize * y), 1
  END IF

  PSET (IMgx + x, IMgy + y), Sc
  IF WindowNr(Nr%).Id = 1 THEN
    PSET (IMgx + x, IMgy + y + 20), 0
    IF Sc = 0 THEN PSET (IMgx + x, IMgy + y + LivOb(Nr%).LOVSpace), 255
  END IF
  MPunt(x, y) = Sc
    
  FOR y = 0 TO 1
    FOR z = 0 TO 1
      GET (LivOb(Nr%).LOXmin + 1 + LivOb(Nr%).LOHSpace * LivOb(Nr%).ActFace, LivOb(Nr%).LOYmin + 1 + y * 8 + z * LivOb(Nr%).LOVSpace)-(LivOb(Nr%).LOXmin + 8 + LivOb(Nr%).LOHSpace * LivOb(Nr%).ActFace, LivOb(Nr%).LOYmin + 8 + y * 8 + z * LivOb(Nr%). _
LOVSpace), Figuur(0, LivOb(Nr%).ActFace, y, z, Nr%)
    NEXT z
  NEXT y
  ShowPointer
END IF

END SUB

SUB Palet.Load

DEF SEG = VARSEG(MClr(0, 0))       ' Vanuit bestand direct naar geheugen
BLOAD "DATA\STANDARD.PAL", VARPTR(MClr(0, 0))
Palet.Update

END SUB

SUB Palet.Save

DEF SEG = VARSEG(MClr(0, 0))       ' Vanuit geheugen direct naar bestand
BSAVE "DATA\STANDARD.PAL", VARPTR(MClr(0, 0)), 768  ' 256 * 3 = 768

END SUB

SUB Palet.Update

FOR Col% = 0 TO 127 '255                  ' Berekening voor dag/nacht werking
  OUT &H3C8, Col%
  OUT &H3C9, ASC(MClr(Col%, 0))
  OUT &H3C9, ASC(MClr(Col%, 1))
  OUT &H3C9, ASC(MClr(Col%, 2))
  OUT &H3C8, Col% + 128
  OUT &H3C9, ASC(MClr(Col%, 0)) / 3 + 2
  OUT &H3C9, ASC(MClr(Col%, 1)) / 3 + 5
  OUT &H3C9, ASC(MClr(Col%, 2)) / 3 + 7
NEXT Col%

END SUB

SUB PIC.Load (File$, PicX%, PicY%)
PicX = PicX%: PicY = PicY%

DEF SEG = VARSEG(PICmem(0))
BLOAD File$, VARPTR(PICmem(0))
IF PicX = -1 THEN PicX = (320 - (PICmem(0) / 8)) / 2
IF PicY = -1 THEN PicY = 8 + ((150 - PICmem(1)) / 2)

HidePointer
PUT (PicX, PicY), PICmem, PSET
'LINE (PicX - 1, PicY - 1)-(PicX + PICmem(0) / 8, PicY + PICmem(1)), 1, B
ShowPointer
'Magnify PicX + 3, PicY + 3

END SUB

SUB PIC.New (Xl%, Yl%, PicX%, PicY%)
'PicX = PicX%: PicY = PicY%
'
'PICmem(0) = Xl% * 8
'PICmem(1) = Yl%
'IF PicX = -1 THEN PicX = (320 - (PICmem(0) / 8)) / 2
'IF PicY = -1 THEN PicY = 8 + ((150 - PICmem(1)) / 2)
'
'HidePointer
'LINE (PicX, PicY)-(PicX + PICmem(0) / 8 - 1, PicY + PICmem(1) - 1), 0, BF
'LINE (PicX - 1, PicY - 1)-(PicX + PICmem(0) / 8, PicY + PICmem(1)), 1, B
'GET (PicX, PicY)-(PicX + PICmem(0) / 8 - 1, PicY + PICmem(1) - 1), PICmem(0)
'ShowPointer
'Magnify PicX + 3, PicY + 3
'
'
END SUB

SUB PIC.Save (File$)

Lenght% = CINT((PICmem(0) / 8) * PICmem(1) / 2) + 2
DIM SaveVar(Lenght%) AS INTEGER

HidePointer
  GET (PicX, PicY)-(PicX + PICmem(0) / 8 - 1, PicY + PICmem(1) - 1), SaveVar(0)
ShowPointer
DEF SEG = VARSEG(SaveVar(0))
BSAVE File$, VARPTR(SaveVar(0)), Lenght% * 2

END SUB

SUB Prepair
SCREEN 13                           ' 320x200 met 256 kleuren
GET (0, 0)-(7, 15), MemCell

Palet.Load

' De kleuren 0 t/m 15 zijn louter voor het programma!
PALETTE 1, 5 + 256 * 5 + 65536 * 5
PALETTE 2, 8 + 256 * 8 + 65536 * 8
PALETTE 3, 14 + 256 * 14 + 65536 * 14
PALETTE 4, 21 + 256 * 21 + 65536 * 21
PALETTE 5, 20 + 256 * 14 + 65536 * 14
PALETTE 6, 14 + 256 * 20 + 65536 * 14
PALETTE 7, 14 + 256 * 14 + 65536 * 20
PALETTE 8, 12 + 256 * 7 + 65536 * 7

FInit                               ' Font initialiseren

' Kleurwaardes in variabelen zetten.
FOR x = 0 TO 255
  OUT &H3C6, &HFF
  OUT &H3C7, x
  MClr(x, 0) = CHR$(INP(&H3C9))
  MClr(x, 1) = CHR$(INP(&H3C9))
  MClr(x, 2) = CHR$(INP(&H3C9))
NEXT x
Palet.Update

' Muis initialiseren...
CALL initpointer(i)
IF i = 0 THEN SCREEN 0: WIDTH 80, 25: COLOR 7: PRINT "Geen muis gevonden.": END

Buildscreen

END SUB

SUB ProgramError (D%)
SCREEN 0: WIDTH 80: CLS : COLOR 8
PRINT "Something has gone terribly wrong!": PRINT : COLOR 7

SELECT CASE D%

  CASE 0:    PRINT "Runtime errorcode:"; ERR
             IF ERL <> 0 THEN PRINT "In line:"; ERL
             SELECT CASE ERR
              CASE 5:  PRINT "Ongeldige functie aanroep, misschien verkeerde scherm modus"
              CASE 6:  PRINT "Overloop"
              CASE 7:  PRINT "Onvoldoende geheugen"
              CASE 52: PRINT "Onjuiste bestandsnaam/nummer"
              CASE 53: PRINT "Bestand niet gevonden"
              CASE 61: PRINT "Schijf is vol"
              CASE 64: PRINT "Onjuiste bestandsnaam"
             END SELECT

  CASE 1:    PRINT "Error in sub FSize:"
             PRINT "Size% cannot be less then 1"

  CASE 2:    PRINT "Error in sub FColor:"
             PRINT "Clr% cannot be negative or above 255"

  CASE 3:    PRINT "Error in sub FRotate:"
             PRINT "Degrees% must be in [-360,360]"

END SELECT

SYSTEM
END SUB

SUB QuitProg

SCREEN 0: WIDTH 80, 25
COLOR 7
PRINT " DrawR " + Version
COLOR 8: PRINT
PRINT " Changes"
PRINT " - Window system supports multiple windows!"
PRINT " - Up to 3 LivOb-windows open at the same time"
PRINT " - Some cordinate changes"
PRINT " - Optimized some things, but the windows are still flickering"
PRINT
PRINT " Features in DrawR v0.20"
PRINT " - LivOb window finished, but suggestions are still welcome"
PRINT " - Window system including dragging and closing (supports 1 window)"
PRINT " - Warning MessageBox when closing if changes are not saved yet"
PRINT " - Supported file types: CHR, PAL"
PRINT " - COMMAND$ can be used to open files more quickly"
PRINT
COLOR 7
SYSTEM

END SUB

SUB Set.Variables

MP.Xmin = 165: MP.Space = 7 '----------------------------- Mengpaneeltje (MP)
MP.Y1 = 165
MP.Y2 = MP.Y1 + MP.Space
MP.Y3 = MP.Y2 + MP.Space
PW.Xmin = 249: PW.Ymin = 159 '----------------------------- Palet Window (PW)
PW.From = 2: PW.To = 15
PW.Xmax = PW.Xmin + 5 * (PW.To - PW.From + 1) - 2
PW.Ymax = PW.Ymin + 5 * 8 - 2
OB.Xmin = 0: OB.Ymin = 9 '------------------------- Open bestand raampje (OB)

END SUB

SUB Update.ActFace (Nr%)

  HidePointer
  FOR u% = 0 TO 3
    IF LivOb(Nr%).ActFace = u% THEN
      LINE (LivOb(Nr%).LOXmin + LivOb(Nr%).LOHSpace * u%, LivOb(Nr%).LOYmin)-(LivOb(Nr%).LOXmin + 9 + LivOb(Nr%).LOHSpace * u%, LivOb(Nr%).LOYmin + 17), 3, B
      Magnify LivOb(Nr%).LOXmin + 1 + LivOb(Nr%).LOHSpace * u%, LivOb(Nr%).LOYmin + 1, Nr%
    ELSE LINE (LivOb(Nr%).LOXmin + LivOb(Nr%).LOHSpace * u%, LivOb(Nr%).LOYmin)-(LivOb(Nr%).LOXmin + 9 + LivOb(Nr%).LOHSpace * u%, LivOb(Nr%).LOYmin + 17), 1, B
    END IF
  NEXT u%
  ShowPointer

END SUB

SUB Window.Close (Nr%)

HidePointer
LINE (WindowNr(Nr%).Xmax - 7, WindowNr(Nr%).Ymin + 1)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 1, B
LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymin + 7), 5, B
LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 8, BF
FWrite "x", WindowNr(Nr%).Xmax - 5, WindowNr(Nr%).Ymin + 5, 1
ShowPointer

DO
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
  IF Druk% = 1 AND (mx% <= WindowNr(Nr%).Xmax - 7 OR my% <= WindowNr(Nr%).Ymin + 1 OR mx% >= WindowNr(Nr%).Xmax - 1 OR my% >= WindowNr(Nr%).Ymin + 7) THEN
    HidePointer
    LINE (WindowNr(Nr%).Xmax - 7, WindowNr(Nr%).Ymin + 1)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 5, B
    LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymin + 7), 1, B
    LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 8, B
    ShowPointer
    Druk% = 0
  ELSEIF Druk% = 0 AND (mx% > WindowNr(Nr%).Xmax - 7 AND my% > WindowNr(Nr%).Ymin + 1 AND mx% < WindowNr(Nr%).Xmax - 1 AND my% < WindowNr(Nr%).Ymin + 7) THEN
    HidePointer
    LINE (WindowNr(Nr%).Xmax - 7, WindowNr(Nr%).Ymin + 1)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 1, B
    LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymin + 7), 5, B
    LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 8, B
    ShowPointer
    Druk% = 1
  END IF
LOOP UNTIL but% = 0

IF Druk% = 1 THEN
  IF LivOb(Nr%).Changed = 0 THEN
    WindowNr(Nr%).Active = 0
    Remove% = 1
  ELSE
    WindowTitle$ = MID$(LivOb(Nr%).Filename, 1, INSTR(LivOb(Nr%).Filename, " ") - 1)
    Choice% = MessageBox("SAVE CHANGES TO " + WindowTitle$ + "?", "YesNoCancel")
    SELECT CASE Choice%
      CASE 1:
        CHR.Save Nr%
        WindowNr(Nr%).Active = 0
        Remove% = 1
      CASE 2:
        WindowNr(Nr%).Active = 0: LivOb(Nr%).Changed = 0
        Remove% = 1
      CASE 0:
        HidePointer
        LINE (WindowNr(Nr%).Xmax - 7, WindowNr(Nr%).Ymin + 1)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 5, B
        LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymin + 7), 1, B
        LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), 8, B
        ShowPointer
    END SELECT
  END IF
END IF

IF Remove% = 1 THEN
  FOR i = 0 TO WindowCount
    IF WindowNr(i).Height > 1 THEN WindowNr(i).Height = WindowNr(i).Height - 1
  NEXT i

  DIM Height(1 TO WindowCount + 1) AS INTEGER
  Number% = 0
  FOR w% = 0 TO WindowCount
    IF WindowNr(w%).Active = 1 THEN Height(WindowNr(w%).Height) = w%: Number% = Number% + 1
  NEXT w%
  HidePointer
  LINE (WindowNr(Nr%).Xmin, WindowNr(Nr%).Ymin)-(WindowNr(Nr%).Xmax, WindowNr(Nr%).Ymax), 0, BF
  FOR w% = Number% TO 1 STEP -1
    Window.Draw Height(w%)
  NEXT w%
  ShowPointer
END IF

END SUB

SUB Window.Drag (Nr%)

minX% = WindowNr(Nr%).Xmin
minY% = WindowNr(Nr%).Ymin
widthX% = WindowNr(Nr%).Xmax - WindowNr(Nr%).Xmin + 1
heightY% = WindowNr(Nr%).Ymax - WindowNr(Nr%).Ymin + 1

VarLenght% = CINT((widthX% * heightY% + 4) / 2) - 1
DIM Vak(VarLenght%) AS INTEGER

FOR x = 2 TO VarLenght%
  Vak(x) = -32640                           ' Het vak kleur 128 maken
NEXT x
Vak(0) = widthX% * 8
Vak(1) = heightY%

CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
Vx% = mx% - minX%: Vy% = my% - minY%
mxo% = mx%: myo% = my%
DO
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
  IF but% <> 1 THEN EXIT SUB
LOOP UNTIL mxo% <> mx% OR myo% <> my%
HidePointer
IF mx% < Vx% + 1 THEN mx% = Vx% + 1
IF my% < Vy% + 9 THEN my% = Vy% + 9
IF mx% > 319 - (widthX% - Vx%) THEN mx% = 319 - (widthX% - Vx%)
IF my% > 155 - (heightY% - Vy%) THEN my% = 155 - (heightY% - Vy%)
PUT (mx% - Vx%, my% - Vy%), Vak(0), OR
mxo% = mx%: myo% = my%
ShowPointer
DO
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
  IF mx% < Vx% THEN mx% = Vx%
  IF my% < Vy% + 9 THEN my% = Vy% + 9
  IF mx% > 320 - (widthX% - Vx%) THEN mx% = 320 - (widthX% - Vx%)
  IF my% > 155 - (heightY% - Vy%) THEN my% = 155 - (heightY% - Vy%)
  IF mxo% <> mx% OR myo% <> my% THEN
    HidePointer
    IF my% > myo% AND my% - myo% < heightY% AND mx% = mxo% THEN
      Vak(0) = widthX% * 8
      Vak(1) = my% - myo%
      PUT (mx% - Vx%, myo% - Vy%), Vak(0), XOR
      PUT (mx% - Vx%, myo% - Vy% + heightY%), Vak(0), XOR
    ELSEIF my% < myo% AND myo% - my% < heightY% AND mx% = mxo% THEN
      Vak(0) = widthX% * 8
      Vak(1) = myo% - my%
      PUT (mx% - Vx%, my% - Vy%), Vak(0), XOR
      PUT (mx% - Vx%, my% - Vy% + heightY%), Vak(0), XOR
    ELSEIF my% = myo% AND mx% - mxo% < widthX% AND mx% > mxo% THEN
      Vak(0) = (mx% - mxo%) * 8
      Vak(1) = heightY%
      PUT (mxo% - Vx%, my% - Vy%), Vak(0), XOR
      PUT (mxo% - Vx% + widthX%, my% - Vy%), Vak(0), XOR
    ELSEIF my% = myo% AND mxo% - mx% < widthX% AND mx% < mxo% THEN
      Vak(0) = (mxo% - mx%) * 8
      Vak(1) = heightY%
      PUT (mx% - Vx%, my% - Vy%), Vak(0), XOR
      PUT (mx% - Vx% + widthX%, my% - Vy%), Vak(0), XOR
    ELSE
      Vak(0) = widthX% * 8
      Vak(1) = heightY%
      PUT (mxo% - Vx%, myo% - Vy%), Vak(0), XOR
      PUT (mx% - Vx%, my% - Vy%), Vak(0), XOR
    END IF
    ShowPointer
    mxo% = mx%: myo% = my%
  END IF
LOOP UNTIL but% = 0

WindowNr(Nr%).Xmin = mx% - Vx%: WindowNr(Nr%).Ymin = my% - Vy%
DIM Height(1 TO WindowCount + 1) AS INTEGER
Number% = 0
FOR w% = 0 TO WindowCount
  IF WindowNr(w%).Active = 1 THEN Height(WindowNr(w%).Height) = w%: Number% = Number% + 1
NEXT w%
HidePointer
LINE (minX%, minY%)-(minX% + widthX% - 1, minY% + heightY% - 1), 0, BF
FOR w% = Number% TO 1 STEP -1
  Window.Draw Height(w%)
NEXT w%
ShowPointer

END SUB

SUB Window.Draw (Nr%)

IF WindowNr(Nr%).Height = 1 THEN WAIT &H3DA, 8        ' Voorkomt geknipper

HidePointer
SELECT CASE WindowNr(Nr%).Id

  CASE 1
    ' Cordinaten van de verschillende onderdelen berekenen
    LivOb(Nr%).VGXmin = WindowNr(Nr%).Xmin + 3
    LivOb(Nr%).VGYmin = WindowNr(Nr%).Ymin + 12
    LivOb(Nr%).VGXmax = LivOb(Nr%).VGXmin + LivOb(Nr%).VGX * LivOb(Nr%).VGSize - 2
    LivOb(Nr%).VGYmax = LivOb(Nr%).VGYmin + LivOb(Nr%).VGY * LivOb(Nr%).VGSize - 2
    LivOb(Nr%).LOXmin = LivOb(Nr%).VGXmax + 4
    LivOb(Nr%).LOYmin = WindowNr(Nr%).Ymin + 11
    WindowNr(Nr%).Xmax = LivOb(Nr%).VGXmax + 4 * LivOb(Nr%).LOHSpace + (5 - (LivOb(Nr%).LOHSpace - 10))
    WindowNr(Nr%).Ymax = LivOb(Nr%).VGYmax + 3
   
    ' Titelbalk
    IF WindowNr(Nr%).Height = 1 THEN
      Dark% = 1
      Normal% = 8
      Light% = 5
    ELSE
      Dark% = 1
      Normal% = 2
      Light% = 3
    END IF
    LINE (WindowNr(Nr%).Xmin, WindowNr(Nr%).Ymin + 8)-(WindowNr(Nr%).Xmax, WindowNr(Nr%).Ymin), Normal%
    LINE (WindowNr(Nr%).Xmin + 1, WindowNr(Nr%).Ymin + 1)-(WindowNr(Nr%).Xmax, WindowNr(Nr%).Ymin + 8), Dark%, B
    LINE (WindowNr(Nr%).Xmin, WindowNr(Nr%).Ymin)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymin + 7), Light%, B
    LINE (WindowNr(Nr%).Xmin + 1, WindowNr(Nr%).Ymin + 1)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymin + 7), Normal%, BF
    WindowTitle$ = MID$(LivOb(Nr%).Filename, 1, INSTR(LivOb(Nr%).Filename, " ") - 1)
    FWrite WindowTitle$, WindowNr(Nr%).Xmin + (WindowNr(Nr%).Xmax - WindowNr(Nr%).Xmin) / 2 - FLenght(WindowTitle$) / 2, WindowNr(Nr%).Ymin + 6, 4
    LINE (WindowNr(Nr%).Xmax - 7, WindowNr(Nr%).Ymin + 1)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), Light%, B
    LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymin + 7), Dark%, B
    LINE (WindowNr(Nr%).Xmax - 6, WindowNr(Nr%).Ymin + 2)-(WindowNr(Nr%).Xmax - 2, WindowNr(Nr%).Ymin + 6), Normal%, BF
    FWrite "x", WindowNr(Nr%).Xmax - 5, WindowNr(Nr%).Ymin + 5, 1

    ' Onderkant
    LINE (WindowNr(Nr%).Xmin, WindowNr(Nr%).Ymax)-(WindowNr(Nr%).Xmax, WindowNr(Nr%).Ymin + 9), 2
    LINE (WindowNr(Nr%).Xmin, WindowNr(Nr%).Ymin + 9)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymax - 1), 3, B
    LINE (WindowNr(Nr%).Xmin + 1, WindowNr(Nr%).Ymin + 10)-(WindowNr(Nr%).Xmax, WindowNr(Nr%).Ymax), 1, B
    LINE (WindowNr(Nr%).Xmin + 1, WindowNr(Nr%).Ymin + 10)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymax - 1), 2, B
    LINE (LivOb(Nr%).VGXmax + 2, WindowNr(Nr%).Ymin + 10)-(WindowNr(Nr%).Xmax - 1, WindowNr(Nr%).Ymax - 1), 2, BF
    LINE (LivOb(Nr%).VGXmin - 1, LivOb(Nr%).VGYmin - 1)-(LivOb(Nr%).VGXmax + 1, LivOb(Nr%).VGYmax + 1), 1, BF
    FOR x = 0 TO 3
      LINE (LivOb(Nr%).LOXmin + LivOb(Nr%).LOHSpace * x, LivOb(Nr%).LOYmin + LivOb(Nr%).LOVSpace)-(LivOb(Nr%).LOXmin + 9 + LivOb(Nr%).LOHSpace * x, LivOb(Nr%).LOYmin + 17 + LivOb(Nr%).LOVSpace), 1, B
    NEXT x
    FOR x = 0 TO 3
      FOR y = 0 TO 1
        FOR z = 0 TO 1
          PUT (LivOb(Nr%).LOXmin + 1 + LivOb(Nr%).LOHSpace * x, LivOb(Nr%).LOYmin + 1 + y * 8 + z * LivOb(Nr%).LOVSpace), Figuur(0, x, y, z, Nr%), PSET
    NEXT z, y, x
    Update.ActFace Nr%

END SELECT
ShowPointer

END SUB

SUB Window.Open (type$, Filename$)

Nr% = -1
FOR i = 0 TO WindowCount
  IF WindowNr(i).Active = 0 THEN Nr% = i: EXIT FOR
NEXT i
IF Nr% = -1 THEN
  x = MessageBox("MAXIMUM WINDOWS REACHED, CLOSE ONE OR MORE WINDOWS FIRST", "AnyKey")
  EXIT SUB
END IF

SELECT CASE type$

  CASE "LivOb"
    IF WindowNr(Nr%).Xmin = 0 THEN WindowNr(Nr%).Xmin = 51
    IF WindowNr(Nr%).Ymin = 0 THEN WindowNr(Nr%).Ymin = 20
    WindowNr(Nr%).Id = 1
    LivOb(Nr%).Filename = UCASE$(Filename$)       ' Instelbare gegevens
    LivOb(Nr%).VGSize = 5
    LivOb(Nr%).LOHSpace = 12: LivOb(Nr%).LOVSpace = 20
    LivOb(Nr%).VGX = 8: LivOb(Nr%).VGY = 16
    LivOb(Nr%).ActFace = 0
    CHR.Load Nr%                                  ' Bestand in geheugen laden

    FOR i = 0 TO WindowCount
      WindowNr(i).Height = WindowNr(i).Height + 1
      IF WindowNr(i).Height = 2 AND WindowNr(i).Active = 1 THEN
        Window.Draw i
      END IF
    NEXT i
    WindowNr(Nr%).Active = 1: WindowNr(Nr%).Height = 1
   
    LivOb(Nr%).VGXmin = WindowNr(Nr%).Xmin + 3      ' De rest berekenen
    LivOb(Nr%).VGYmin = WindowNr(Nr%).Ymin + 12
    LivOb(Nr%).VGXmax = LivOb(Nr%).VGXmin + LivOb(Nr%).VGX * LivOb(Nr%).VGSize - 2
    LivOb(Nr%).VGYmax = LivOb(Nr%).VGYmin + LivOb(Nr%).VGY * LivOb(Nr%).VGSize - 2
    LivOb(Nr%).LOXmin = LivOb(Nr%).VGXmax + 4
    LivOb(Nr%).LOYmin = WindowNr(Nr%).Ymin + 11
    WindowNr(Nr%).Xmax = LivOb(Nr%).VGXmax + 4 * LivOb(Nr%).LOHSpace + (5 - (LivOb(Nr%).LOHSpace - 10))
    WindowNr(Nr%).Ymax = LivOb(Nr%).VGYmax + 3

    Window.Draw Nr%

  END SELECT

END SUB

