'Ŀ
' RPG Edit v1.141                                                1999/2000 
' Made by Bjorn Lindeijer                        (c) Moonlight Productions 
'

' ---------- The Advanced Font Routines -------------------------------------
DECLARE FUNCTION FLenght% (zin$)
DECLARE SUB FWindow (Xmin%, Ymin%, Xmax%, Ymax%)
DECLARE SUB FLocate (x%, y%)
DECLARE SUB FInit ()
DECLARE SUB FSize (Size%)
DECLARE SUB FColor (Clr%)
DECLARE SUB FRotate (Degrees%)
DECLARE SUB FPrint (zin$)
DIM SHARED Letter(32 TO 122) AS STRING
DIM SHARED Lengte(32 TO 122) AS STRING * 1
DIM SHARED Lib.Xco AS INTEGER, Lib.Yco AS INTEGER
DIM SHARED FClr AS STRING, FSze AS STRING
DIM SHARED FAngle AS STRING
' ---------------------------------------------------------------------------
DECLARE SUB Prepair ()              ' Programma voorbereidingen
DECLARE SUB Set.Variables ()
DECLARE SUB Buildscreen ()          ' Eerste scherm opbouw
DECLARE SUB Check.Command ()        ' COMMAND$ controleren op inhoud
DECLARE SUB EditingMode ()          ' Prog-mode om events en triggers te editen
DECLARE SUB Cells.Update (SCell%)   ' Cellen updated en wereld PUTten
DECLARE SUB Palet.Update ()         ' Updaten/Saves en laden van het palet
DECLARE SUB Palet.Save ()
DECLARE SUB Palet.Load ()
DECLARE SUB Window.Drag (minX%, minY%, widthX%, heightY%)
DECLARE SUB Chance.Color (Col%)
DECLARE SUB Set.ColorSerie (Col%)
DECLARE SUB Get.Cell (Xc%, Yc%)     ' Tekent geselecteerde cel in vergrotinging
DECLARE SUB World.Put ()            ' Subs die te maken hebben met de wereld
DECLARE SUB World.Open ()
DECLARE SUB World.Load ()
DECLARE SUB World.Save ()
DECLARE SUB Cells.Copy ()           ' Subs die te maken hebben met de cellen
DECLARE SUB Cells.Paste ()
DECLARE SUB Cells.Load ()
DECLARE SUB Cells.Save ()
DECLARE SUB BottomMessage (thing$)  ' Sub voor dingen onderaan de pagina
DECLARE SUB Muis.CellSelect ()      ' Subs die worden geactiveerd door de muis
DECLARE SUB Muis.ColorSelect ()
DECLARE SUB Muis.ColorGet ()
DECLARE SUB Muis.Paint ()
DECLARE SUB Muis.Putcell ()
DECLARE SUB Muis.CellGet ()
DECLARE SUB Muis.ScrollX ()
DECLARE SUB Muis.ScrollY ()
DECLARE SUB Muis.Misc ()
DECLARE SUB Muis.Mengen ()
DECLARE SUB Muis.PushButton ()
DECLARE SUB Info.AR ()              ' Subs voor de informatie bovenaan
DECLARE SUB Info.PW ()
DECLARE SUB Info.VG ()
DECLARE SUB Info.KN ()
DECLARE SUB Info.CS ()
DECLARE SUB Info.Triggers ()
DECLARE SUB QuitProg ()             ' Sub voor een juiste afsluiting
DECLARE SUB HidePointer             ' Library subs voor de muis
DECLARE SUB ShowPointer
DECLARE SUB ProgramError (D%)       ' Sub om fouten af te handelen
'ON ERROR GOTO UnforseenError

CONST CellsX = 64, CellsY = 64      ' Grote van de wereld (niet veranderen)
CONST Z = 5                         ' Z = Vergroting van de geselecteerde cel
CONST Version = "1.141"

DIM SHARED AR.Xmin AS INTEGER, AR.Ymin AS INTEGER                      ' (AR)
DIM SHARED AR.Xmax AS INTEGER, AR.Ymax AS INTEGER
DIM SHARED AR.Xcll AS INTEGER, AR.Ycll AS INTEGER
DIM SHARED MP.Xmin AS INTEGER, MP.Xmax AS INTEGER, MP.Space AS INTEGER ' (MP)
DIM SHARED MP.Y1   AS INTEGER, MP.Y2   AS INTEGER, MP.Y3 AS INTEGER
DIM SHARED PW.Xmin AS INTEGER, PW.Ymin AS INTEGER                      ' (PW)
DIM SHARED PW.Xmax AS INTEGER, PW.Ymax AS INTEGER
DIM SHARED PW.From AS INTEGER, PW.To   AS INTEGER
DIM SHARED VG.Xmin AS INTEGER, VG.Ymin AS INTEGER, VG.Size AS INTEGER  ' (VG)
DIM SHARED VG.Xmax AS INTEGER, VG.Ymax AS INTEGER
DIM SHARED VG.X    AS INTEGER, VG.Y    AS INTEGER
DIM SHARED KN.Xmin AS INTEGER, KN.Ymin AS INTEGER                      ' (KB)
DIM SHARED KN.Xmax AS INTEGER, KN.Ymax AS INTEGER
DIM SHARED OB.Xmin AS INTEGER, OB.Ymin AS INTEGER                      ' (OB)
DIM SHARED CS.Xmin AS INTEGER, CS.Ymin AS INTEGER                      ' (CS)
DIM SHARED CS.Xmax AS INTEGER, CS.Ymax AS INTEGER

DIM SHARED MPunt(7, 7) AS INTEGER   ' Geselecteerde cel in geheugen
DIM SHARED Cell(16, 255) AS SINGLE  ' Cellen in geheugen
DIM SHARED MCell(1, CellsX - 1, CellsY - 1) AS STRING * 1' Wereld in geheugen
DIM SHARED ICell AS INTEGER, IKleur AS INTEGER        ' Info weergave bovenin
DIM SHARED Ix AS INTEGER, Iy AS INTEGER, Ic AS INTEGER
DIM SHARED Iwx AS INTEGER, Iwy AS INTEGER, Iwc AS INTEGER
DIM SHARED mx%, my%, but%
DIM SHARED Sc AS INTEGER: Sc = 32   ' Geselecteerde kleur
DIM SHARED Info$                    ' Welke info weergave bovenin
DIM SHARED Inf AS INTEGER           ' 1 als Info, 0 als geen Info
DIM SHARED Xc AS INTEGER, Yc AS INTEGER
DIM SHARED Contrast, Intensiteit AS INTEGER
DIM SHARED x AS INTEGER, y AS INTEGER
DIM SHARED Schuif.X AS INTEGER, Schuif.Y AS INTEGER
DIM SHARED CellsFile$
DIM SHARED WorldFile$
DIM SHARED MClr(255, 2) AS STRING * 1 ' Kleur waarden in variabele
DIM SHARED Layer AS INTEGER         ' 0 onder en 1 boven de speler
DIM SHARED MemCell(16) AS SINGLE    ' Plak/Kopieer cell
DIM SHARED Plus128(16) AS SINGLE
DIM SHARED RasterC(16) AS SINGLE

Prepair
ShowPointer
Check.Command

DO
  Inf = 0
  a$ = INKEY$
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2

  ' Informatie weergave rechtsbovenin
  IF mx% >= VG.Xmin AND my% >= VG.Ymin AND mx% <= VG.Xmax AND my% <= VG.Ymax THEN Info.VG
  IF mx% >= PW.Xmin AND my% >= PW.Ymin AND mx% <= PW.Xmax AND my% <= PW.Ymax THEN Info.PW
  IF mx% >= AR.Xmin AND my% >= AR.Ymin AND mx% <= AR.Xmax AND my% <= AR.Ymax THEN Info.AR
  IF mx% >= KN.Xmin AND my% >= KN.Ymin AND mx% <= KN.Xmax AND my% <= KN.Ymax THEN Info.KN
  IF mx% >= CS.Xmin AND my% >= CS.Ymin AND mx% <= CS.Xmax AND my% <= CS.Ymax THEN Info.CS
  IF Inf = 0 AND Info$ <> "Geen" THEN
    IF my% < 7 THEN HidePointer
    LINE (150, 1)-(319, 5), 2, BF: Info$ = "Geen"
    IF my% < 7 THEN ShowPointer
  END IF

  ' Muis afhandeling
  IF but% = 1 THEN
    IF mx% >= AR.Xmin AND my% >= AR.Ymin AND mx% <= AR.Xmax AND my% <= AR.Ymax THEN Muis.Putcell
    IF mx% >= PW.Xmin AND my% >= PW.Ymin AND mx% <= PW.Xmax AND my% <= PW.Ymax THEN Muis.ColorSelect
    IF mx% >= VG.Xmin AND my% >= VG.Ymin AND mx% <= VG.Xmax AND my% <= VG.Ymax THEN Muis.Paint
    IF mx% >= CS.Xmin AND my% >= CS.Ymin AND mx% <= CS.Xmax AND my% <= CS.Ymax THEN Muis.CellSelect
    IF Sc > 0 AND mx% >= PW.Xmin - 5 AND my% >= PW.Ymin + 35 AND mx% <= PW.Xmin - 2 AND my% <= PW.Ymax THEN Sc = 0: Chance.Color (Sc)
    IF Sc > 31 AND mx% > MP.Xmin - 2 AND mx% <= MP.Xmin + 64 AND my% >= MP.Y1 - 3 AND my% < MP.Y3 THEN Muis.Mengen
    IF mx% >= KN.Xmin AND my% >= KN.Ymin AND mx% <= KN.Xmax AND my% <= KN.Ymax THEN Muis.PushButton
    IF my% > 8 AND mx% <= AR.Xmax + 1 AND my% < 16 THEN Muis.Misc
  END IF
  IF but% = 2 THEN
    IF mx% >= PW.Xmin AND my% >= PW.Ymin AND mx% <= PW.Xmax AND my% <= PW.Ymax THEN Muis.ColorSelect
    IF mx% >= AR.Xmin AND my% >= AR.Ymin AND mx% <= AR.Xmax AND my% <= AR.Ymax THEN Muis.CellGet
    IF mx% >= VG.Xmin AND my% >= VG.Ymin AND mx% <= VG.Xmax AND my% <= VG.Ymax THEN Muis.ColorGet
    IF mx% >= CS.Xmin AND my% >= CS.Ymin AND mx% <= CS.Xmax AND my% <= CS.Ymax THEN Muis.CellSelect
    IF mx% >= AR.Xmin AND mx% <= AR.Xmax AND my% < AR.Ymin AND my% >= AR.Ymin - 2 THEN Muis.ScrollX
    IF my% >= AR.Ymin AND my% <= AR.Ymax AND mx% < AR.Xmin AND mx% >= AR.Xmin - 2 THEN Muis.ScrollY
  END IF

  ' Toetsen afhandeling
  IF a$ <> "" THEN
    IF a$ = CHR$(27) THEN BottomMessage "Exit"
    IF a$ = CHR$(0) + CHR$(75) AND Schuif.X > 0 THEN Schuif.X = Schuif.X - 1: World.Put                ' Links
    IF a$ = CHR$(0) + CHR$(77) AND Schuif.X < CellsX - AR.Xcll THEN Schuif.X = Schuif.X + 1: World.Put ' Rechts
    IF a$ = CHR$(0) + CHR$(72) AND Schuif.Y > 0 THEN Schuif.Y = Schuif.Y - 1: World.Put                ' Omhoog
    IF a$ = CHR$(0) + CHR$(80) AND Schuif.Y < CellsY - AR.Ycll THEN Schuif.Y = Schuif.Y + 1: World.Put ' Omlaag
    a$ = LCASE$(a$)
    IF a$ = "s" THEN BottomMessage "Save"
    IF a$ = "l" THEN BottomMessage "Load"
    IF a$ = "h" THEN BottomMessage "Help"
    IF a$ = "c" THEN Cells.Copy
    IF a$ = "p" THEN Cells.Paste
  END IF

  'DO: LOOP UNTIL INKEY$ = ""   ' Voorkomt opstapeling toetsen bij langzame computers
  'WAIT &H3DA, 8                ' Dit voorkomt soms geknipper
LOOP

UnforseenError:
ProgramError 0

SUB BottomMessage (thing$)

DIM Ondervak(3521)
HidePointer
GET (0, 156)-(319, 199), Ondervak   ' Dit vak wordt straks weer teruggezet
LINE (0, 157)-(319, 199), 2, BF

SELECT CASE thing$
 
  CASE "Exit"
    FColor 4
    FLocate 5, 166: FPrint "REALLY EXIT? PRESS..."
    FLocate 5, 174: FPrint "Y TO EXIT THIS PROGRAM"
    FLocate 5, 180: FPrint "N TO ADMIT YOUR MISTAKE"
    FLocate 5, 188: FPrint "ESC TO CANCEL"
    ShowPointer
    DO
      a$ = INKEY$
      IF LCASE$(a$) = "y" THEN QuitProg
      IF LCASE$(a$) = "n" THEN EXIT DO
      IF a$ = CHR$(27) THEN EXIT DO
    LOOP
 
  CASE "Save"
    FColor 4
    FLocate 5, 166: FPrint "PRESS..."
    FLocate 5, 174: FPrint "C TO SAVE CELLS"
    FLocate 5, 180: FPrint "W TO SAVE WORLD"
    FLocate 5, 186: FPrint "P TO SAVE PALET"
    FLocate 5, 194: FPrint "ESC TO CANCEL"
    ShowPointer
    DO
      a$ = INKEY$
      IF LCASE$(a$) = "p" THEN Palet.Save: EXIT DO
      IF LCASE$(a$) = "c" THEN Cells.Save: EXIT DO
      IF LCASE$(a$) = "w" THEN World.Save: EXIT DO
      IF a$ = CHR$(27) THEN EXIT DO
    LOOP
 
  CASE "Load"
    FColor 4
    FLocate 5, 166: FPrint "PRESS..."
    FLocate 5, 174: FPrint "C TO LOAD CELLS"
    FLocate 5, 180: FPrint "W TO LOAD WORLD"
    FLocate 5, 186: FPrint "P TO LOAD PALET"
    FLocate 5, 194: FPrint "ESC TO CANCEL"
    ShowPointer
    DO
      a$ = INKEY$
      IF LCASE$(a$) = "c" THEN EXIT DO
      IF LCASE$(a$) = "w" THEN EXIT DO
      IF LCASE$(a$) = "p" THEN EXIT DO
      IF a$ = CHR$(27) THEN EXIT DO
    LOOP
 
  CASE "Help"
    FColor 4
    FLocate 5, 166: FPrint "KEYS:"
    FLocate 5, 174: FPrint "C - COPY SELECTED CELL"
    FLocate 5, 180: FPrint "P - PASTE CELL IN SELECTED CELL"
    FLocate 5, 186: FPrint "ESC - EXIT THIS PROGRAM"
    FLocate 150, 174: FPrint "L - LOAD"
    FLocate 150, 180: FPrint "S - SAVE"
    FLocate 150, 186: FPrint "H - THIS HELP WINDOW"
    ShowPointer
    DO: LOOP WHILE INKEY$ = ""

END SELECT


HidePointer
PUT (0, 156), Ondervak, PSET
ShowPointer
   
IF thing$ = "Load" THEN
  IF LCASE$(a$) = "c" THEN Cells.Load
  IF LCASE$(a$) = "w" THEN World.Open
  IF LCASE$(a$) = "p" THEN Palet.Load
END IF

END SUB

SUB Buildscreen

LINE (0, 7)-(319, 7), 3              ' Bovenbalk
LINE (0, 0)-(319, 6), 2, BF
FLocate 2, 5: FColor 0: FPrint "RPG EDIT  v" + Version
FLocate 1, 5: FColor 4: FPrint "RPG EDIT  v" + Version
LINE (0, 156)-(319, 156), 3          ' Onderbalk
LINE (0, 157)-(319, 199), 2, BF

' Cel vergroting (VG)
LINE (VG.Xmin - 1, VG.Ymin - 1)-(VG.Xmax + 1, VG.Ymax + 1), 1, BF
Get.Cell Xc, Yc

' Knoppen voor draaien en spiegelen
FOR x = 0 TO 2
  LINE (KN.Xmin + x * 10, KN.Ymin)-(KN.Xmin + x * 10 + 9 - 1, KN.Ymin + 9 - 1), 3, B
  LINE (KN.Xmin + x * 10 + 1, KN.Ymin + 1)-(KN.Xmin + x * 10 + 9, KN.Ymin + 9), 1, B
  LINE (KN.Xmin + x * 10 + 1, KN.Ymin + 1)-(KN.Xmin + x * 10 + 9 - 1, KN.Ymin + 9 - 1), 2, BF
  PSET (KN.Xmin + x * 10 + 2, KN.Ymin + 2), 2
  SELECT CASE x
    CASE 0: DRAW "BDC3EFLD4BR3C1EL2EU3"
    CASE 1: DRAW "BDC3R4UFGBFBDC1L3HD2H"
    CASE 2: DRAW "C3R2D2HGDFBFBRC1U2FDRBU2UH"
  END SELECT
NEXT x

' Knoppen om tussen de layers te switchen
LINE (0, 9)-(AR.Xmax + 1, 15), 1, BF
LINE (0, 9)-(22, 15), 2, BF
LINE (25, 9)-(29, 15), 2, BF
LINE (31, 9)-(35, 15), 2, BF
LINE (AR.Xmax - 3, 9)-(AR.Xmax + 1, 15), 2, BF
FLocate 1, 14: FColor 3: FPrint "LAYER:"
IF Layer = 0 THEN
  FLocate 26, 14: FColor 4: FPrint "1"
  FLocate 32, 14: FColor 3: FPrint "2"
END IF
IF Layer = 1 THEN
  FLocate 26, 14: FColor 3: FPrint "1"
  FLocate 32, 14: FColor 4: FPrint "2"
END IF
FLocate AR.Xmax - 2, 14: FColor 3: FPrint ">"

' Cellen-weergave-omlijning
FOR x = 0 TO 15
  FOR y = 0 TO 15
    LINE (CS.Xmin + x * 9 - 1, CS.Ymin + y * 9 - 1)-(CS.Xmin + 8 + x * 9, CS.Ymin + 8 + y * 9), 1, B
  NEXT y
NEXT x
LINE (CS.Xmin + Xc * 9 - 1, CS.Ymin + Yc * 9 - 1)-(CS.Xmin + 8 + Xc * 9, CS.Ymin + 8 + Yc * 9), 2, B

' Palette Hokjes
LINE (PW.Xmin - 1, PW.Ymin - 1)-(PW.Xmax + 1, PW.Ymax + 1), 1, BF
FOR x = PW.From TO PW.To
  FOR y = 0 TO 7
    LINE (PW.Xmin + 5 * (x - PW.From), PW.Ymin + 5 * y)-(PW.Xmin + 3 + 5 * (x - PW.From), PW.Ymin + 3 + 5 * y), 8 * x + y, BF
    IF 8 * x + y < 16 THEN LINE (160 + 5 * x, 160 + 5 * y)-(163 + 5 * x, 163 + 5 * y), 0
  NEXT y
NEXT x
LINE (PW.Xmin - 6, PW.Ymin + 34)-(PW.Xmin - 1, PW.Ymax + 1), 1, B
LINE (PW.Xmin - 5, PW.Ymin + 35)-(PW.Xmin - 2, PW.Ymax), 0, BF
LINE (PW.Xmin - 5, PW.Ymin + 35)-(PW.Xmin - 2, PW.Ymax), 1
LINE (PW.Xmin - 5, PW.Ymax)-(PW.Xmin - 2, PW.Ymin + 35), 1

' Mengpaneeltje
LINE (MP.Xmin - 1, MP.Y1)-(MP.Xmin + 64, MP.Y1), 5
LINE (MP.Xmin - 1, MP.Y2)-(MP.Xmin + 64, MP.Y2), 6
LINE (MP.Xmin - 1, MP.Y3)-(MP.Xmin + 64, MP.Y3), 7
LINE (MP.Xmin - 1, MP.Y1 + 1)-(MP.Xmin + 64, MP.Y1 + 1), 1, BF
LINE (MP.Xmin - 1, MP.Y2 + 1)-(MP.Xmin + 64, MP.Y2 + 1), 1, BF
LINE (MP.Xmin - 1, MP.Y3 + 1)-(MP.Xmin + 64, MP.Y3 + 1), 1, BF
Chance.Color Sc

END SUB

SUB Cells.Copy
                            
HidePointer
GET (CS.Xmin + Xc * 9, CS.Ymin + Yc * 9)-(CS.Xmin + 7 + Xc * 9, CS.Ymin + 7 + Yc * 9), MemCell
ShowPointer
'                       Geselecteerde cell gaat in variabele MemCell
END SUB

SUB Cells.Load

DEF SEG = VARSEG(Cell(0, 0))        ' Vanuit bestand direct naar geheugen
BLOAD CellsFile$, VARPTR(Cell(0, 0))
HidePointer
FOR x = 0 TO 15                     ' Nieuwe cellen op het scherm zetten
  FOR y = 0 TO 15
    PUT (CS.Xmin + x * 9, CS.Ymin + y * 9), Cell(0, 16 * y + x), PSET
  NEXT y
NEXT x
World.Put                           ' Wereld opnieuw tekenen
Get.Cell Xc, Yc                     ' Opnieuw geselecteerde cel uitvergroten
ShowPointer

END SUB

SUB Cells.Paste

HidePointer
PUT (CS.Xmin + Xc * 9, CS.Ymin + Yc * 9), MemCell, PSET
GET (CS.Xmin + Xc * 9, CS.Ymin + Yc * 9)-(CS.Xmin + 7 + Xc * 9, CS.Ymin + 7 + Yc * 9), Cell(0, 16 * Yc + Xc)
Get.Cell Xc, Yc
ShowPointer
Cells.Update (16 * Yc + Xc)
'                       Geselecteerde cell wordt cell in variabele MemCell
END SUB

SUB Cells.Save

HidePointer
FOR x = 0 TO 15                     ' Zorgen dat de cellen in geheugen
  FOR y = 0 TO 15                   ' recent zijn
    GET (CS.Xmin + x * 9, CS.Ymin + y * 9)-(CS.Xmin + 7 + x * 9, CS.Ymin + 7 + y * 9), Cell(0, 16 * y + x)
  NEXT y
NEXT x
ShowPointer
DEF SEG = VARSEG(Cell(0, 0))        ' Vanuit geheugen direct naar bestand
BSAVE CellsFile$, VARPTR(Cell(0, 0)), 17408       ' 17 * 256 * 4 = 17408

END SUB

SUB Cells.Update (SCell%)

  FOR x = 0 TO (AR.Xcll - 1)
    FOR y = 0 TO (AR.Ycll - 1)
      Layer0Cell% = ASC(MCell(0, x + Schuif.X, y + Schuif.Y))
      Layer1Cell% = ASC(MCell(1, x + Schuif.X, y + Schuif.Y))
      IF Layer1Cell% >= 208 AND Layer1Cell% <= 223 THEN AndCell% = Layer1Cell% + 32
      IF Layer1Cell% >= 224 AND Layer1Cell% <= 239 THEN AndCell% = Layer1Cell% + 16
 
      IF Layer0Cell% = SCell% OR Layer1Cell% = SCell% OR AndCell% = SCell% THEN
        IF Layer1Cell% = 0 OR Layer1Cell% >= 208 THEN
          PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer0Cell%), PSET
          IF Layer = 1 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), RasterC(0), AND
        END IF

        IF Layer1Cell% > 0 THEN
          IF AndCell% > 0 THEN
            PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, AndCell%), AND
            PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%), OR
          ELSE
            PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%), PSET
          END IF
          IF Layer = 0 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), RasterC(0), AND
          AndCell% = 0
        END IF
        'IF x < 1 OR y < 1 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Plus128(0), XOR
      END IF
    NEXT y
  NEXT x

END SUB

SUB Chance.Color (Col%)

' Nieuwe instellingen van de kleur doorvoeren
  OUT &H3C8, Col%
  OUT &H3C9, ASC(MClr(Col%, 0))
  OUT &H3C9, ASC(MClr(Col%, 1))
  OUT &H3C9, ASC(MClr(Col%, 2))
  IF Col% < 128 THEN
    OUT &H3C8, Col% + 128
    OUT &H3C9, CINT(ASC(MClr(Col%, 0)) / 2)
    OUT &H3C9, CINT(ASC(MClr(Col%, 1)) / 2)
    OUT &H3C9, CINT(ASC(MClr(Col%, 2)) / 2)
  END IF
    
' Mengpaneeltje updaten
  HidePointer
   LINE (MP.Xmin + 65, MP.Y1 - 4)-(MP.Xmin + 73, MP.Y1 + 1), 2, BF
   FColor 1: FLocate MP.Xmin + 63, MP.Y1 + 1: FPrint STR$(ASC(MClr(Sc, 0)))
  FColor 5: FLocate MP.Xmin + 63, MP.Y1: FPrint STR$(ASC(MClr(Sc, 0)))
  LINE (MP.Xmin - 1, MP.Y1 - 3)-(MP.Xmin + 64, MP.Y1 - 1), 2, BF
  FColor 4: FLocate MP.Xmin + ASC(MClr(Sc, 0)) - 1, MP.Y1 - 1: FPrint "^"
 
   LINE (MP.Xmin + 65, MP.Y2 - 4)-(MP.Xmin + 73, MP.Y2 + 1), 2, BF
   FColor 1: FLocate MP.Xmin + 63, MP.Y2 + 1: FPrint STR$(ASC(MClr(Sc, 1)))
  FColor 6: FLocate MP.Xmin + 63, MP.Y2: FPrint STR$(ASC(MClr(Sc, 1)))
  LINE (MP.Xmin - 1, MP.Y2 - 3)-(MP.Xmin + 64, MP.Y2 - 1), 2, BF
  FColor 4: FLocate MP.Xmin + ASC(MClr(Sc, 1)) - 1, MP.Y2 - 1: FPrint "^"
 
   LINE (MP.Xmin + 65, MP.Y3 - 4)-(MP.Xmin + 73, MP.Y3 + 1), 2, BF
   FColor 1: FLocate MP.Xmin + 63, MP.Y3 + 1: FPrint STR$(ASC(MClr(Sc, 2)))
  FColor 7: FLocate MP.Xmin + 63, MP.Y3: FPrint STR$(ASC(MClr(Sc, 2)))
  LINE (MP.Xmin - 1, MP.Y3 - 3)-(MP.Xmin + 64, MP.Y3 - 1), 2, BF
  FColor 4: FLocate MP.Xmin + ASC(MClr(Sc, 2)) - 1, MP.Y3 - 1: FPrint "^"
  ShowPointer

END SUB

SUB Check.Command

IF COMMAND$ > "" THEN
  ComFile$ = LCASE$(COMMAND$)

  SHELL "DIR DATA\*.FLD /B /L /ON >DIR.TMP"    ' Bestand met FLD-lijst maken
  OPEN "DIR.TMP" FOR INPUT AS #1
  Succes% = 0
  DO UNTIL EOF(1)                              ' Bestanden inlezen
    INPUT #1, File$
    IF ComFile$ = File$ THEN Succes% = 1: EXIT DO
    IF ComFile$ = LEFT$(File$, INSTR(File$, ".") - 1) THEN Succes% = 1: ComFile$ = ComFile$ + ".FLD": EXIT DO
  LOOP
  CLOSE #1
  KILL "DIR.TMP"

  IF Succes% = 1 THEN
    WorldFile$ = "DATA\" + ComFile$
    World.Load
  ELSE
    World.Open
  END IF
ELSE
  World.Open
END IF

END SUB

SUB EditingMode

AR.Xmin = 1:  AR.Ymin = 18
AR.Xcll = 33: AR.Ycll = 22
AR.Xmax = AR.Xmin + AR.Xcll * 8 - 1
AR.Ymax = AR.Ymin + AR.Ycll * 8 - 1
IF Schuif.X > CellsX - AR.Xcll THEN Schuif.X = CellsX - AR.Xcll
IF Schuif.Y > CellsY - AR.Ycll THEN Schuif.Y = CellsY - AR.Ycll

' Scherm ombouwen
HidePointer
LINE (0, 158)-(319, AR.Ymax + 2), 0, BF       ' Brede onderbalk weghalen
LINE (CS.Xmin - 1, CS.Ymin - 1)-(319, 199), 0, BF  ' Cellen-weergave weghalen
LINE (0, AR.Ymax + 3)-(319, 199), 1, BF
LINE (AR.Xmax + 3, 17)-(319, AR.Ymax + 1), 1, BF
LINE (0, 9)-(319, 15), 1, BF
LINE (319 - 4, 9)-(319, 15), 2, BF
FLocate 319 - 3, 14: FColor 3: FPrint "<"
FLocate 1, 14: FColor 2: FPrint "PREVIEW MODE"  'TRIGGER-EDITING
PLayer% = Layer: Layer = 3
World.Put
ShowPointer

DO  ' Wachten tot de muisknop is losgelaten
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
LOOP WHILE but% > 0

DO
  Inf = 0
  a$ = INKEY$
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
 
  ' Informatie weergave rechtsbovenin
  IF mx% >= AR.Xmin AND my% >= AR.Ymin AND mx% <= AR.Xmax AND my% <= AR.Ymax THEN Info.Triggers
  IF Inf = 0 AND Info$ <> "Geen" THEN
    IF my% < 7 THEN HidePointer
    LINE (150, 1)-(319, 5), 2, BF: Info$ = "Geen"
    IF my% < 7 THEN ShowPointer
  END IF
 
  ' Muis afhandeling
  IF but% = 1 THEN
    IF mx% >= 319 - 4 AND mx% <= 319 AND my% > 8 AND my% < 16 THEN EXIT DO
  END IF
  IF but% = 2 THEN
    IF mx% >= AR.Xmin AND mx% <= AR.Xmax AND my% < AR.Ymin AND my% >= AR.Ymin - 2 THEN Muis.ScrollX
    IF my% >= AR.Ymin AND my% <= AR.Ymax AND mx% < AR.Xmin AND mx% >= AR.Xmin - 2 THEN Muis.ScrollY
  END IF
 
  ' Toetsen afhandeling
  IF a$ <> "" THEN
    IF a$ = CHR$(27) THEN EXIT DO
    IF a$ = CHR$(0) + CHR$(75) AND Schuif.X > 0 THEN Schuif.X = Schuif.X - 1: World.Put                ' Links
    IF a$ = CHR$(0) + CHR$(77) AND Schuif.X < CellsX - AR.Xcll THEN Schuif.X = Schuif.X + 1: World.Put ' Rechts
    IF a$ = CHR$(0) + CHR$(72) AND Schuif.Y > 0 THEN Schuif.Y = Schuif.Y - 1: World.Put                ' Omhoog
    IF a$ = CHR$(0) + CHR$(80) AND Schuif.Y < CellsY - AR.Ycll THEN Schuif.Y = Schuif.Y + 1: World.Put ' Omlaag
  END IF
 
  'DO: LOOP UNTIL INKEY$ = ""       ' Voorkomt opstapeling van toetsen voor langzame computers
  'WAIT &H3DA, 8                    ' Dit voorkomt soms geknipper
LOOP

' Scherm terugbouwen
Layer = PLayer%
Set.Variables
HidePointer
LINE (0, AR.Ymax + 2)-(319, 155), 0, BF  ' Ruimte voor onderbalk
LINE (AR.Xmax + 2, 8)-(319, 155), 0, BF  ' Ruimte voor cellen-weergave
FOR x = 0 TO 15                     ' Cellen op het scherm zetten
  FOR y = 0 TO 15
    PUT (CS.Xmin + x * 9, CS.Ymin + y * 9), Cell(0, 16 * y + x), PSET
  NEXT y
NEXT x
Buildscreen
World.Put
ShowPointer

DO  ' Wachten tot de muisknop is losgelaten
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
LOOP WHILE but% > 0

END SUB

SUB FColor (Clr%)

IF Clr% < 0 OR Clr% > 255 THEN ProgramError 2
FClr = "C" + MID$(STR$(Clr%), 2, 3)

END SUB

SUB FInit

' Lettertype inladen...
OPEN "DATA\STANDARD.LTT" FOR INPUT AS #1    ' Lettertype inladen
DO UNTIL EOF(1)
  LINE INPUT #1, DrawRegel$
  IF LEN(DrawRegel$) > 2 THEN
    Char% = ASC(LEFT$(DrawRegel$, 1))
    Letter(Char%) = RIGHT$(DrawRegel$, LEN(DrawRegel$) - 4)
    Lengte(Char%) = CHR$(VAL(RIGHT$(LEFT$(DrawRegel$, 4), 2)))
  END IF
LOOP
CLOSE #1

FSize 1                                     ' Beginwaarden instellen
FColor 7
FRotate 0
FWindow 0, 0, 319, 199
FLocate 1, 5

END SUB

FUNCTION FLenght% (zin$)
DIM LTeken AS STRING * 1

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)

FOR TekenNummer% = 1 TO LEN(zin$)
  LTeken = MID$(zin$, TekenNummer%, 1)
  Lenght% = Lenght% + ASC(Lengte(ASC(LTeken))) * TekenBg%
NEXT TekenNummer%

FLenght% = Lenght%

END FUNCTION

SUB FLocate (x%, y%)

Lib.Xco% = x%
Lib.Yco% = y%

END SUB

SUB FPrint (zin$)
DIM Teken AS STRING * 1

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)
Lib.Yc% = Lib.Yco% - 4 * TekenBg%
PSET (Lib.Xco%, Lib.Yc%), POINT(Lib.Xco%, Lib.Yc%)
DRAW FClr + FSze + FAngle                ' Juiste lettertype instellen

FOR TekenNummer% = 1 TO LEN(zin$)
  Teken = MID$(zin$, TekenNummer%, 1)    ' Teken uit de string halen
  DRAW Letter(ASC(Teken))                ' Teken op het scherm zetten

  Lib.Xco% = Lib.Xco% + 4 * TekenBg%     ' Nieuwe positie op scherm berekenen
   IF LCASE$(Teken) = "i" OR Teken = "!" OR Teken = "'" OR Teken = "l" OR Teken = "." OR Teken = ";" THEN Lib.Xco% = Lib.Xco% - 2 * TekenBg%
    IF LCASE$(Teken) = "m" OR LCASE$(Teken) = "w" THEN Lib.Xco% = Lib.Xco% + 2 * TekenBg%
     IF Teken = "t" OR Teken = "J" THEN Lib.Xco% = Lib.Xco% - TekenBg%
NEXT TekenNummer%

END SUB

SUB FRotate (Degrees%)

IF Degrees% < -360 OR Degrees% > 360 THEN ProgramError 3
FAngle = "TA" + MID$(STR$(Degrees%), 1, 3)
IF MID$(FAngle, 1, 1) = " " THEN FAngle = MID$(FAngle, 2, 3)
 
END SUB

SUB FSize (Size%)

IF Size% < 1 THEN ProgramError 1
FSze = "S" + MID$(STR$(Size% * 4), 2, 3)

END SUB

SUB FWindow (Xmin%, Ymin%, Xmax%, Ymax%)
' Deze sub doet nog niet veel
END SUB

SUB Get.Cell (Xc%, Yc%)

' Vergroting tekenen
FOR x = 0 TO VG.X - 1
  FOR y = 0 TO VG.Y - 1
    Pc% = POINT(CS.Xmin + Xc * 9 + x, CS.Ymin + Yc * 9 + y)
    MPunt(x, y) = Pc%
  NEXT y
NEXT x
FOR x = 0 TO VG.X - 1
  FOR y = 0 TO VG.Y - 1
    LINE (VG.Xmin + VG.Size * x, VG.Ymin + VG.Size * y)-(VG.Xmin - 2 + VG.Size * (x + 1), VG.Ymin - 2 + VG.Size * (y + 1)), MPunt(x, y), BF
    IF MPunt(x, y) = 0 THEN
      LINE (VG.Xmin + VG.Size * x, VG.Ymin + VG.Size * y)-(VG.Xmin - 2 + VG.Size * (x + 1), VG.Ymin - 2 + VG.Size * (y + 1)), 1
      LINE (VG.Xmin + VG.Size * x, VG.Ymin - 2 + VG.Size * (y + 1))-(VG.Xmin - 2 + VG.Size * (x + 1), VG.Ymin + VG.Size * y), 1
    END IF
  NEXT y
NEXT x

END SUB

SUB Info.AR
DIM wx AS INTEGER, wy AS INTEGER, wc AS INTEGER
Inf = 1

wx = INT((mx% - AR.Xmin) / 8) + Schuif.X  ' Rekenen op welke x en y de muis is
wy = INT((my% - AR.Ymin) / 8) + Schuif.Y
IF Layer < 3 THEN wc = ASC(MCell(Layer, wx, wy))

IF Info$ <> "AR" THEN
  LINE (200, 1)-(319, 5), 2, BF
  FColor 3
  FLocate 220, 5: FPrint "X:"
  FLocate 250, 5: FPrint "Y:"
  IF Layer < 3 THEN FLocate 284, 5: FPrint "CELL:"
  Info$ = "AR"
  FColor 4
  FLocate 225, 5: FPrint STR$(wx)
  FLocate 255, 5: FPrint STR$(wy)
  IF Layer < 3 THEN FLocate 304, 5: FPrint STR$(wc)
END IF

FColor 4
IF Iwx <> wx THEN LINE (225, 1)-(249, 5), 2, BF: FLocate 225, 5: FPrint STR$(wx): Iwx = wx
IF Iwy <> wy THEN LINE (255, 1)-(283, 5), 2, BF: FLocate 255, 5: FPrint STR$(wy): Iwy = wy
IF Layer < 3 AND Iwc <> wc THEN LINE (304, 1)-(318, 5), 2, BF: FLocate 304, 5: FPrint STR$(wc): Iwc = wc

END SUB

SUB Info.CS
Inf = 1

x = INT((mx% - CS.Xmin) / 9)            ' Uitrekenen boven welke cel de muis zit
y = INT((my% - CS.Ymin) / 9)
VCell = 16 * y + x
Cn$ = STR$(VCell)

IF Info$ <> "CS" THEN
  LINE (200, 1)-(319, 5), 2, BF
  FColor 3: FLocate 284, 5: FPrint "CELL:"
  Info$ = "CS"
  ICell = -1
END IF

IF ICell <> VCell THEN
  LINE (304, 1)-(318, 5), 2, BF          ' Vorig getal wissen
  FColor 4: FLocate 304, 5: FPrint Cn$   ' Nieuwe ervoor in de plaats
  ICell = VCell
END IF

END SUB

SUB Info.KN
Inf = 1

x = INT((mx% - KN.Xmin) / 10)       ' Uitrekenen boven welke knop de muis zit
Knop$ = STR$(x)

IF Info$ <> Knop$ THEN
  SELECT CASE x
    CASE 0: TopInfo$ = "FLIP CELL VERTICALLY"
    CASE 1: TopInfo$ = "FLIP CELL HORIZONTALLY"
    CASE 2: TopInfo$ = "ROTATE CELL 90 DEGREES TO THE RIGHT"
  END SELECT
  FColor 3: FLocate 319 - FLenght(TopInfo$), 5
  LINE (100, 1)-(319, 5), 2, BF: FPrint TopInfo$
  Info$ = Knop$
END IF

END SUB

SUB Info.PW
Inf = 1

x = INT((mx% - PW.Xmin) / 5)            ' Rekenen boven welke kleur de muis zit
y = INT((my% - PW.Ymin) / 5)
VKleur = 8 * (x + PW.From) + y
Ch$ = STR$(VKleur)

IF Info$ <> "PW" THEN
  LINE (200, 1)-(319, 5), 2, BF
  FColor 3: FLocate 280, 5: FPrint "COLOR:"
  IKleur = -1
  Info$ = "PW"
END IF

IF IKleur <> VKleur THEN
  LINE (304, 1)-(318, 5), 2, BF         ' Vorig getal wissen
  FColor 4: FLocate 304, 5: FPrint Ch$  ' Nieuwe ervoor in de plaats
  IKleur = VKleur
END IF

END SUB

SUB Info.Triggers
DIM wx AS INTEGER, wy AS INTEGER
Inf = 1

wx = INT((mx% - AR.Xmin) / 8) + Schuif.X  ' Rekenen op welke x en y de muis is
wy = INT((my% - AR.Ymin) / 8) + Schuif.Y

IF Info$ <> "Triggers" THEN
  LINE (200, 1)-(319, 5), 2, BF
  FColor 3
  FLocate 220, 5: FPrint "X:"
  FLocate 250, 5: FPrint "Y:"
  Info$ = "Triggers"
  FColor 4
  FLocate 225, 5: FPrint STR$(wx)
  FLocate 255, 5: FPrint STR$(wy)
END IF

FColor 4
IF Iwx <> wx THEN LINE (225, 1)-(249, 5), 2, BF: FLocate 225, 5: FPrint STR$(wx): Iwx = wx
IF Iwy <> wy THEN LINE (255, 1)-(283, 5), 2, BF: FLocate 255, 5: FPrint STR$(wy): Iwy = wy

END SUB

SUB Info.VG
Inf = 1

x = INT((mx% - VG.Xmin) / VG.Size)              ' Rekenen boven welke x en y de muis is
y = INT((my% - VG.Ymin) / VG.Size)
c = MPunt(x, y)

IF Info$ <> "VG" THEN
  LINE (200, 1)-(319, 5), 2, BF
  FColor 3
  FLocate 220, 5: FPrint "X:"
  FLocate 250, 5: FPrint "Y:"
  FLocate 280, 5: FPrint "COLOR:"
  Info$ = "VG"
  FColor 4
  FLocate 225, 5: FPrint STR$(x)
  FLocate 255, 5: FPrint STR$(y)
  FLocate 304, 5: FPrint STR$(c)
END IF

FColor 4
IF Ix <> x THEN LINE (225, 1)-(249, 5), 2, BF: FLocate 225, 5: FPrint STR$(x): Ix = x
IF Iy <> y THEN LINE (255, 1)-(279, 5), 2, BF: FLocate 255, 5: FPrint STR$(y): Iy = y
IF Ic <> c THEN LINE (304, 1)-(318, 5), 2, BF: FLocate 304, 5: FPrint STR$(c): Ic = c

END SUB

SUB Muis.CellGet

x = INT((mx% - AR.Xmin) / 8) + Schuif.X
y = INT((my% - AR.Ymin) / 8) + Schuif.Y
CellNr% = ASC(MCell(Layer, x, y))

IYc = Yc: IXc = Xc
Yc = INT(CellNr% / 16)
CellNr% = CellNr% - Yc * 16
Xc = CellNr%

IF IXc <> Xc OR IYc <> Yc THEN
  HidePointer
  LINE (CS.Xmin + IXc * 9 - 1, CS.Ymin + IYc * 9 - 1)-(CS.Xmin + 8 + IXc * 9, CS.Ymin + 8 + IYc * 9), 1, B
  LINE (CS.Xmin + Xc * 9 - 1, CS.Ymin + Yc * 9 - 1)-(CS.Xmin + 8 + Xc * 9, CS.Ymin + 8 + Yc * 9), 2, B
  Get.Cell Xc, Yc
  ShowPointer
END IF

END SUB

SUB Muis.CellSelect

IXc = Xc: Xc = INT((mx% - CS.Xmin) / 9)
IYc = Yc: Yc = INT((my% - CS.Ymin) / 9)

IF IXc <> Xc OR IYc <> Yc THEN
  HidePointer
  LINE (CS.Xmin + IXc * 9 - 1, CS.Ymin + IYc * 9 - 1)-(CS.Xmin + 8 + IXc * 9, CS.Ymin + 8 + IYc * 9), 1, B
  LINE (CS.Xmin + Xc * 9 - 1, CS.Ymin + Yc * 9 - 1)-(CS.Xmin + 8 + Xc * 9, CS.Ymin + 8 + Yc * 9), 2, B
  Get.Cell Xc, Yc                   ' Nieuw geselecteerde cel uitvergroten
  ShowPointer
END IF

END SUB

SUB Muis.ColorGet

x = INT((mx% - VG.Xmin) / VG.Size)
y = INT((my% - VG.Ymin) / VG.Size)

IF Sc <> MPunt(x, y) THEN
  Sc = MPunt(x, y)
  HidePointer
  Chance.Color (Sc)
  ShowPointer
END IF

END SUB

SUB Muis.ColorSelect

ISc = Sc
x = INT((mx% - PW.Xmin) / 5)
y = INT((my% - PW.Ymin) / 5)
Sc = 8 * (x + PW.From) + y
IF ISc <> Sc THEN Chance.Color (Sc)

END SUB

SUB Muis.Mengen

x% = mx%: y% = my%

IF my% < MP.Y1 THEN
  DO
    Kl% = x% - MP.Xmin
    IF Kl% < 0 THEN Kl% = 0
    IF Kl% > 63 THEN Kl% = 63
    IF Kl% <> ASC(MClr(Sc, 0)) THEN
      MClr(Sc, 0) = CHR$(Kl%)
      Chance.Color (Sc)
    END IF
    CALL GetButtonM(but%, x%, y%): x% = x% / 2
  LOOP UNTIL but% = 0
END IF
IF my% > MP.Y2 - 4 AND my% < MP.Y2 THEN
  DO
    Kl% = x% - MP.Xmin
    IF Kl% < 0 THEN Kl% = 0
    IF Kl% > 63 THEN Kl% = 63
    IF Kl% <> ASC(MClr(Sc, 1)) THEN
      MClr(Sc, 1) = CHR$(Kl%)
      Chance.Color (Sc)
    END IF
    CALL GetButtonM(but%, x%, y%): x% = x% / 2
  LOOP UNTIL but% = 0
END IF
IF my% > MP.Y3 - 4 THEN
  DO
    Kl% = x% - MP.Xmin
    IF Kl% < 0 THEN Kl% = 0
    IF Kl% > 63 THEN Kl% = 63
    IF Kl% <> ASC(MClr(Sc, 2)) THEN
      MClr(Sc, 2) = CHR$(Kl%)
      Chance.Color (Sc)
    END IF
    CALL GetButtonM(but%, x%, y%): x% = x% / 2
  LOOP UNTIL but% = 0
END IF

END SUB

SUB Muis.Misc

IF mx% > 24 AND mx% < 30 THEN
  PrevLayer = Layer
  Layer = 0
  IF PrevLayer <> Layer THEN
    HidePointer
    FLocate 26, 14: FColor 4: FPrint "1"
    FLocate 32, 14: FColor 3: FPrint "2"
    ShowPointer
    World.Put
  END IF
END IF
IF mx% > 30 AND mx% < 36 THEN
  PrevLayer = Layer
  Layer = 1
  IF PrevLayer <> Layer THEN
    HidePointer
    FLocate 26, 14: FColor 3: FPrint "1"
    FLocate 32, 14: FColor 4: FPrint "2"
    ShowPointer
    World.Put
  END IF
END IF
IF mx% >= AR.Xmax - 3 AND mx% <= AR.Xmax + 1 THEN
  EditingMode
  EXIT SUB
END IF

END SUB

SUB Muis.Paint

x = INT((mx% - VG.Xmin) / VG.Size)
y = INT((my% - VG.Ymin) / VG.Size)

IF Sc <> MPunt(x, y) THEN
  HidePointer
  LINE (VG.Xmin + VG.Size * x, VG.Ymin + VG.Size * y)-(VG.Xmin - 2 + VG.Size * (x + 1), VG.Ymin - 2 + VG.Size * (y + 1)), Sc, BF
  IF Sc = 0 THEN
      LINE (VG.Xmin + VG.Size * x, VG.Ymin + VG.Size * y)-(VG.Xmin - 2 + VG.Size * (x + 1), VG.Ymin - 2 + VG.Size * (y + 1)), 1
      LINE (VG.Xmin + VG.Size * x, VG.Ymin - 2 + VG.Size * (y + 1))-(VG.Xmin - 2 + VG.Size * (x + 1), VG.Ymin + VG.Size * y), 1
  END IF
  ShowPointer
 
  MPunt(x, y) = Sc
  PSET (CS.Xmin + Xc * 9 + x, CS.Ymin + Yc * 9 + y), Sc
  GET (CS.Xmin + Xc * 9, CS.Ymin + Yc * 9)-(CS.Xmin + 7 + Xc * 9, CS.Ymin + 7 + Yc * 9), Cell(0, 16 * Yc + Xc)
  Cells.Update (16 * Yc + Xc)
END IF

END SUB

SUB Muis.PushButton

Knop = INT((mx% - KN.Xmin) / 10)    ' Uitrekenen boven welke knop de muis zit

' Knop indrukken
HidePointer
LINE (KN.Xmin + Knop * 10, KN.Ymin)-(KN.Xmin + Knop * 10 + 9 - 1, KN.Ymin + 9 - 1), 1, B
LINE (KN.Xmin + Knop * 10 + 1, KN.Ymin + 1)-(KN.Xmin + Knop * 10 + 9, KN.Ymin + 9), 3, B
LINE (KN.Xmin + Knop * 10 + 1, KN.Ymin + 1)-(KN.Xmin + Knop * 10 + 9 - 1, KN.Ymin + 9 - 1), 2, B

SELECT CASE Knop
  CASE 0
    FOR x = 0 TO VG.X - 1
      FOR y = 0 TO VG.Y - 1
        PSET (CS.Xmin + Xc * 9 + x, CS.Ymin + Yc * 9 + y), MPunt(x, VG.Y - y - 1)
      NEXT y
    NEXT x
  CASE 1
    FOR x = 0 TO VG.X - 1
      FOR y = 0 TO VG.Y - 1
        PSET (CS.Xmin + Xc * 9 + x, CS.Ymin + Yc * 9 + y), MPunt(VG.X - x - 1, y)
      NEXT y
    NEXT x
  CASE 2
    FOR x = 0 TO VG.X - 1
      FOR y = 0 TO VG.Y - 1
        PSET (CS.Xmin + Xc * 9 + x, CS.Ymin + Yc * 9 + y), MPunt(y, VG.Y - x - 1)
      NEXT y
    NEXT x
END SELECT

GET (CS.Xmin + Xc * 9, CS.Ymin + Yc * 9)-(CS.Xmin + 7 + Xc * 9, CS.Ymin + 7 + Yc * 9), Cell(0, 16 * Yc + Xc)
Get.Cell Xc, Yc
Cells.Update (16 * Yc + Xc)
ShowPointer

DO
  a$ = INKEY$
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
  IF a$ <> "" THEN
    IF a$ = CHR$(0) + CHR$(75) AND Schuif.X > 0 THEN Schuif.X = Schuif.X - 1: World.Put                ' Links
    IF a$ = CHR$(0) + CHR$(77) AND Schuif.X < CellsX - AR.Xcll THEN Schuif.X = Schuif.X + 1: World.Put ' Rechts
    IF a$ = CHR$(0) + CHR$(72) AND Schuif.Y > 0 THEN Schuif.Y = Schuif.Y - 1: World.Put                ' Omhoog
    IF a$ = CHR$(0) + CHR$(80) AND Schuif.Y < CellsY - AR.Ycll THEN Schuif.Y = Schuif.Y + 1: World.Put ' Omlaag
  END IF
LOOP UNTIL but% = 0

' Knop weer omhoog
HidePointer
LINE (KN.Xmin + Knop * 10, KN.Ymin)-(KN.Xmin + Knop * 10 + 9 - 1, KN.Ymin + 9 - 1), 3, B
LINE (KN.Xmin + Knop * 10 + 1, KN.Ymin + 1)-(KN.Xmin + Knop * 10 + 9, KN.Ymin + 9), 1, B
LINE (KN.Xmin + Knop * 10 + 1, KN.Ymin + 1)-(KN.Xmin + Knop * 10 + 9 - 1, KN.Ymin + 9 - 1), 2, B
ShowPointer

END SUB

SUB Muis.Putcell
DIM IMCell AS INTEGER
DIM Sx AS INTEGER, Sy AS INTEGER

x = INT((mx% - AR.Xmin) / 8)
y = INT((my% - AR.Ymin) / 8)
CellNr% = 16 * Yc + Xc
Sx = x + Schuif.X
Sy = y + Schuif.Y

IMCell = ASC(MCell(Layer, Sx, Sy))
MCell(Layer, Sx, Sy) = CHR$(CellNr%)

IF IMCell <> ASC(MCell(Layer, Sx, Sy)) THEN
  Layer0Cell% = ASC(MCell(0, Sx, Sy))
  Layer1Cell% = ASC(MCell(1, Sx, Sy))
  HidePointer
   
  PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer0Cell%), PSET
  IF Layer = 1 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), RasterC(0), AND
 
  IF Layer1Cell% > 0 THEN
    IF Layer1Cell% >= 208 AND Layer1Cell% <= 223 THEN AndCell% = Layer1Cell% + 32
    IF Layer1Cell% >= 224 AND Layer1Cell% <= 239 THEN AndCell% = Layer1Cell% + 16
    IF AndCell% > 0 THEN
      PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, AndCell%), AND
      PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%), OR
    ELSE
      PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%), PSET
    END IF
    IF Layer = 0 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), RasterC(0), AND
    AndCell% = 0
  END IF
  'IF x < 1 OR y < 1 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Plus128(0), XOR
  ShowPointer
END IF

END SUB

SUB Muis.ScrollX

x% = mx%: y% = my%
DO
  Sch% = Schuif.X
  Schuif.X = ((x% - AR.Xmin) / (AR.Xmax - AR.Xmin)) * CellsX - CINT(AR.Xcll / 2)
  IF Schuif.X < 0 THEN Schuif.X = 0
  IF Schuif.X > CellsX - AR.Xcll THEN Schuif.X = CellsX - AR.Xcll

  IF Schuif.X <> Sch% THEN World.Put
  CALL GetButtonM(but%, x%, y%): x% = x% / 2
LOOP UNTIL but% < 2

END SUB

SUB Muis.ScrollY

x% = mx%: y% = my%
DO
  Sch% = Schuif.Y
  Schuif.Y = ((y% - AR.Ymin) / (AR.Ymax - AR.Ymin)) * CellsY - CINT(AR.Ycll / 2)
  IF Schuif.Y < 0 THEN Schuif.Y = 0
  IF Schuif.Y > CellsY - AR.Ycll THEN Schuif.Y = CellsY - AR.Ycll

  IF Schuif.Y <> Sch% THEN World.Put
  CALL GetButtonM(but%, x%, y%): x% = x% / 2
LOOP UNTIL but% < 2

END SUB

SUB Palet.Load

DEF SEG = VARSEG(MClr(0, 0))       ' Vanuit bestand direct naar geheugen
BLOAD "DATA\STANDARD.PAL", VARPTR(MClr(0, 0))
Palet.Update

END SUB

SUB Palet.Save

DEF SEG = VARSEG(MClr(0, 0))       ' Vanuit geheugen direct naar bestand
BSAVE "DATA\STANDARD.PAL", VARPTR(MClr(0, 0)), 768  ' 256 * 3 = 768

END SUB

SUB Palet.Update

FOR x = 0 TO 127 '255
  OUT &H3C8, x
  OUT &H3C9, ASC(MClr(x, 0))
  OUT &H3C9, ASC(MClr(x, 1))
  OUT &H3C9, ASC(MClr(x, 2))
  OUT &H3C8, x + 128
  OUT &H3C9, CINT(ASC(MClr(x, 0)) / 2)
  OUT &H3C9, CINT(ASC(MClr(x, 1)) / 2)
  OUT &H3C9, CINT(ASC(MClr(x, 2)) / 2)
 
' Grijswaarden
'  OUT &H3C9, CINT((ASC(MClr(x, 0)) + ASC(MClr(x, 1)) + ASC(MClr(x, 2))) / 3)
'  OUT &H3C9, CINT((ASC(MClr(x, 0)) + ASC(MClr(x, 1)) + ASC(MClr(x, 2))) / 3)
'  OUT &H3C9, CINT((ASC(MClr(x, 0)) + ASC(MClr(x, 1)) + ASC(MClr(x, 2))) / 3)
' 50% donkerder
'  OUT &H3C9, CINT(ASC(MClr(x, 0)) / 2)
'  OUT &H3C9, CINT(ASC(MClr(x, 1)) / 2)
'  OUT &H3C9, CINT(ASC(MClr(x, 2)) / 2)
NEXT x

END SUB

SUB Prepair
SCREEN 13                           ' 320x200 met 256 kleuren

' Speciale cellen voorbereiden
GET (0, 0)-(7, 7), MemCell          ' Zorgen dat deze niet leeg is
FOR x = 0 TO 7 STEP 2
  FOR y = 0 TO 7 STEP 2
    PSET (x + 1, y), 255
    PSET (x, y + 1), 255
  NEXT y
NEXT x
GET (0, 0)-(7, 7), RasterC(0)       ' Raster cel
LINE (0, 0)-(7, 7), 128, BF
GET (0, 0)-(7, 7), Plus128(0)       ' Vakje van kleur 128

Palet.Load

' De kleuren 0 t/m 15 zijn louter voor het programma!
PALETTE 1, 5 + 256 * 5 + 65536 * 7         ' 5  7
PALETTE 2, 8 + 256 * 8 + 65536 * 11        ' 8  11
PALETTE 3, 14 + 256 * 14 + 65536 * 20      ' 14 20
PALETTE 4, 21 + 256 * 21 + 65536 * 29      ' 21 29
PALETTE 5, 20 + 256 * 14 + 65536 * 14
PALETTE 6, 14 + 256 * 20 + 65536 * 14
PALETTE 7, 14 + 256 * 14 + 65536 * 20

' Kleurwaardes in variabelen zetten.
FOR x = 0 TO 255
  OUT &H3C6, &HFF
  OUT &H3C7, x
  MClr(x, 0) = CHR$(INP(&H3C9))
  MClr(x, 1) = CHR$(INP(&H3C9))
  MClr(x, 2) = CHR$(INP(&H3C9))
NEXT x

FInit                               ' Font initialiseren

' Muis initialiseren...
CALL initpointer(i%)
IF i% = 0 THEN SCREEN 0: WIDTH 80, 25: COLOR 7: PRINT "Geen muis gevonden.": END

Set.Variables
Buildscreen                         ' Eerste scherm opbouw

END SUB

SUB ProgramError (D%)
SCREEN 0: WIDTH 80: CLS : COLOR 8
PRINT "Something has gone terribly wrong!": PRINT : COLOR 7

SELECT CASE D%

  CASE 0:    PRINT "Runtime errorcode:"; ERR
             IF ERL <> 0 THEN PRINT "In line:"; ERL
             SELECT CASE ERR
               CASE 5:  PRINT "Ongeldige functie aanroep, misschien verkeerde scherm modus"
               CASE 6:  PRINT "Overloop"
               CASE 7:  PRINT "Onvoldoende geheugen"
               CASE 52: PRINT "Onjuiste bestandsnaam/nummer"
               CASE 53: PRINT "Bestand niet gevonden"
               CASE 61: PRINT "Schijf is vol"
               CASE 64: PRINT "Onjuiste bestandsnaam"
             END SELECT

  CASE 1:    PRINT "Error in sub FSize:"
             PRINT "Size% cannot be less then 1"

  CASE 2:    PRINT "Error in sub FColor:"
             PRINT "Clr% cannot be negative or above 255"

  CASE 3:    PRINT "Error in sub FRotate:"
             PRINT "Degrees% must be in [-360,360]"

END SELECT

SYSTEM
END SUB

SUB QuitProg

SCREEN 0: WIDTH 80, 25
COLOR 7
PRINT " RPG Edit v" + Version
COLOR 8: PRINT
PRINT " Changes"
PRINT " - Completely deleted remaining ColorHokje code from the program"
PRINT
PRINT " Features in RPG Edit v1.14"
PRINT " - Building a two layerd world, the second layer overlapping the player"
PRINT " - Mixing the palet to your own needs"
PRINT " - Drawing cells quick and easy. Tools to flip/mirror and rotate a cell"
PRINT " - COMMAND$ checking: FLD files can be argumented from DOS"
PRINT " - The areas are 64x64 and loaded into memory as 8-bit characters"
PRINT " - All data files stored in \DATA directory"
COLOR 7
SYSTEM

END SUB

SUB Set.Variables

' Variabelen voor de onderdelen van RPG Edit
AR.Xmin = 1:  AR.Ymin = 18 '----------------------- Area window (AR)
AR.Xcll = 21: AR.Ycll = 17
AR.Xmax = AR.Xmin + AR.Xcll * 8 - 1
AR.Ymax = AR.Ymin + AR.Ycll * 8 - 1
MP.Xmin = 165: MP.Space = 7 '---------------------- Mengpaneeltje (MP)
MP.Y1 = 165
MP.Y2 = MP.Y1 + MP.Space
MP.Y3 = MP.Y2 + MP.Space
PW.Xmin = 249: PW.Ymin = 159 '--------------------- Palet weergave (PW)
PW.From = 2: PW.To = 15
PW.Xmax = PW.Xmin + 5 * (PW.To - PW.From + 1) - 2
PW.Ymax = PW.Ymin + 5 * 8 - 2
VG.Xmin = 2: VG.Ymin = 159 '----------------------- Vergrootglas (VG)
VG.Size = 5
VG.X = 8:    VG.Y = 8
VG.Xmax = VG.Xmin + VG.X * VG.Size - 2
VG.Ymax = VG.Ymin + VG.Y * VG.Size - 2
KN.Xmin = 50: KN.Ymin = 189 '---------------------- Knoppen (KN)
KN.Xmax = KN.Xmin + 3 * 10 - 1: KN.Ymax = KN.Ymin + 9
OB.Xmin = 5: OB.Ymin = 22 '------------------------ Open bestand raampje (OB)
CS.Xmin = 174: CS.Ymin = 11 '---------------------- Cell Select raampje (CS)
CS.Xmax = CS.Xmin + 16 * 9 - 2
CS.Ymax = CS.Ymin + 16 * 9 - 2

END SUB

SUB Window.Drag (minX%, minY%, widthX%, heightY%)

VarLenght% = CINT((widthX% * heightY% + 4) / 2) - 1
DIM Vak(VarLenght%) AS INTEGER

FOR x = 2 TO VarLenght%
  Vak(x) = -32640                           ' Het vak kleur 128 maken
NEXT x
Vak(0) = widthX% * 8
Vak(1) = heightY%


CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
HidePointer
PUT (mx% - 8, my% - 8), Vak(0), OR
ShowPointer
DO
  mxo% = mx%: myo% = my%
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2
  IF mx% < 8 THEN mx% = 8
  IF my% < 8 THEN my% = 8
  IF mxo% <> mx% OR myo% <> my% THEN
    HidePointer
    PUT (mxo% - 8, myo% - 8), Vak(0), XOR
    PUT (mx% - 8, my% - 8), Vak(0), XOR
    ShowPointer
  END IF
LOOP

END SUB

SUB World.Load

DEF SEG = VARSEG(MCell(0, 0, 0))
BLOAD WorldFile$, VARPTR(MCell(0, 0, 0))
   
InfoFile$ = LEFT$(WorldFile$, INSTR(WorldFile$, ".") - 1) + ".ARI"
OPEN InfoFile$ FOR INPUT AS #1
DO UNTIL EOF(1)
  INPUT #1, Regel$
  IF Regel$ = "CellsFile" THEN
    INPUT #1, CellsFile$
    CellsFile$ = "DATA\" + CellsFile$
    CLOSE #1
    Cells.Load
    EXIT DO
  END IF
LOOP
CLOSE #1

END SUB

SUB World.Open

DIM Ondervak(3303)
DIM FLDFiles AS INTEGER, CLLFiles AS INTEGER
DIM SelectedFile AS INTEGER
DIM PrevFile AS INTEGER
DIM FileNr AS INTEGER

' Raampje op scherm zetten
HidePointer
 GET (OB.Xmin, OB.Ymin)-(OB.Xmin + 104 - 1, OB.Ymin + 127 - 1), Ondervak
LINE (OB.Xmin, OB.Ymin)-(OB.Xmin + 104 - 1, OB.Ymin + 127 - 1), 1, B
LINE (OB.Xmin, OB.Ymin)-(OB.Xmin + 104 - 2, OB.Ymin + 127 - 2), 3, B
LINE (OB.Xmin + 1, OB.Ymin + 1)-(OB.Xmin + 104 - 2, OB.Ymin + 127 - 2), 2, BF
LINE (OB.Xmin + 3, OB.Ymin + 3)-(OB.Xmin + 49 + 3, OB.Ymin + 127 - 3), 3, B
LINE (OB.Xmin + 2, OB.Ymin + 2)-(OB.Xmin + 49 + 2, OB.Ymin + 127 - 4), 1, B
LINE (OB.Xmin + 3, OB.Ymin + 3)-(OB.Xmin + 49 + 2, OB.Ymin + 127 - 4), 1, BF
FColor 3: FLocate OB.Xmin + 57, OB.Ymin + 127 - 4: FPrint "N: NEW FILE"
FColor 2: FLocate OB.Xmin + 4, OB.Ymin + 4 + 4: FPrint "LOADING FILES"
ShowPointer

SHELL "DIR DATA\*.FLD /B /L /ON >DIR.LST"    ' Bestand met FLD-lijst maken
OPEN "DIR.LST" FOR INPUT AS #1
DO UNTIL EOF(1)                              ' Tellen hoeveel het er zijn
  INPUT #1, File$
  FLDFiles = FLDFiles + 1
LOOP
CLOSE #1
DIM FLDFile(FLDFiles) AS STRING

OPEN "DIR.LST" FOR INPUT AS #1
FileNr = 0
DO UNTIL EOF(1)
  INPUT #1, FLDFile(FileNr)                  ' FLD bestanden inlezen
  FLDFile(FileNr) = LEFT$(FLDFile(FileNr), INSTR(FLDFile(FileNr), ".") - 1)
  FileNr = FileNr + 1
LOOP
CLOSE #1

SHELL "DIR DATA\*.CLL /B /L /ON >DIR.LST"    ' Bestand met CLL-lijst maken
OPEN "DIR.LST" FOR INPUT AS #1
DO UNTIL EOF(1)                              ' Tellen hoeveel het er zijn
  INPUT #1, File$
  CLLFiles = CLLFiles + 1
LOOP
CLOSE #1
DIM CLLFile(CLLFiles) AS STRING

OPEN "DIR.LST" FOR INPUT AS #1
FileNr = 0
DO UNTIL EOF(1)
  INPUT #1, CLLFile(FileNr)                  ' CLL bestanden inlezen
  CLLFile(FileNr) = LEFT$(CLLFile(FileNr), INSTR(CLLFile(FileNr), ".") - 1)
  FileNr = FileNr + 1
LOOP
CLOSE #1
KILL "DIR.LST"
 
' Vakje leeg maken en vullen met de net ingelezen FLD bestanden.
SelectedFile = 0
HidePointer
LINE (OB.Xmin + 3, OB.Ymin + 3)-(OB.Xmin + 49 + 2, OB.Ymin + 127 - 4), 1, BF
FOR FileNr = 0 TO FLDFiles - 1
  FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * FileNr
  IF FileNr = SelectedFile THEN
    LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * SelectedFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * SelectedFile + 4), 2, BF
    FLocate OB.Xmin + 4 + 1, OB.Ymin + 4 + 4 + 6 * SelectedFile
    FColor 1: FPrint UCASE$(FLDFile(SelectedFile))
    FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * SelectedFile
    FColor 4
  ELSE FColor 3
  END IF
  FPrint UCASE$(FLDFile(FileNr))
NEXT FileNr
ShowPointer

DO
  CALL GetButtonM(but%, mx%, my%): mx% = mx% / 2

  ' Muis afhandelen
  IF but% = 1 THEN
    IF mx% >= OB.Xmin + 4 AND my% >= OB.Ymin + 4 AND mx% <= OB.Xmin + 49 + 1 AND my% <= OB.Ymin + 127 - 5 THEN
      PrevFile = SelectedFile
      SelectedFile = INT((my% - (OB.Ymin + 4)) / 6)
      IF SelectedFile > (FLDFiles - 1) THEN SelectedFile = PrevFile
      IF PrevFile <> SelectedFile THEN
        HidePointer
        LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * PrevFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * PrevFile + 4), 1, BF
        FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * PrevFile
        FColor 3: FPrint UCASE$(FLDFile(PrevFile))
        LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * SelectedFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * SelectedFile + 4), 2, BF
        FLocate OB.Xmin + 4 + 1, OB.Ymin + 4 + 4 + 6 * SelectedFile
        FColor 1: FPrint UCASE$(FLDFile(SelectedFile))
        FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * SelectedFile
        FColor 4: FPrint UCASE$(FLDFile(SelectedFile))
        ShowPointer
        PrevFile = SelectedFile
      END IF
    END IF
  END IF
  'IF but% = 1 THEN
  '  IF mx% > 2 AND my% > 11 AND mx% < 148 AND my% < 71 THEN
  '    Fl = INT((my% - 12) / 6) + 10 * INT((mx% - 3) / 49)
  '    IF Fl < w THEN EXIT DO
  '  END IF
  'END IF
  
  ' Toetsen afhandelen
  a$ = INKEY$
  IF a$ <> "" THEN
    IF LCASE$(a$) = "n" THEN
' ---------------- Openen van een nieuwe wereld -----------------------------
      SCREEN 0: WIDTH 80, 25: CLS : COLOR 7
      PRINT " Create a new world "
      PRINT : WorldFile$ = "": CellsFile$ = "": COLOR 8
      PRINT "--- Existing worlds ------------------------------------------------------------": COLOR 7
      FOR FileNr = 0 TO FLDFiles - 1: PRINT UCASE$(FLDFile(FileNr)); "  "; : NEXT FileNr: PRINT : PRINT : COLOR 8
      PRINT "--- Cells files ----------------------------------------------------------------": COLOR 7
      FOR FileNr = 0 TO CLLFiles - 1: PRINT UCASE$(CLLFile(FileNr)); "  "; : NEXT FileNr: PRINT : PRINT : COLOR 8
      PRINT "--- Keyboard input -------------------------------------------------------------"
      COLOR 7
      DO
      PRINT "Type a (new) world name: ";
      LINE INPUT WorldFile$
      LOOP UNTIL LEN(WorldFile$) < 8 AND LEN(WorldFile$) > 0
      DO
      PRINT "Give a (new) cells-file: ";
      LINE INPUT CellsFile$
      LOOP UNTIL LEN(CellsFile$) < 8 AND LEN(CellsFile$) > 0
      IF INSTR(WorldFile$, ".") > 0 THEN WorldFile$ = LEFT$(WorldFile$, INSTR(WorldFile$, ".") - 1)
      IF INSTR(CellsFile$, ".") > 0 THEN CellsFile$ = LEFT$(CellsFile$, INSTR(CellsFile$, ".") - 1)
      CSame% = 0: WSame% = 0
      FOR FileNr = 0 TO CLLFiles - 1
        IF UCASE$(CLLFile(FileNr)) = UCASE$(CellsFile$) THEN CSame% = 1: EXIT FOR
      NEXT FileNr
      CellsFile$ = CellsFile$ + ".CLL"
      FOR FileNr = 0 TO FLDFiles - 1
        IF UCASE$(FLDFile(FileNr)) = UCASE$(WorldFile$) THEN WSame% = 1: EXIT FOR
      NEXT FileNr
      InfoFile$ = "DATA\" + WorldFile$ + ".ARI"
      WorldFile$ = "DATA\" + WorldFile$ + ".FLD"
      OPEN InfoFile$ FOR OUTPUT AS #1
      PRINT #1, "CellsFile," + CellsFile$: CLOSE #1
      CellsFile$ = "DATA\" + CellsFile$
     
      SCREEN 13: Info$ = "Niks"
      CALL HidePointer: Prepair
      IF CSame% = 0 THEN Cells.Save ELSE Cells.Load
      IF WSame% = 0 THEN
        FOR x = 0 TO CellsX - 1
          FOR y = 0 TO CellsY - 1
            MCell(0, x, y) = CHR$(0)
            MCell(1, x, y) = CHR$(0)
          NEXT y
        NEXT x
        CALL World.Put: World.Save
      ELSE World.Load
      END IF
      ShowPointer
      EXIT SUB
' ---------------------------------------------------------------------------
    END IF
    IF a$ = CHR$(13) THEN Fl = SelectedFile: EXIT DO
    IF a$ = CHR$(27) AND WorldFile$ <> "" THEN
      HidePointer
        PUT (OB.Xmin, OB.Ymin), Ondervak, PSET
      ShowPointer
      EXIT SUB
    END IF
    IF a$ = CHR$(0) + CHR$(72) AND SelectedFile > 0 THEN SelectedFile = SelectedFile - 1               ' Omhoog
    IF a$ = CHR$(0) + CHR$(80) AND SelectedFile < FLDFiles - 1 THEN SelectedFile = SelectedFile + 1    ' Omlaag
    IF PrevFile <> SelectedFile THEN
      HidePointer
        LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * PrevFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * PrevFile + 4), 1, BF
        FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * PrevFile
        FColor 3: FPrint UCASE$(FLDFile(PrevFile))
        LINE (OB.Xmin + 3, OB.Ymin + 4 + 6 * SelectedFile)-(OB.Xmin + 49 + 2, OB.Ymin + 4 + 6 * SelectedFile + 4), 2, BF
        FLocate OB.Xmin + 4 + 1, OB.Ymin + 4 + 4 + 6 * SelectedFile
        FColor 1: FPrint UCASE$(FLDFile(SelectedFile))
        FLocate OB.Xmin + 4, OB.Ymin + 4 + 4 + 6 * SelectedFile
        FColor 4: FPrint UCASE$(FLDFile(SelectedFile))
      ShowPointer
      PrevFile = SelectedFile
    END IF
  END IF
LOOP

'HidePointer -- Niet nodig want World.Put zet de wereld eroverheen
'PUT (OB.Xmin, OB.Ymin), Ondervak, PSET
'ShowPointer
WorldFile$ = "DATA\" + FLDFile(SelectedFile) + ".FLD"
World.Load

DO
  CALL GetButtonM(but%, mx%, my%)
LOOP WHILE but% = 1

END SUB

SUB World.Put
Shw% = 0
IF mx% < (AR.Xmax + 1) AND my% < (AR.Ymax + 1) THEN HidePointer: Shw% = 1

' Scroll lijntjes
LINE (AR.Xmin - 1, AR.Ymin - 1)-(AR.Xmax + 1, AR.Ymax + 1), 1, B
LINE (AR.Xmin + (Schuif.X / CellsX) * (AR.Xmax - AR.Xmin), AR.Ymin - 1)-(AR.Xmin + ((Schuif.X + AR.Xcll) / CellsX) * (AR.Xmax - AR.Xmin), AR.Ymin - 1), 3
LINE (AR.Xmin - 1, AR.Ymin + (Schuif.Y / CellsY) * (AR.Ymax - AR.Ymin))-(AR.Xmin - 1, AR.Ymin + ((Schuif.Y + AR.Ycll) / CellsY) * (AR.Ymax - AR.Ymin)), 3

' Cellen in area window tekenen
FOR x = 0 TO (AR.Xcll - 1)
  FOR y = 0 TO (AR.Ycll - 1)
    Layer0Cell% = ASC(MCell(0, x + Schuif.X, y + Schuif.Y))
    Layer1Cell% = ASC(MCell(1, x + Schuif.X, y + Schuif.Y))
   
    IF Layer1Cell% = 0 OR Layer1Cell% >= 208 THEN
      PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer0Cell%), PSET
      IF Layer = 1 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), RasterC(0), AND
    END IF
   
    IF Layer1Cell% > 0 THEN
      IF Layer1Cell% >= 208 AND Layer1Cell% <= 223 THEN AndCell% = Layer1Cell% + 32
      IF Layer1Cell% >= 224 AND Layer1Cell% <= 239 THEN AndCell% = Layer1Cell% + 16
      IF AndCell% > 0 THEN
        PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, AndCell%), AND
        PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%), OR
      ELSE
        PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%), PSET
      END IF
      IF Layer = 0 THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), RasterC(0), AND
      AndCell% = 0
    END IF
    'IF (x < 1 OR y < 1) THEN PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Plus128(0), XOR
  NEXT y
NEXT x

IF Shw% = 1 THEN ShowPointer
END SUB

SUB World.Save

DEF SEG = VARSEG(MCell(0, 0, 0))               ' Segment adres instellen
BSAVE WorldFile$, VARPTR(MCell(0, 0, 0)), 8192 ' Beginnen bij het offset adres
                                               ' van MCell(0, 0, 0).
                                               ' Lengte = 64 * 64 * 2 = 8192
END SUB

