'Ŀ
' RPG Engine v0.50                                               1999/2000 
' Programmed by Bjorn Lindeijer/Georg Muntingh   (c) Moonlight Productions 
'

' -------- Subs en variabelen van Georg (events/items/living objects) -------
DECLARE SUB Fight (CreatureNummer)
DECLARE SUB Fight.End (A, CreatureNummer)
DECLARE SUB Fight.Update (CreatureNummer)
DECLARE SUB LivOb.Update ()
DECLARE SUB Event.Call (Temp$)
DECLARE SUB Event.Add (Temp$)
DECLARE SUB Event.Show (Temp$)
DECLARE SUB Event.Move (Temp$)
DECLARE SUB Event.Load (EventFile$)
DECLARE SUB Event.Start (Event.nummer)
DECLARE SUB Check.Place ()
DECLARE SUB Items.LineUp ()
CONST Max.Events = 60                          ' Aantal events per area
CONST Max.group.events = 60                    ' Aantal samenhangende events
CONST Max.items = 256                          ' Maximale aantal items.
DIM SHARED Event.x(Max.Events), Event.y(Max.Events), Event.nummer(Max.Events)
DIM SHARED Aantal.events AS INTEGER, Finished AS INTEGER
DIM SHARED Progresspoint(Max.group.events) AS INTEGER
DIM SHARED LivOb.Aantal AS INTEGER
DIM SHARED Item(Max.items) AS INTEGER, Aantal.Items AS INTEGER

' ---------- The Advanced Font Routines -------------------------------------
DECLARE FUNCTION FLenght% (zin$)
DECLARE SUB FWindow (Xmin%, Ymin%, Xmax%, Ymax%)
DECLARE SUB FLocate (x%, y%)
DECLARE SUB FInit ()
DECLARE SUB FSize (Size%)
DECLARE SUB FColor (Clr%)
DECLARE SUB FRotate (Degrees%)
DECLARE SUB FPrint (zin$)
DIM SHARED Letter(32 TO 122) AS STRING
DIM SHARED Lengte(32 TO 122) AS STRING * 1
DIM SHARED Lib.Xco AS INTEGER, Lib.Yco AS INTEGER
DIM SHARED FClr AS STRING, FSze AS STRING
DIM SHARED FAngle AS STRING
' ---------------------------------------------------------------------------
DECLARE SUB Area.Load (Name$, x%, y%, dir%)
DECLARE SUB Stats.Show ()
DECLARE SUB Stats.Update ()
DECLARE SUB Palet.Load ()
DECLARE SUB Palet.Update ()
DECLARE SUB Walk (D%, E)
DECLARE SUB Wacht (ms%)                        ' Wacht tijd in ms
DECLARE SUB Prepair ()                         ' Een aantal voorbereidigen
DECLARE SUB Buildscreen ()                     ' Eerste schermopbouw
DECLARE SUB QuitProg ()                        ' Sub voor het afsluiten
DECLARE SUB World.Put ()                       ' Tekenen van de wereld
DECLARE SUB World.PutPart (Xb%, Yb%, Xe%, Ye%)
DECLARE SUB Talk (File$, GespreksNummer)
DECLARE SUB World.Load (WorldFile$)
DECLARE SUB ProgramError (ErrorCode%)          ' Foutafhandeling
'ON ERROR GOTO UnforseenError

CONST CellsX = 64, CellsY = 64                 ' Grote van de wereld
CONST Version = "0.50"                         ' Versienummer

' Gegevens over het raampje waar je de area ziet (AR)
CONST AR.Xmin = 24: CONST AR.Ymin = 24
CONST AR.Xcll = 24: CONST AR.Ycll = 18
CONST AR.Xmax = AR.Xmin + AR.Xcll * 8 - 1
CONST AR.Ymax = AR.Ymin + AR.Ycll * 8 - 1

TYPE TypeCreature
  Hp AS INTEGER: MaxHp AS INTEGER: AC AS INTEGER
  geld AS INTEGER
  x AS INTEGER: y AS INTEGER
  dir AS INTEGER
  graph AS INTEGER
  speed AS INTEGER
  face AS STRING * 8
END TYPE

DIM SHARED Hero.Ep AS INTEGER       '           = Huidige Ep
DIM SHARED Hero.LvlUpEp AS INTEGER  '           = Ep nodig voor Lvl Up
DIM SHARED Hero.Lvl AS INTEGER      '
DIM SHARED Hero.Vit AS INTEGER      ' +Vitality = meer HP
DIM SHARED Hero.Acc AS INTEGER      ' +Accuracy = kans op raken groter
DIM SHARED Hero.Agi AS INTEGER      ' +Agility  = kans op ontwijken groter
DIM SHARED Hero.Spd AS INTEGER      '  Speed    = Loopsnelheid in turn based
DIM SHARED Hero.WpnMin, Hero.WpnMax, Hero.Str
DIM SHARED Hero.AmrMin, Hero.AmrMax, Hero.Def
DIM SHARED Monster.WpnMin, Monster.WpnMax, Monster.Str
DIM SHARED Monster.AmrMin, Monster.AmrMax, Monster.Def
DIM SHARED Cell(16, 255, 1)                    ' Cellen in geheugen
DIM SHARED PCreature(16, 3, 1, 1, 15)          ' 1 held en 15 creatures
DIM SHARED Creature(32) AS TypeCreature        ' Ruimte voor 32 creatures
DIM SHARED Schuif.x AS INTEGER, Schuif.y AS INTEGER
DIM SHARED x AS INTEGER, y AS INTEGER
DIM SHARED MCell(1, CellsX - 1, CellsY - 1) AS STRING * 1  ' Wereld
DIM SHARED MClr(255, 2) AS STRING * 1          ' Kleur waarden
DIM SHARED Actietoets, Look, LivOb.Count
DIM SHARED Tijd AS SINGLE
DIM SHARED EventFile$

Prepair

EventFile$ = "DATA\HOUSE"
Area.Load EventFile$, 13, 4, 3
Schuif.x = 0: Schuif.y = 0
Aantal.Items = 25
Hero.WpnMin = 12: Hero.WpnMax = 16: Hero.Str = 7
Hero.AmrMin = 8: Hero.AmrMax = 11: Hero.Def = 5
Creature(0).Hp = 80: Creature(0).MaxHp = 80
Stats.Update

World.Put
Tijd = TIMER

DO
  IF TIMER - Tijd > .1 THEN LivOb.Count = LivOb.Count + 1: LivOb.Update: Tijd = TIMER: LivOb.Count = LivOb.Count MOD 2000
  
  A$ = INKEY$
 
  'IF LCASE$(A$) = "s" THEN CALL Stats.Show    ' Statistics uitgeschakeld
  IF A$ = " " THEN Actietoets = 1: CALL Check.Place: Actietoets = 0
  IF A$ = CHR$(27) THEN CALL QuitProg
  IF A$ = CHR$(0) + CHR$(75) THEN CALL Walk(0, 0): Check.Place
  IF A$ = CHR$(0) + CHR$(72) THEN CALL Walk(1, 0): Check.Place
  IF A$ = CHR$(0) + CHR$(77) THEN CALL Walk(2, 0): Check.Place
  IF A$ = CHR$(0) + CHR$(80) THEN CALL Walk(3, 0): Check.Place
 
  'WAIT &H3DA, 8
LOOP

UnforseenError:
ProgramError 0

SUB Area.Load (Name$, x%, y%, dir%)

Event.Load Name$ + ".EVT"
World.Load Name$ + ".FLD"

Creature(0).x = x%
Creature(0).y = y%
Creature(0).dir = dir%

Schuif.x = Creature(0).x - (AR.Xcll / 2)
Schuif.y = Creature(0).y - (AR.Ycll / 2)
IF Schuif.x < 0 THEN Schuif.x = 0
IF Schuif.y < 0 THEN Schuif.y = 0
IF Schuif.x > CellsX - AR.Xcll THEN Schuif.x = CellsX - AR.Xcll
IF Schuif.y > CellsY - AR.Ycll THEN Schuif.y = CellsY - AR.Ycll

END SUB

SUB Buildscreen

' Standaard palet inladen
Palet.Load

' De kleuren 0 t/m 15 zijn louter voor het programma!
PALETTE 1, 5 + 256 * 5 + 65536 * 5
PALETTE 2, 8 + 256 * 8 + 65536 * 8
PALETTE 3, 14 + 256 * 14 + 65536 * 14
PALETTE 4, 21 + 256 * 21 + 65536 * 21

' Omlijning speelveld
LINE (AR.Xmin - 1, AR.Ymin - 1)-(AR.Xmax + 1, AR.Ymax + 1), 1, B
LINE (224, 24)-(296, 167), 2, BF                        ' Status vak
LINE (223, 23)-(297, 168), 1, B
FSize 1
FColor 1: FLocate 232, 166: FPrint "RPG ENGINE " + Version
FColor 3: FLocate 232, 165: FPrint "RPG ENGINE " + Version

' Gegevens venster nog niet 100%
'FColor 1: FLocate 226, AR.Ymin + 10: FPrint "GEGEVENS"
'FColor 4: FLocate 226, AR.Ymin + 9: FPrint "GEGEVENS"

END SUB

SUB Check.Place

FOR i = 1 TO Aantal.events
  IF Creature(0).x = Event.x(i) AND Creature(0).y = Event.y(i) THEN CALL Event.Start(Event.nummer(i)): EXIT FOR
NEXT i

Look = 0
FOR i = 1 TO LivOb.Aantal
  IF Creature(i).x + 1 = Creature(0).x AND Creature(i).y = Creature(0).y THEN
    IF Creature(0).dir = 0 THEN Look = 1
    Event.Start (256 + i): EXIT FOR
  END IF
  IF Creature(i).x = Creature(0).x AND Creature(i).y + 1 = Creature(0).y THEN
    IF Creature(0).dir = 1 THEN Look = 1
    Event.Start (256 + i): EXIT FOR
  END IF
  IF Creature(i).x - 1 = Creature(0).x AND Creature(i).y = Creature(0).y THEN
    IF Creature(0).dir = 2 THEN Look = 1
    Event.Start (256 + i): EXIT FOR
  END IF
  IF Creature(i).x = Creature(0).x AND Creature(i).y - 1 = Creature(0).y THEN
    IF Creature(0).dir = 3 THEN Look = 1
    Event.Start (256 + i): EXIT FOR
  END IF
NEXT i

END SUB

SUB Discussie
'
'  Georg: Ik ben het niet helemaal eens met je om na het ontsnappen uit een
'         gevecht altijd een seconde wegkomtijd te hebben. Ik vind dat dit
'         af moet hangen van de speed van het creature.
'  Bjorn: Mee eens, het was ook een tijdelijke oplossing om van dat probleem
'         dat je helemaal niet kon ontsnappen af te komen (samen met andere
'         wijzigingen)
'
'
'  Bjorn: Nou Georg, ik heb een bug voor je:
'         Waarom in hemelsnaam blijven alle LivOb's stil staan als je rondjes
'         loopt rond een van hun? Heeft vast iets te maken met LivOb.Count...
'
'         ...
'
'  Bjorn: Ik heb hem gevonden. Het kwam door het laatste regeltje van
'         de sub Event.Start. Dat heb ik uit gezet.
'
'  Georg: Natuurlijk! Als je er omheen blijft lopen blijft 'tijd' steeds een
'         seconde vooruit. Klasse Bjorn.
'  Bjorn: Dank je Georg.
'
'
' Geleuter 
'

' - Het lijkt mij wel een leuk idee om in het .EVT bestand terwijl je het ge-
'   vecht aanroept allemaal parameters mee te geven. Bijv: live, strength,
'   defense, experience, gold (evt. plaatje.) Op die manier kun je het gehele
'   gevecht vanuit het .EVT bestand regelen. En dat is volgens mij ideaal.
'   Bjorn: Goed idee, doen!
'   Georg: Mooi. Ik wacht alleen even totdat we definitief de knoop doorge-
'          hakt hebben over hoe ons vechtscherm eruit moet komen te zien.


' Nieuw geleuter 
'
' - Ik heb de loopsnelheid instelbaar gemaakt. Elke Creature bevat nu ook de
'   variabele Creature(a).speed. Dit is een getal dat weergeeft om de hoeveel
'   updates hij een stapje mag verzetten. Als elke update zoals nu 0.1 seconde
'   duurt, en Creature(a).speed = 7 dan 'stapt' hij om de 0.1 * 7 = 0.7 secon-
'   de. Ik heb dit als volgt gedaan:
'   Ik heb de variabele LivOb.Update.Teller ingevoerd. (Moeten we misschien
'   een andere naam geven, ik kon niets duidelijkers bedenken.) Deze houdt bij
'   hoe vaak er geupdate is en wordt na 2000 keer gereset, want hij mag door
'   zijn integer waarde niet eeuwig door blijven lopen. Dit getal mag niet te
'   klein want als het geen factor is van de Creature(a).speed kunnen ze op
'   dat moment even een onregelmatige stap doen. En ook niet te groot, want
'   als dat scheelt (denk ik) rekenwerk. Nu kijkt hij tijdens elke update of
'   LivOb.Update.Teller een veelvoud is van Creature(a).speed ...
'   Zo ja, updaten maar.
'   Bjorn: Dat is een heel verhaal, nagenoeg briljant.
'          LivOb.Update.Teller zou ook LibOb.Tel of LivOb.Count kunnen heten.
'   Georg: Mij lijkt LivOb.Count wel wat. Ik verander hem er alvast in. Zeg
'          het maar als je 't er niet mee eens bent.
'   Bjorn: Ik zeg niks.
'
' - Nieuwe event functie ingevoerd. movtr2. Oftwel 'Move, turn to...' Hiermee
'   draai je een willekeurig creature richting een willekeurig ander creature.
'   Het kan ook over lange afstanden, dat maakt het een stukje moeilijker. Als
'   je een beter algoritme weet prima, maar ik denk dat dit ongeveer het beste
'   is. Je geeft de getallen a en b mee voor Creature(a) die naar Creature(b)
'   toedraait.
'   Bjorn: Je twijfeld aan je kunnen? Jij hebt vast een algoritme opgesteld
'          waar 10.000 programmeurs plus Bill Gates alleen van kunnen dromen.
'          Hoewel ik heb geconstateerd dat, bijvoorbeeld als je naast het
'          slijm staat, je de verkeerde kant uit gaat staan de kijken.
'          (Loop maar eens boven het slijm langs)
'   Georg: Ja fuck, ik zie het ook. Er zit dus ergens een foutje in. Het slijm
'          draait echter wel de goede kant op -> Het moet dus makkelijk te ver-
'          helpen zijn.
'          En dat was het. Ik had gewoon een foutje in het .EVT bestand. Ik gaf
'          de verkeerde parameters mee. Hij draaide zich t.o.v. creature 001
'          i.p.v. 010. Het algoritme klopt dus gelukkig.
'          Even een uitleg van het algoritme:
'          X1 = X.Hero, Y1 = Y.Hero, X2 = X.Monster, Y2 = Y.Monster.
'          Ik vergelijk van Hero en Monster alle afstanden tussen elkaar.
'          X1 - X2 en X2 - X1 (zijn elkaars tegengestelden)
'          Y1 - Y2 en Y2 - Y1 (zijn natuurlijk ook elkaars tegengestelden.)
'          Dan kijk ik welke van deze het kleinste is, en daaruit trek ik de
'          conclusie welke kant hij op moet draaien. (Bijvoorbeeld als X1 - X2
'          het kleinste is en groter dan 0 (is hij kleiner dan 0, dan moet je
'          X2 - X1 hebben) dan betekent dat X.Hero 'net' iets groter is dan
'          X.Monster. De Hero moet dan naar links kijken.)
'   Bjorn: 'k vat 't.


' - Wat is RPGedit ongelooflijk mooi geworden!! Echt fantastisch.
'   Bjorn: Vind je het goed dat dit bericht nog even blijft staan?
'   Georg: Ja. Als RPGedit een 10 verdient, dan verdient DrawR een 10 met een
'          griffel! (ofzo iets.) Dat ziet er echt fantastisch uit. Van mij had
'          versie 0.20 ook wel versie 0.30 mogen heten.
'   Bjorn: Die wou ik bewaren voor een DrawR waar je ook de gezichten in kon
'          tekenen. De nieuwste versie van DrawR (v0.21) kan meerdere
'          characters tegelijk openen!
'
'   Georg: Nieuwe functie in eventsbestand: wai????. Hierbij is ???? het aantal
'          millisecondes dat er gewacht moet worden.
'   Bjorn: 'sgoed. Houd je ook een bestand bij dat beschrijft welke functies
'          er allemaal in het EVT bestand gebruikt kunnen worden? Dat zal
'          ook van pas komen bij het maken van de EVT-editor voor RPGEdit.
'
'   Georg: Ik heb de variabele progrespoint(0) ingevoerd, gezorgd dat hij niet
'          hoger dan 0 kan worden, en hem bij alle progrespointonafhankelijke
'          LibOb's ingevoerd. (dat zijn ze allemaal)
'   Bjorn: Mooi. Ook iets om te melden in het hiervoor genoemde bestand.
'
'   Georg: Ik vind niet dat als een vast event afgelopen is, dat hij dan meteen
'          moet kijken of op die plaats een nieuw vast event is. Kijk maar naar
'          de teleport. Hij teleport meteen terug. Vooral ook omdat hij niet
'          alle events bij langsging maar de rest van die eerste for-lus in
'          Check.Place. Ik heb dus maar aan het einde een EXIT FOR gezet. Ik
'          vond dat er ook nog een regeltje na elk event bij moest die de key-
'          buffer leeghaalt. Dat heb ik dus ook maar gedaan.
'   Bjorn: Key buffer leeghalen is goed. Alleen die EXIT FOR heb je ook bij de
'          LivOb's neergezet, is dat wel de bedoeling? Als je aan weerszijden
'          van jezelf een monster hebt staan, vallen die toch allebei aan? Ook
'          het aanspreken van mensen kan in dit soort gevallen tot problemen
'          leiden volgens mij. Ik heb deze sub zelf al een beetje veranderd
'          om het probleem met het vluchten weg te halen.
'   Georg: Aan de ene kant wel mee eens, maar de EXIT FOR weghalen zou 'niet
'          eerlijk zijn'. De Hero zou dan volgens mij alleen reageren op
'          LivOb's met een hoger nummer dan de eerste LivOb die aangesproken
'          wordt.
'
'   Georg: Een functie voor in RPGedit: als je op de 'f' drukt van fill, dan
'          vult hij de hele cell met de geselecteerde kleur.
'   Bjorn: Ik zal zien wat ik voor je kan doen.
'
'   Georg: Ik maakte voor het eerst gebruik van jouw font-routines in het
'          vechtscherm en er rees in mijn hoofd een vraag op:
'          Waarom heb je al die verschillende SUB's voor parameters van de
'          uiteindelijke tekst die op het scherm komt? Is het niet veel
'          slimmer een aantal van deze parameters mee te geven aan FWrite?
'          Denk bijvoorbeeld aan dit:
'          CALL FWrite(zin$, x-co, y-co, kleur, size)
'          Dit lijkt mij een stuk handiger. Wat denk jij hiervan?
'          Het is misschien ook handig om in zin$ een bepaald character mee
'          te kunnen geven dat de kleur veranderd. Een character dat nooit
'          gebruikt wordt. Dit is bijvoorbeeld voor mijn FIGHT routine handig.
'   Bjorn: Ik heb het een en ander in elkaar gezet in een nieuwe F-sub.
'          FWrite is nu FPrint geworden, dus FPrint "zin"
'          FWrite (zin$, x%, y%, Color%) is de nieuwe FWrite.
'          Ik heb expres Size en Rotate er niet bij gedaan omdat deze naar
'          mijn idee erg weinig gebruikt worden.
'
'   Georg: Ik heb mijn fightroutine gedeeltelijk geintegreerd in anestor.bas.
'          Dit leek mij de beste manier om zoveel mogelijk gegevens kwijt te
'          kunnen in het praatschermpje. Kiezen tussen Attack, Item en Escape
'          moet natuurlijk nog mooier. Ik heb een aantal nieuwe variabelen
'          moeten gebruiken:
'          - Monster.WpnMin, Monster.WpnMax, Monster.Str
'          - Monster.AmrMin, Monster.AmrMax, Monster.Def
'          - Hero.WpnMin, Hero.WpnMax, Hero.Str
'          - Hero.AmrMin, Hero.AmrMax, Hero.Def
'          Hp en MaxHp wordt over de hele area bijgehouden. De LOB's krijgen
'          hiervoor nu nog een extra parameter mee in AreaXX.EVT.
'          Ik wilde dat + Monster.Str en + Monster.Def en + Hero.Str en
'          + Hero.Def graag in het blauw hebben. Verder moeten de getalletjes
'          wat netter tegen de slash en tegen de rechterkant aan komen te
'          staan.
'   Bjorn: Ik heb de gegevens voor de hero naar de zijkant verplaatst. Wat
'          er met de gegevens van het monster gebeurt is mij nog niet helemaal
'          duidelijk, maar ik stel een levensbalkje voor onder het plaatje.
'   Georg: Ja, leuk idee. Moet dat levensbalkje dan altijd even groot zijn en
'          in procenten het aantal HP weergeven, of moet dat levensbalkje ook
'          kunnen groeien.(Dan hebben we te weinig ruimte.)
'   Bjorn: Je zegt het zelf al, groeien is lastig met de ruimte. Het zal
'          dus procentueel moeten.
'
'   Georg: Ik heb dat lelijke mededelinkje veranderd dat je een ITEM RECEIVED
'          hebt als je het kistje opent. De Keybuffer wordt ook nog leeggehaald.
'   Bjorn: Dit is beter, maar het kan natuurlijk altijd ng beter.
'
'   Georg: Probleem: Als je vanuit een event een stukje moet lopen, maar er
'          staat een LOB in de weg dan wil die dat event van de LOB opstarten
'          maar de Event.Sub staat al open. Moeten we gewoon zorgen dat je
'          TIJDENS een event alle andere LOB's vergeet. Dat zou betekenen dat
'          je er dan gewoon doorheen loopt...
'   Bjorn: Aangezien ik nog steeds vind dat voor elke LivOb een gebied aan-
'          gegeven moet worden waarin hij mag lopen, stel ik voor dat we
'          er gewoon rekening mee houden dat het elkaar niet gaat overlappen.
'          Omdat dit misschien nogal foutjegevoelig is stel ik verder voor
'          dat we, mocht er toch iets overlappen, we de LivOb gewoon negeren.
'   Georg: Okee. Hoe gaan we zorgen dat de LivOb niet buiten een gebied kan
'          komen?
'   Bjorn: Dan zul je alle LivOb's nog 4 extra variabelen moeten meegeven,
'          de twee hoekpunten van de rechthoek waar ze in mogen lopen.
'
'   Georg: Waarin gaan we de gezichten tekenen?
'   Bjorn: In DrawR. Ik ben van plan DrawR zodanig aan de passen dat daar
'          zowel LibOb's, Items, Gezichten en gewone plaatjes in getekend
'          kunnen worden. Gewone plaatjes kunnen bijvoorbeeld gebruikt worden
'          in een intro filmpje of ook tijdens het spel.
'
'   Georg: Met het vechten: De eerste poging tot ontsnappen lukt nooit. Heb jij
'          enig idee hoe dat komt?
'   Bjorn: Ja, ik heb het uitzocht. Er stond nog een variant van Check.Place
'          onderaan de Walk sub. Ik denk dat deze de problemen veroorzaakte.
'          Het probleem is nu in ieder geval de wereld uit en de Walk sub
'          is een stuk korter geworden door uniformisatie tussen de held
'          en de andere creatures.
'
'   Georg: Het vechtscherm is inmiddels redelijk ontwikkeld. Wat er nog moet
'          veranderen - en daar heb ik jouw hulp bij nodig - is dat er na elke
'          slag of item gebruik daar even verslag van gedaan moet worden:
'          'You hit the monster and it loses 5 life.' etc.
'          Ik wou dit wat mooi laten scrollen en zo; net zoiets als in de
'          Talk-routine, maar daar heb ik jouw hulp bij nodig.
'   Bjorn: Ok. Aangezien over het monster geen uitgebreide gegevens worden
'          getoond en de gegevens van de held aan de rechterkant staan,
'          kunnen die berichtjes mooi boven de 123-keuze verschijnen. Ik stel
'          scrollen per regel voor.
'   Georg: Dat is mijn idee.
'   Bjorn: Dan zijn we het hierover snel eens.
'
'   Georg: Als we nu met RPGedit al op 55 Kb zitten, dan ben ik bang dat een
'          eventontwerpsysteem in RPGedit er niet meer in zit.
'   Bjorn: Zoals gezegd hou ik de EVT-editor zoveel mogelijk gescheiden van
'          de wereld editor, zodat de programma's zonder al te veel moeite
'          gescheiden kunnen worden.
'
'
' RPG Planning 
'
'
' Algemeen
'  - Directories verder indelen
'  - Verder mengen aan het nieuwe palet
' RPG Edit
'  - Trigger editing mode afmaken
'  - World.Open sub verder uitwerken
' DrawR
'  - Beginnen aan Face-mode
' RPG Engine
'  - Gezichten inladen mogelijk maken (gegeven in Creature.Face)
'  - Praatraam openklappen
'  - Praatraam scrollen aanpassen
'  - Fightscreen integreren en afmaken.
'  - Het eventssysteem verder uitwerken.

'
' En dan is hier het handboek: RPGeml voor dummie's 
'
'          
' Subtitel: 'Vademecum van RPGeml.'
'
' Hallo RPG-makend Nederland. Dit tekstbestand geeft een korte beschrijving
' van de mogelijkheden die RPGeml biedt. Ik ga geen lange verhalen houden
' want daar heb ik kortweg geen zin in.
' RPGeml is een scriptinglanguage die is ontwikkeld door Moonlight Productions.
' Het staat voor Roll Playing Game Event Markup Language. Mocht u denken dat u
' spelfouten tegenkomt dan zit u ernaast. Wij maken geen spelfouten en dat wat
' op spelfouten lijkt behoort tot ons RPG-jargon en bla bla bla.
' Ik hoop dat u veel plezier zult beleven aan het leren en gebruiken van RPGeml.
'
' Georg Muntingh
'
' 1. Gekke woorden.
'
' Tijdens het ontwikkelen van onze RPG is er een soort jargon ontstaan waar we
' zelf nauwelijks meer zonder kunnen. Ik zal dus maar beginnen met een klein
' woordenlijstje met gekke woorden.
'
'  area - Het spel is opgebouwd uit meerdere gebieden/terreinen. Dit noemen we
'         area's.
' event - Ja eh, hoe moet ik dit nou weer uitleggen.
' LivOb - Langweg, Living Object. Dit is een object die enige vorm van leven
'         vertoont. Bijvoorbeeld een monster of een pratend mannetje.
' pixel - En puntje met een bepaalde kleur.
'  cell - Een klein plaatje. In ons geval 8x8 pixels.
'    HP - Health Points. De hoeveelheid life. Bij 0 is een LivOb dood.
'   PGP - Progrespoints. Dit geeft aan in hoeverre een event al heeft plaats
'         gevonden.
'  hero - De persoon waarmee het spel gespeeld wordt.
'  .EVT - Dit is een bestand waarin de events en nog wat andere dingetjes staan.
'  .CNV - Dit is een bestand waarin alle gesprekken staan die in het spel
'         gevoerd kunnen worden.
'  .CHR - Dit is een bestand waarin de tekeningetjes van LivOb's staan.
'  .FLD - In dit bestand staan de gegevens over hoe een area eruit moet zien.
'  .CLL - In dit bestand staan de cells waaruit een area bestaat.
'  .ARI - In dit bestand staan de restjes.

' 2. Het .EVT bestand.
'
' De RPGengine anestor.bas maakt leest RPGeml in d.m.v. het .EVT bestand. Dit
' bestand is in een aantal onderdelen opgedeeld:
'
' I:   We lopen meteen al tegen een beperking aan in de engine. Er is een
'      maximum gesteld van maximaal 16 verschillende figuurtjes per area.
'      Dit betekent niet dat er maximaal 16 figuurtje in een area kunnen rond-
'      lopen. Er kunnen er best meer lopen maar dan hebben sommige figuurtjes
'      dubbele tekeningetjes.
'      In deel I van het .EVT bestand worden 16 getallen, gescheiden door een
'      komma of een return, opgegeven. De 16 getallen geven aan welke 16 ver-
'      schillende plaatjes van LivOb's er in deze area kunnen rondlopen.
' II:  Eerst een getal dat aangeeft dat x LivOb's zich in deze area bevin-
'      den. Gevolgd door x keer voor alle LivOb's afzonderlijk de informatie
'      die voor dat LivOb geldt. Het desbetreffende nummer van het LivOb wordt
'      gegeven door van boven naar beneden te tellen. Het ziet er dus x keer
'      zo uit:
'      x-coordinaat, y-coordinaat, plaatjenummer, loopsnelheid, HP
'      Nu zijn alle gegevens van de LivOb's ingeladen.
' III: We onderscheiden twee types events: walking events en vaststaande
'      events. Walking events worden geactiveerd door bij een LivOb te staan.
'      vaststaande events kunnen worden geactiveerd door op een bepaalde plaats
'      te staan.
'      Nu volgen de gegevens over de vaststaande events. Dus bijvoorbeeld voor
'      een kistje, voor een deur of op een bloemetje. Het eerste getal dat
'      ingevoerd dient te worden is het getal a dat aangeeft hoeveel vast-
'      staande plaatsen er zijn. Dan volgt er a keer een regel met het
'      volgende:
'      x-coordinaat, y-coordinaat, eventnummer.
'      Oftewel: Aan een bepaalde positie wordt een bepaald eventnummer ge-
'      koppeld.
' IV:  Dit is het laatste deel van het .EVT bestand. In dit deel staat aange-
'      geven hoe een bepaalde positie of LivOb met een bepaald PGP-nummer je
'      aan een event koppelt. De eventnummers  [0,256] zijn bedoelt voor
'      de vaststaande events. De eventnummers  [257,-> > zijn bedoelt voor
'      de LivOb's.
'      De eventnummers kunnen uit meerdere events zijn opgebouwd. Het ziet er
'      altijd in deze vorm uit:
'      [eventnummer
'      {voorwaarderegel                   
'      eventcode                          
'      eventcode                           Dit kan vaak worden herhaald.
'      ...                                
'      }event afsluitregel                
'      ]eventnummer afsluitregel
'
'      Ik zal hier nu wat dieper op ingaan:
'
'    * Eventnummer: Als het om een vaststaand event gaat, zal dit nummer
'      overeenkomen met het nummer uit III. Als de hero echter met een LivOb
'      in aanraking komt zal het eventnummer overeenkomen met
'      256 + LivObnummer.
'    * voorwaarderegel: Deze regel bevat de voorwaarde waaraan voldaan moet
'      worden om het event plaats te laten vinden. Er moet voldaan worden aan:
'      - Het aantal PGP's moeten kloppen.
'      - De hero moet evt. in een bepaalde richting staan.
'      - Er moet misschien een aktietoets ingedrukt zijn.
'      De voorwaarderegel ziet er nu als volgt uit:
'      {aaabbbcd
'      aaa, bbb, c en d zijn getallen.
'      - PGP(aaa) moet bbb zijn.
'      - De richting van de hero moet c zijn. Als c=4 dan maakt de richting
'        niet uit.
'      - als d=1 dan moet er een aktietoets zijn ingedrukt, als d=0 dan maakt
'        het niet uit.
'      Als aan al deze voorwaarden voldaan is dan gaat de engine over op het
'      het uitvoeren van de eventcode. Deze wordt in hoofdstuk 4 besproken. De
'      eventcode wordt afgesloten met een }.
'      Als aan al deze voorwaarden niet voldaan is dan gaat hij binnen dit
'      eventnummer op zoek naar een nieuwe voorwaarderegel en probeert deze.
'      Dit herhaalt zich net zo lang tot alle voorwaarden kloppen of totdat hij
'      een ] tegenkomt. Dit betekent nl. dat dit eventnummer is afgelopen.
'
'

END SUB

SUB Event.Add (Temp$)

 SELECT CASE MID$(Temp$, 4, 3)
  CASE "pgp": IF VAL(MID$(Temp$, 7, 3)) <> 0 THEN Progresspoint(VAL(MID$(Temp$, 7, 3))) = Progresspoint(VAL(MID$(Temp$, 7, 3))) + VAL(MID$(Temp$, 10, 3))
  CASE "gld": Creature(0).geld = Creature(0).geld + VAL(MID$(Temp$, 7, LEN(Temp$) - 6)): Stats.Update
  CASE "itm"
              IF Item(Aantal.Items) = 0 THEN
                Item(Aantal.Items) = VAL(MID$(Temp$, 7, LEN(Temp$) - 6))
                CALL Items.LineUp
                 LINE (98, 94)-(155, 104), 2, BF
                 LINE (98, 94)-(155, 104), 1, B
                 FLocate 100, 100: FPrint "Item ontvangen."
                  'Wacht (1200)
                   DO UNTIL INKEY$ = "": LOOP
                   T = TIMER: DO UNTIL TIMER - T > 1.4 OR INKEY$ <> "": LOOP
                 World.Put
              ELSE
                 LINE (70, 94)-(178, 104), 2, BF
                 LINE (70, 94)-(178, 104), 1, B
                 FLocate 72, 100: FPrint "Je kunt niets extra's dragen."
                  Wacht (1200)
                   DO UNTIL INKEY$ = "": LOOP
                 World.Put
                ' Evt. een box waarin je kan beslissen welk item je wilt vervangen.
              END IF
 END SELECT

END SUB

SUB Event.Call (Temp$)

 SELECT CASE MID$(Temp$, 4, 3)
   CASE "fgt"
    CreatureNummer = VAL(MID$(Temp$, 7, 3))
    Monster.WpnMin = VAL(MID$(Temp$, 10, 3))
    Monster.WpnMax = VAL(MID$(Temp$, 13, 3))
    Monster.Str = VAL(MID$(Temp$, 16, 3))
    Monster.AmrMin = VAL(MID$(Temp$, 19, 3))
    Monster.AmrMax = VAL(MID$(Temp$, 22, 3))
    Monster.Def = VAL(MID$(Temp$, 25, 3))
    CALL Fight(CreatureNummer)
 END SELECT

END SUB

SUB Event.Load (EventFile$)

 OPEN EventFile$ FOR INPUT AS #1

 FOR i = 0 TO 15
  INPUT #1, File$
  DEF SEG = VARSEG(PCreature(0, 0, 0, 0, i))
  BLOAD "DATA\Player" + File$ + ".chr", VARPTR(PCreature(0, 0, 0, 0, i))
 NEXT i

 'Creature(0).graph = 0  ************************ Kan deze niet weg?

  INPUT #1, LivOb.Aantal
 
  FOR i = 1 TO LivOb.Aantal
   INPUT #1, Creature(i).x
   INPUT #1, Creature(i).y
   INPUT #1, Creature(i).graph
   INPUT #1, Creature(i).speed
   INPUT #1, Creature(i).MaxHp: Creature(i).Hp = Creature(i).MaxHp
  NEXT i

 INPUT #1, Aantal.events
 Teller = 0

  DO
   Teller = Teller + 1
   INPUT #1, Event.x(Teller)
   INPUT #1, Event.y(Teller)
   INPUT #1, Event.nummer(Teller)
  LOOP UNTIL Aantal.events = Teller

 CLOSE #1

END SUB

SUB Event.Move (Temp$)
 
 SELECT CASE MID$(Temp$, 4, 3)
  CASE "wlk"
        FOR i = 13 TO LEN(Temp$)
         CALL Walk(VAL(MID$(Temp$, i, 1)), VAL(MID$(Temp$, 7, 3)))
         Wacht (VAL(MID$(Temp$, 10, 3)))
        NEXT i
  CASE "trn"
        FOR i = 13 TO LEN(Temp$)
         Getal1 = VAL(MID$(Temp$, i, 1))
         Getal2 = VAL(MID$(Temp$, 7, 3))
         IF Getal1 <= 3 THEN Creature(Getal2).dir = Getal1
         IF Getal1 = 4 THEN Creature(Getal2).dir = (Creature(Getal2).dir - 1) MOD 4
         IF Getal1 = 5 THEN Creature(Getal2).dir = (Creature(Getal2).dir + 1) MOD 4
         IF Getal1 >= 6 THEN Creature(Getal2).dir = (Creature(0).dir + Getal1 - 6) MOD 4
         World.PutPart Creature(Getal2).x, Creature(Getal2).y - 1, Creature(Getal2).x, Creature(Getal2).y
         Wacht (VAL(MID$(Temp$, 10, 3)))
         NEXT i
  CASE "tr2"
        Getal1 = VAL(MID$(Temp$, 7, 3))
        Getal2 = VAL(MID$(Temp$, 10, 3))
        Getal3 = Creature(Getal1).x - Creature(Getal2).x
        Getal4 = Creature(Getal1).y - Creature(Getal2).y
        IF Getal3 >= Getal4 AND Getal3 >= -Getal4 THEN Creature(Getal1).dir = 0
        IF -Getal3 >= Getal4 AND -Getal3 >= -Getal4 THEN Creature(Getal1).dir = 2
        IF Getal4 >= Getal3 AND Getal4 >= -Getal3 THEN Creature(Getal1).dir = 1
        IF -Getal4 >= Getal3 AND -Getal4 >= -Getal3 THEN Creature(Getal1).dir = 3
        World.PutPart Creature(Getal1).x, Creature(Getal1).y - 1, Creature(Getal1).x, Creature(Getal1).y
  CASE "tlp"
        EventFile$ = "data\" + MID$(Temp$, 16, 8)
        CALL Area.Load(EventFile$, VAL(MID$(Temp$, 10, 3)), VAL(MID$(Temp$, 13, 3)), Creature(0).dir)
  CASE "scr"
        Schuif.x = VAL(MID$(Temp$, 7, 3))
        Schuif.y = VAL(MID$(Temp$, 10, 3))
        IF Schuif.x < 0 THEN Schuif.x = 0
        IF Schuif.y < 0 THEN Schuif.y = 0
        IF Schuif.x > CellsX - AR.Xcll THEN Schuif.x = CellsX - AR.Xcll
        IF Schuif.y > CellsY - AR.Ycll THEN Schuif.y = CellsY - AR.Ycll
        CALL World.Put
 END SELECT
END SUB

SUB Event.Show (Temp$)

 SELECT CASE MID$(Temp$, 4, 3)
  CASE "fil": CALL Talk(EventFile$ + ".CNV", VAL(MID$(Temp$, 9, LEN(Temp$) - 8)))
 END SELECT

END SUB

SUB Event.Start (Event.nummer)

  OPEN EventFile$ + ".evt" FOR INPUT AS #2
  DO UNTIL (EOF(2) OR Finished = 1)
   INPUT #2, Temp$
   
    IF LEFT$(Temp$, 1) = "[" THEN
     IF VAL(RIGHT$(Temp$, LEN(Temp$) - 1)) = Event.nummer THEN
      DO UNTIL (EOF(2) OR Finished = 1)
       INPUT #2, Temp$
      
       IF Temp$ = "]" THEN Finished = 1: EXIT DO
      
       IF LEFT$(Temp$, 1) = "{" THEN
        IF Progresspoint(VAL(MID$(Temp$, 2, 3))) = VAL(MID$(Temp$, 5, 3)) AND ((VAL(MID$(Temp$, 8, 1)) = 4 OR VAL(MID$(Temp$, 8, 1)) = Creature(0).dir) OR (VAL(MID$(Temp$, 8, 1)) = 5 AND Look = 1)) AND (((VAL(MID$(Temp$, 9, 1))) = 0 OR Actietoets =  _
1)) THEN
         
          DO
           INPUT #2, Temp$
           IF Temp$ = "}" THEN EXIT DO
          
            SELECT CASE MID$(Temp$, 1, 3)
             CASE "sho": CALL Event.Show(Temp$)
             CASE "add": CALL Event.Add(Temp$)
             CASE "mov": CALL Event.Move(Temp$)
             CASE "cal": CALL Event.Call(Temp$)
             CASE "wai": CALL Wacht(VAL(MID$(Temp$, 4, 4)))
             CASE "END": CALL QuitProg
            END SELECT
          LOOP
          
          Finished = 1

        END IF
       END IF
      LOOP
     END IF
    END IF
  LOOP
 CLOSE #2

 Finished = 0

 DO UNTIL INKEY$ = "": LOOP
 World.Put

END SUB

SUB FColor (Clr%)

IF Clr% < 0 OR Clr% > 255 THEN ProgramError 2
FClr = "C" + MID$(STR$(Clr%), 2, 3)

END SUB

SUB Fight (CreatureNummer)

 CALL Fight.Update(CreatureNummer)

 DO UNTIL Toets$ = CHR$(27)
' Spelers beurt
  DO UNTIL Toets$ = "1" OR Toets$ = "2" OR Toets$ = "3"
   Toets$ = INPUT$(1)
   SELECT CASE Toets$
    CASE "1"
      Creature(CreatureNummer).Hp = INT(Creature(CreatureNummer).Hp - ((Hero.WpnMax - Hero.WpnMin) * RND + Hero.WpnMin) ^ 2 / (INT((Monster.AmrMax - Monster.AmrMin) * RND + Monster.AmrMin) + 1) * (Hero.Str / Monster.Def - 1) + 1)
      IF Creature(CreatureNummer).Hp <= 0 THEN CALL Fight.End(0, CreatureNummer)
       CALL Fight.Update(CreatureNummer)
    CASE "3"
      LINE (23, 168)-(216, 168), 1             ' Onderste lijn speelveld
      LINE (23, 169)-(216, 185), 0, BF         ' Onder het speelveld
      World.Put
      Tijd = TIMER + 1
      EXIT SUB
   END SELECT
  LOOP

' Monsters beurt
  Toets$ = INPUT$(1)
   Creature(0).Hp = INT(Creature(0).Hp - ((Monster.WpnMax - Monster.WpnMin) * RND + Monster.WpnMin) ^ 2 / (INT((Hero.AmrMax - Hero.AmrMin) * RND + Hero.AmrMin) + 1) * (Monster.Str / Hero.Def - 1) + 1)
   IF Creature(0).Hp <= 0 THEN CALL Fight.End(1, CreatureNummer)
     CALL Fight.Update(CreatureNummer)
  Toets$ = ""
 LOOP

END SUB

SUB Fight.End (A, CreatureNummer)

 SELECT CASE A
  CASE 0
        Creature(CreatureNummer).Hp = 0
        CALL Fight.Update(CreatureNummer)
        LOCATE 15, 30: PRINT "You killed it."
        END
  CASE 1
        Creature(0).Hp = 0
        CALL Fight.Update(CreatureNummer)
        LOCATE 15, 30: PRINT "You died."
        END
 END SELECT

END SUB

SUB Fight.Update (CreatureNummer)

 Stats.Update                           ' Gegevens van de held die aan de
                                        ' rechter kant staan worden geupdate.

 LINE (37, 148)-(74, 184), 2, BF        ' Gezicht vakje
 LINE (36, 147)-(75, 185), 1, B
 LINE (85, 148)-(202, 184), 2, BF       ' Tekst vak
 LINE (84, 147)-(203, 185), 1, B
 LINE (84, 177)-(203, 177), 1

 FColor 5
 FLocate 86, 153: CALL FPrint("MONSTER")
 FColor 4
 FLocate 86, 161: CALL FPrint("HP")
 FLocate 86, 167: CALL FPrint("STR")
 FLocate 86, 173: CALL FPrint("DEF")

 FLocate 100, 161: CALL FPrint(STR$(Creature(CreatureNummer).Hp) + "/" + STR$(Creature(CreatureNummer).MaxHp))
 FLocate 100, 167: CALL FPrint(STR$(Monster.WpnMin) + "-" + STR$(Monster.WpnMax) + "+" + STR$(Monster.Str))
 FLocate 100, 173: CALL FPrint(STR$(Monster.AmrMin) + "-" + STR$(Monster.AmrMax) + "+" + STR$(Monster.Def))
 
 FLocate 87, 183: CALL FPrint("(1) ATTACK (2) ITEM (3) ESCAPE")

END SUB

SUB FInit

' Lettertype inladen...
OPEN "DATA\STANDARD.LTT" FOR INPUT AS #1    ' Lettertype inladen
DO UNTIL EOF(1)
  LINE INPUT #1, DrawRegel$
  IF LEN(DrawRegel$) > 2 THEN
    Char% = ASC(LEFT$(DrawRegel$, 1))
    Letter(Char%) = RIGHT$(DrawRegel$, LEN(DrawRegel$) - 4)
    Lengte(Char%) = CHR$(VAL(RIGHT$(LEFT$(DrawRegel$, 4), 2)))
  END IF
LOOP
CLOSE #1

FSize 1                                       ' Beginwaarden instellen
FColor 7
FRotate 0
FWindow 0, 0, 319, 199
FLocate 1, 5

END SUB

FUNCTION FLenght% (zin$)
DIM LTeken AS STRING * 1

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)

FOR TekenNummer% = 1 TO LEN(zin$)
  LTeken = MID$(zin$, TekenNummer%, 1)
  Lenght% = Lenght% + ASC(Lengte(ASC(LTeken))) * TekenBg%
NEXT TekenNummer%

FLenght% = Lenght%

END FUNCTION

SUB FLocate (x%, y%)

Lib.Xco% = x%
Lib.Yco% = y%

END SUB

SUB FPrint (zin$)
DIM Teken AS STRING * 1

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)
Lib.Yc% = Lib.Yco% - 4 * TekenBg%
PSET (Lib.Xco%, Lib.Yc%), POINT(Lib.Xco%, Lib.Yc%)
DRAW FClr + FSze + FAngle                ' Juiste lettertype instellen

FOR TekenNummer% = 1 TO LEN(zin$)
  Teken = MID$(zin$, TekenNummer%, 1)    ' Teken uit de string halen
  DRAW Letter(ASC(Teken))                ' Teken op het scherm zetten

  Lib.Xco% = Lib.Xco% + ASC(Lengte(ASC(Teken))) * TekenBg%     ' Nieuwe positie op scherm berekenen
NEXT TekenNummer%

END SUB

SUB FRotate (Degrees%)

IF Degrees% < -360 OR Degrees% > 360 THEN ProgramError 3
FAngle = "TA" + MID$(STR$(Degrees%), 1, 3)
IF MID$(FAngle, 1, 1) = " " THEN FAngle = MID$(FAngle, 2, 3)
 
END SUB

SUB FSize (Size%)

IF Size% < 1 THEN ProgramError 1
FSze = "S" + MID$(STR$(Size% * 4), 2, 3)

END SUB

SUB FWindow (Xmin%, Ymin%, Xmax%, Ymax%)
END SUB

SUB FWrite (zin$, x%, y%, Clr%)
DIM Teken AS STRING * 1

IF Clr% < 0 OR Clr% > 255 THEN ProgramError 2
FClr = "C" + MID$(STR$(Clr%), 2, 3)
Lib.Xco% = x%
Lib.Yco% = y%

TekenBg% = (VAL(MID$(FSze, 2, 3)) / 4)
Lib.Yc% = Lib.Yco% - 4 * TekenBg%
PSET (Lib.Xco%, Lib.Yc%), POINT(Lib.Xco%, Lib.Yc%)
DRAW FClr + FSze + FAngle                ' Juiste lettertype instellen

FOR TekenNummer% = 1 TO LEN(zin$)
  Teken = MID$(zin$, TekenNummer%, 1)    ' Teken uit de string halen
  DRAW Letter(ASC(Teken))                ' Teken op het scherm zetten

  Lib.Xco% = Lib.Xco% + ASC(Lengte(ASC(Teken))) * TekenBg%     ' Nieuwe positie op scherm berekenen
NEXT TekenNummer%

END SUB

SUB Items.LineUp
 ' Deze routine sorteert de Items en zet '0-en' aan het eind. (0 = geen item)

 FOR j = 1 TO Aantal.Items
  FOR i = 1 TO Aantal.Items - 1
   IF Item(i) > Item(i + 1) AND Item(i + 1) <> 0 THEN SWAP Item(i), Item(i + 1)
   IF Item(i) = 0 THEN SWAP Item(i), Item(i + 1)
  NEXT i
 NEXT j

END SUB

SUB LivOb.Update
 
  FOR i = 1 TO LivOb.Aantal
  
   IF LivOb.Count MOD Creature(i).speed = 0 THEN
    SELECT CASE INT(4 * RND)
     CASE 0: CALL Walk(0, i)
     CASE 1: CALL Walk(1, i)
     CASE 2: CALL Walk(2, i)
     CASE 3: CALL Walk(3, i)
    END SELECT
   END IF

  NEXT i
  
END SUB

SUB Palet.Load

DEF SEG = VARSEG(MClr(0, 0))       ' Vanuit bestand direct naar geheugen
BLOAD "DATA\STANDARD.PAL", VARPTR(MClr(0, 0))
Palet.Update

END SUB

SUB Palet.Update

FOR x = 0 TO 255'135
  OUT &H3C8, x
  OUT &H3C9, ASC(MClr(x, 0))
  OUT &H3C9, ASC(MClr(x, 1))
  OUT &H3C9, ASC(MClr(x, 2))
NEXT x

END SUB

SUB Prepair

 SCREEN 13                           ' 320x200 met 256 kleuren

 SHELL "keyrate.exe 1 15 >nul"

 FInit                               ' Lettertype initialiseren
 Buildscreen                         ' Hoofd-layout van scherm neerzetten
 RANDOMIZE TIMER                     ' Altijd anders

END SUB

SUB ProgramError (ErrorCode%)
SCREEN 0: WIDTH 80: CLS : COLOR 8
PRINT "Something has gone terribly wrong!": PRINT : COLOR 7

SELECT CASE ErrorCode%

  CASE 0:    PRINT "Runtime errorcode:"; ERR
             IF ERL <> 0 THEN PRINT "In line:"; ERL
             SELECT CASE ERR
              CASE 5:  PRINT "Illegal funcion call, possibly wrong screen mode"
              CASE 6:  PRINT "Overloop"
              CASE 7:  PRINT "Insufficient memory"
              CASE 52: PRINT "Incorrect filename/number"
              CASE 53: PRINT "File not found"
              CASE 61: PRINT "Disk is full"
              CASE 64: PRINT "Incorrect filename"
             END SELECT

  CASE 1:    PRINT "Error in sub FSize:"
             PRINT "Size% cannot be less then 1"

  CASE 2:    PRINT "Error in sub FColor or FWrite:"
             PRINT "Clr% cannot be negative or above 255"

  CASE 3:    PRINT "Error in sub FRotate:"
             PRINT "Degrees% must be in [-360,360]"

END SELECT

SHELL "keyrate.exe 1 20 >nul"
SYSTEM
END SUB

SUB QuitProg

SCREEN 0: WIDTH 80, 25
COLOR 7
PRINT "Thank you for playing Anestor the miniRPG."

SHELL "keyrate.exe 1 20 >nul"
SYSTEM

END SUB

SUB Stats.Show

'  HP AS INTEGER: MaxHP AS INTEGER: AC AS INTEGER
'  Ep AS INTEGER: Lvl AS INTEGER
'  Str AS INTEGER                    ' +Strength = meer schade
'  Vit AS INTEGER                    ' +Vitality = meer HP
'  Acc AS INTEGER                    ' +Accuracy = kans op raken groter
'  Agi AS INTEGER                    ' +Agility  = kans op ontwijken groter
'  Spd AS INTEGER                    '  Speed    = Loopsnelheid in turn based
'
'  Geld AS INTEGER

LINE (AR.Xmin, AR.Ymin)-(AR.Xmax, AR.Ymax), 2, BF
FColor 1
FLocate AR.Xmin + 10, AR.Ymin + 10: FPrint "VERDERE GEGEVENS"
FColor 4: r% = 6
FLocate AR.Xmin + 10, AR.Ymin + 9: FPrint "VERDERE GEGEVENS"
FLocate AR.Xmin + 10, AR.Ymin + 19 + 1 * r%: FPrint "STRENGTH:"
FLocate AR.Xmin + 50, AR.Ymin + 19 + 1 * r%: FPrint STR$(Hero.Str)
FLocate AR.Xmin + 10, AR.Ymin + 19 + 2 * r%: FPrint "VITALITY:"
FLocate AR.Xmin + 50, AR.Ymin + 19 + 2 * r%: FPrint STR$(Hero.Vit)
FLocate AR.Xmin + 10, AR.Ymin + 19 + 3 * r%: FPrint "ACCURACY:"
FLocate AR.Xmin + 50, AR.Ymin + 19 + 3 * r%: FPrint STR$(Hero.Acc)
FLocate AR.Xmin + 10, AR.Ymin + 19 + 4 * r%: FPrint "AGILITY:"
FLocate AR.Xmin + 50, AR.Ymin + 19 + 4 * r%: FPrint STR$(Hero.Agi)
FLocate AR.Xmin + 10, AR.Ymin + 19 + 5 * r%: FPrint "SPEED:"
FLocate AR.Xmin + 50, AR.Ymin + 19 + 5 * r%: FPrint STR$(Hero.Spd)

FLocate AR.Xmin + 100, AR.Ymin + 19 + 1 * r%: FPrint "LEVEL:"
FLocate AR.Xmin + 150, AR.Ymin + 19 + 1 * r%: FPrint STR$(Hero.Lvl)
FLocate AR.Xmin + 100, AR.Ymin + 19 + 2 * r%: FPrint "EXPERIENCE:"
FLocate AR.Xmin + 150, AR.Ymin + 19 + 2 * r%: FPrint STR$(Hero.Ep)
FLocate AR.Xmin + 100, AR.Ymin + 19 + 3 * r%: FPrint "HEALTH:"
FLocate AR.Xmin + 150, AR.Ymin + 19 + 3 * r%: FPrint STR$(Creature(0).Hp) + ";" + STR$(Creature(0).MaxHp)

DO: LOOP WHILE INKEY$ = ""
World.Put

END SUB

SUB Stats.Update
EXIT SUB                 ' Geen statistics

DIM Xmin AS INTEGER, Ymin AS INTEGER
DIM Plus AS INTEGER

Xmin = 226: Ymin = 40: Plus = FLenght("DEFENCE")

FColor 4
FLocate Xmin, Ymin + 5: FPrint "HEALTH"
FLocate Xmin, Ymin + 12: FPrint "ATTACK"
FLocate Xmin, Ymin + 19: FPrint "DEFENCE"
FLocate Xmin, Ymin + 28: FPrint "GOLD"

x = FLenght(MID$(STR$(Creature(0).Hp), 2, 3) + "/" + MID$(STR$(Creature(0).MaxHp), 2, 4))
LINE (Xmin + Plus, Ymin)-(296, Ymin + 5), 2, BF
FLocate 296 - x, Ymin + 5
FColor 4: FPrint MID$(STR$(Creature(0).Hp), 2, 3) + "/" + MID$(STR$(Creature(0).MaxHp), 2, 4)

x = FLenght(MID$(STR$(Hero.WpnMin), 2, 3) + "-" + MID$(STR$(Hero.WpnMax), 2, 3) + " +" + MID$(STR$(Hero.Str), 2, 3))
LINE (Xmin + Plus, Ymin + 7)-(296, Ymin + 12), 2, BF
FLocate 296 - x, Ymin + 12
FColor 4: FPrint MID$(STR$(Hero.WpnMin), 2, 3) + "-" + MID$(STR$(Hero.WpnMax), 2, 3)
FColor 7: FPrint " +" + MID$(STR$(Hero.Str), 2, 3)

x = FLenght(MID$(STR$(Hero.AmrMin), 2, 3) + "-" + MID$(STR$(Hero.AmrMax), 2, 3) + " +" + MID$(STR$(Hero.Def), 2, 3))
LINE (Xmin + Plus, Ymin + 14)-(296, Ymin + 19), 2, BF
FLocate 296 - x, Ymin + 19
FColor 4: FPrint MID$(STR$(Hero.AmrMin), 2, 3) + "-" + MID$(STR$(Hero.AmrMax), 2, 3)
FColor 7: FPrint " +" + MID$(STR$(Hero.Def), 2, 3)

x = FLenght(MID$(STR$(Creature(0).geld), 2, 5))
LINE (Xmin + Plus, Ymin + 23)-(296, Ymin + 28), 2, BF
FLocate 296 - x, Ymin + 28
FColor 4: FPrint MID$(STR$(Creature(0).geld), 2, 5)

END SUB

SUB Talk (File$, GespreksNummer)
DIM TTeken AS STRING * 1
DIM Vak(1015)

LINE (37, 148)-(74, 184), 2, BF        ' Gezicht vakje
LINE (36, 147)-(75, 185), 1, B
LINE (85, 148)-(202, 184), 2, BF       ' Tekst vak
LINE (84, 147)-(203, 185), 1, B

OPEN File$ FOR INPUT AS #1
DO UNTIL EOF(1)
  INPUT #1, Line$
  IF LEFT$(Line$, 1) = "{" THEN
    IF VAL(RIGHT$(Line$, LEN(Line$) - 1)) = GespreksNummer THEN EXIT DO
  END IF
LOOP

FSize 1: FLocate 86, 153
DO
  INPUT #1, Line$
  IF Line$ = "}" THEN EXIT DO

  Person$ = UCASE$(Line$)            ' Naam inlezen
  INPUT #1, Kleur%                   ' Kleur inlezen
  INPUT #1, Words$: Words$ = UCASE$(Words$)   ' Tekst inlezen

  LINE (37, 148)-(74, 184), 2, BF    ' Gezicht vakje leegmaken
  Tx% = Lib.Xco%: Ty% = Lib.Yco%
  FColor 4: FLocate 38, 153
  FPrint Person$                     ' Naam op het scherm zetten
  FLocate Tx%, Ty%: FColor Kleur%

  FOR C% = 1 TO LEN(Words$)
    IF p$ = "" THEN p$ = INKEY$
    IF p$ = CHR$(0) + CHR$(75) OR p$ = CHR$(0) + CHR$(72) OR p$ = CHR$(0) + CHR$(77) OR p$ = CHR$(0) + CHR$(80) THEN p$ = ""

    TTeken = MID$(Words$, C%, 1)

    IF TTeken <> " " THEN
      q% = INSTR(C%, Words$, " ")            ' Knippen tot de volgende spatie
      IF q% = 0 THEN q% = LEN(Words$) + 1
      IF FLenght(MID$(Words$, C%, q% - C%)) + Lib.Xco% > 203 THEN Lib.Xco% = 86: Lib.Yco% = Lib.Yco% + 6
     
      IF Lib.Yco% = 189 THEN                 ' Scrollen als het moet
        FOR Scroll% = 1 TO 6
          GET (86, 150)-(201, 184), Vak
          IF p$ = "" THEN p$ = INKEY$
          IF p$ = CHR$(0) + CHR$(75) OR p$ = CHR$(0) + CHR$(72) OR p$ = CHR$(0) + CHR$(77) OR p$ = CHR$(0) + CHR$(80) THEN p$ = ""
          IF p$ = "" THEN Wacht 10
          PUT (86, 149), Vak, PSET
        NEXT Scroll%
        Lib.Yco% = Lib.Yco% - 6
      END IF
    END IF
    FPrint TTeken
    IF p$ = "" THEN Wacht 10
  NEXT C%
  Lib.Xco% = 86
  Lib.Yco% = Lib.Yco% + 6
  DO: LOOP UNTIL INKEY$ = ""
  DO: LOOP WHILE INKEY$ = ""
  p$ = ""
LOOP
CLOSE #1

LINE (23, 168)-(216, 168), 1             ' Onderste lijn speelveld
LINE (23, 169)-(216, 185), 0, BF         ' Onder het speelveld
World.Put

END SUB

SUB Wacht (ms%)
DIM TijdEerst AS SINGLE

TijdEerst = TIMER
DO
LOOP UNTIL (TIMER - TijdEerst) > (ms% / 1000)

END SUB

SUB Walk (D%, E)
 
 OudX% = Creature(E).x: OudY% = Creature(E).y: OudD% = Creature(E).dir  ' Oude informatie
 Schoof.x% = Schuif.x: Schoof.y% = Schuif.y
  
 Failure = 0
 SELECT CASE D%
   CASE 0
     FOR i = 0 TO LivOb.Aantal
       IF i <> E AND Creature(E).x - 1 = Creature(i).x AND Creature(E).y = Creature(i).y THEN Failure = 1
     NEXT i
     IF Failure = 0 AND Creature(E).x > 0 THEN IF ASC(MCell(0, Creature(E).x - 1, Creature(E).y)) < 64 THEN Creature(E).x = Creature(E).x - 1: Creature(E).dir = D% ' Lohrol
   CASE 1
     FOR i = 0 TO LivOb.Aantal
       IF i <> E AND Creature(E).x = Creature(i).x AND Creature(E).y - 1 = Creature(i).y THEN Failure = 1
     NEXT i
     IF Failure = 0 AND Creature(E).y > 1 THEN IF ASC(MCell(0, Creature(E).x, Creature(E).y - 1)) < 64 THEN Creature(E).y = Creature(E).y - 1: Creature(E).dir = D%
   CASE 2
     FOR i = 0 TO LivOb.Aantal
       IF i <> E AND Creature(E).x + 1 = Creature(i).x AND Creature(E).y = Creature(i).y THEN Failure = 1
     NEXT i
     IF Failure = 0 AND Creature(E).x < CellsX - 1 THEN IF ASC(MCell(0, Creature(E).x + 1, Creature(E).y)) < 64 THEN Creature(E).x = Creature(E).x + 1: Creature(E).dir = D%
   CASE 3
     FOR i = 0 TO LivOb.Aantal
       IF i <> E AND Creature(E).x = Creature(i).x AND Creature(E).y + 1 = Creature(i).y THEN Failure = 1
     NEXT i
     IF Failure = 0 AND Creature(E).y < CellsY - 1 THEN IF ASC(MCell(0, Creature(E).x, Creature(E).y + 1)) < 64 THEN Creature(E).y = Creature(E).y + 1: Creature(E).dir = D%
 END SELECT

 Creature(E).dir = D%

 IF E = 0 THEN                    ' Verschuiving telt alleen voor Creature(0)
   IF Creature(E).x - Schuif.x > AR.Xcll - 8 THEN Schuif.x = Creature(E).x - AR.Xcll + 8
   IF Creature(E).y - Schuif.y > AR.Ycll - 7 THEN Schuif.y = Creature(E).y - AR.Ycll + 7
   IF Creature(E).x - Schuif.x < 7 THEN Schuif.x = Creature(E).x - 7
   IF Creature(E).y - Schuif.y < 7 THEN Schuif.y = Creature(E).y - 7
   IF Schuif.x < 0 THEN Schuif.x = 0
   IF Schuif.y < 0 THEN Schuif.y = 0
   IF Schuif.x > CellsX - AR.Xcll THEN Schuif.x = CellsX - AR.Xcll
   IF Schuif.y > CellsY - AR.Ycll THEN Schuif.y = CellsY - AR.Ycll
 END IF

 IF Schoof.x% <> Schuif.x OR Schoof.y% <> Schuif.y THEN
   World.Put
 ELSEIF OudX% <> Creature(E).x OR OudY% <> Creature(E).y OR OudD% <> Creature(E).dir THEN
   SELECT CASE D%
     CASE 0: World.PutPart Creature(E).x, Creature(E).y - 1, Creature(E).x + 1, Creature(E).y
     CASE 1: World.PutPart Creature(E).x, Creature(E).y - 1, Creature(E).x, Creature(E).y + 1
     CASE 2: World.PutPart Creature(E).x - 1, Creature(E).y - 1, Creature(E).x, Creature(E).y
     CASE 3: World.PutPart Creature(E).x, Creature(E).y - 2, Creature(E).x, Creature(E).y
   END SELECT
 END IF

 IF E > 0 AND (OudX% <> Creature(E).x OR OudY% <> Creature(E).y) THEN
   FOR i = 1 TO LivOb.Aantal
     IF Creature(0).x - 1 = Creature(i).x AND Creature(0).y = Creature(i).y THEN CALL Event.Start(256 + i)
     IF Creature(0).x + 1 = Creature(i).x AND Creature(0).y = Creature(i).y THEN CALL Event.Start(256 + i)
     IF Creature(0).x = Creature(i).x AND Creature(0).y - 1 = Creature(i).y THEN CALL Event.Start(256 + i)
     IF Creature(0).x = Creature(i).x AND Creature(0).y + 1 = Creature(i).y THEN CALL Event.Start(256 + i)
   NEXT i
 END IF

END SUB

SUB World.Load (WorldFile$)

DEF SEG = VARSEG(MCell(0, 0, 0))               ' Wereld in geheugen laden
BLOAD WorldFile$, VARPTR(MCell(0, 0, 0))
  
InfoFile$ = LEFT$(WorldFile$, INSTR(WorldFile$, ".")) + "ARI"
OPEN InfoFile$ FOR INPUT AS #1
DO UNTIL EOF(1)
  INPUT #1, Regel$
  IF Regel$ = "CellsFile" THEN
    INPUT #1, CellsFile$
      CellsFile$ = "DATA\" + CellsFile$
      DEF SEG = VARSEG(Cell(0, 0, 0))          ' Cellen in geheugen laden
      BLOAD CellsFile$, VARPTR(Cell(0, 0, 0))
    EXIT DO
  END IF
LOOP
CLOSE #1

END SUB

SUB World.Put
                                        
World.PutPart Schuif.x, Schuif.y, Schuif.x + AR.Xcll, Schuif.y + AR.Ycll

END SUB

SUB World.PutPart (Xb%, Yb%, Xe%, Ye%)

' Waarden omdraaien als ze verkeerdom staan
IF Xb% > Xe% THEN SWAP Xb%, Xe%
IF Yb% > Ye% THEN SWAP Yb%, Ye%

' Vastleggen welke creatures te zien zijn
DIM Visable(LivOb.Aantal) AS INTEGER
FOR i = 1 TO LivOb.Aantal
  IF Creature(i).x >= Xb% AND Creature(i).y >= Yb% AND Creature(i).x <= Xe% AND Creature(i).y <= Ye% + 1 THEN Visable(T) = i: T = T + 1
NEXT i

' Area op het scherm plaatsen
FOR x = (Xb% - Schuif.x) TO (Xe% - Schuif.x)
  FOR y = (Yb% - Schuif.y) TO (Ye% - Schuif.y)
    IF x >= 0 AND y >= 0 AND x < AR.Xcll AND y < AR.Ycll THEN

    Layer0Cell% = ASC(MCell(0, x + Schuif.x, y + Schuif.y))
    Layer1Cell% = ASC(MCell(1, x + Schuif.x, y + Schuif.y))
  
    ' Kijk of er op de cell die getekend wordt ook een creature staat
    L.Onder% = -1: L.Boven% = -1
    FOR i = 0 TO T
      IF Creature(Visable(i)).x = x + Schuif.x THEN
        IF Creature(Visable(i)).y = y + Schuif.y THEN L.Onder% = Visable(i)
        IF Creature(Visable(i)).y - 1 = y + Schuif.y THEN L.Boven% = Visable(i)
      END IF
    NEXT i
  
    IF Layer1Cell% = 0 OR Layer1Cell% >= 208 THEN
      PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer0Cell%, 0), PSET
   
      IF L.Onder% > -1 THEN
        PUT (AR.Xmin + (Creature(L.Onder%).x - Schuif.x) * 8, AR.Ymin + 8 + ((Creature(L.Onder%).y - Schuif.y) - 1) * 8), PCreature(0, Creature(L.Onder%).dir, 1, 1, Creature(L.Onder%).graph), AND
        PUT (AR.Xmin + (Creature(L.Onder%).x - Schuif.x) * 8, AR.Ymin + 8 + ((Creature(L.Onder%).y - Schuif.y) - 1) * 8), PCreature(0, Creature(L.Onder%).dir, 1, 0, Creature(L.Onder%).graph), OR
      END IF
      IF L.Boven% > -1 THEN
        PUT (AR.Xmin + (Creature(L.Boven%).x - Schuif.x) * 8, AR.Ymin + ((Creature(L.Boven%).y - Schuif.y) - 1) * 8), PCreature(0, Creature(L.Boven%).dir, 0, 1, Creature(L.Boven%).graph), AND
        PUT (AR.Xmin + (Creature(L.Boven%).x - Schuif.x) * 8, AR.Ymin + ((Creature(L.Boven%).y - Schuif.y) - 1) * 8), PCreature(0, Creature(L.Boven%).dir, 0, 0, Creature(L.Boven%).graph), OR
      END IF
    END IF

    IF Layer1Cell% > 0 THEN
      IF Layer1Cell% >= 208 AND Layer1Cell% <= 223 THEN AndCell% = Layer1Cell% + 32
      IF Layer1Cell% >= 224 AND Layer1Cell% <= 239 THEN AndCell% = Layer1Cell% + 16
      IF AndCell% > 0 THEN
        PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, AndCell%, 0), AND
        PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%, 0), OR
      ELSE
        PUT (AR.Xmin + x * 8, AR.Ymin + y * 8), Cell(0, Layer1Cell%, 0), PSET
      END IF
      AndCell% = 0
    END IF

    END IF
  NEXT y
NEXT x

END SUB

